	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Advanced function window (Auto Pilot 1.0)
	 * 
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

public class AdvWindowD extends JFrame {
	private static final long serialVersionUID = 1L;

	public static boolean frameActive = false;
	private JLabel label1 = new JLabel( "     Dispense Mode" );  
	private JLabel label2 = new JLabel( "     Multi Plate Dispensing");  
	private JLabel label3 = new JLabel( " " );  
	private JLabel label3a = new JLabel( " " );  
	private JLabel label4 = new JLabel( " " );  
	private JLabel label5 = new JLabel( " " );  
	private JLabel label6 = new JLabel( "     Chill" );  
	private JLabel label7 = new JLabel( "     Shake" );  
	private JLabel label8 = new JLabel( "       " );  
	private JLabel label9 = new JLabel( "       " );  
	private JLabel label10 = new JLabel( " " );  
	private JLabel label11 = new JLabel( " " );  
	private JLabel label12 = new JLabel( " " );  
	private JLabel label13 = new JLabel( " " );  
	private JLabel label14 = new JLabel( " " );  

	private JPanel jContentPane = null;
	private JPanel advPanel = null;
	private JPanel okPanel = null;
	private javax.swing.JComboBox aspmode =  null ;
	private javax.swing.JComboBox mpasp =  null ;
	private JCheckBox vstart = new JCheckBox() ;
	private JCheckBox chill = new JCheckBox()  ;
	private JCheckBox shake = new JCheckBox()  ;

	private JButton okButton = null ;  

	private String asp = " ";
	private String mp = " ";

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				AdvWindowD thisClass = new AdvWindowD();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}
	/**
	 * This is the default constructor
	 */
	public AdvWindowD() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(350, 250);
		this.setContentPane(getJContentPane());
		this.setTitle("Dispense Options");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getAdvPanel(), BorderLayout.CENTER);
			jContentPane.add(getOKPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}
	private JPanel getAdvPanel() {
		if (advPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(7);
			gridLayout.setColumns(2);
			advPanel = new JPanel();
			advPanel.setLayout(gridLayout);
			advPanel.add(label1);
			advPanel.add(getAspMode());
			advPanel.add(label2);
			advPanel.add(getMPAsp());
			advPanel.add(label3);
			advPanel.add(label3a);
			advPanel.add(label4);
			advPanel.add(label5);
			advPanel.add(label6);
			advPanel.add(chill);
			advPanel.add(label7);
			advPanel.add(shake);

		 }
		return advPanel;
	}

	/**
	 * This method initializes source JCombobox
	 *  * @return javax.swing.JComboBox
	 */
	public javax.swing.JComboBox getAspMode() {

			if (aspmode == null) {
				aspmode = new JComboBox() ;
				aspmode.addItem( "Auto" ) ;
				aspmode.addItem( "Surface" ) ;
				aspmode.addItem( "Surface Walk Away" ) ;
				aspmode.addItem( "Bottom" ) ;
			}
			aspmode.setSelectedIndex(0) ;
			asp = (String) aspmode.getSelectedItem();
			aspmode.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					JComboBox cb = (JComboBox)e.getSource();
			         asp  = (String)cb.getSelectedItem();
				}
			});

			return aspmode;
	}

	/**
	 * This method initializes source JCombobox
	 *  * @return javax.swing.JComboBox
	 */
	public javax.swing.JComboBox getMPAsp() {

			if (mpasp == null) {
				mpasp = new JComboBox() ;
				mpasp.addItem( "1" ) ;
				mpasp.addItem( "2" ) ;
				mpasp.addItem( "3" ) ;
				mpasp.addItem( "4" ) ;
				mpasp.addItem( "5" ) ;
				mpasp.addItem( "6" ) ;
				mpasp.addItem( "7" ) ;
				mpasp.addItem( "8" ) ;
				mpasp.addItem( "9" ) ;
				mpasp.addItem( "10" ) ;
				mpasp.addItem( "11" ) ;
				mpasp.addItem( "12" ) ;
				mpasp.addItem( "Variable" ) ;
			}
			mpasp.setSelectedIndex(0) ;
			mp = (String) mpasp.getSelectedItem();
			mpasp.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					JComboBox cb = (JComboBox)e.getSource();
			         mp  = (String)cb.getSelectedItem();
				}
			});

			return mpasp;
	}

	private JPanel getOKPanel() {
		if (okPanel == null) {
			FlowLayout flow = new FlowLayout();
			okPanel = new JPanel();
			okPanel.setLayout(flow);
            okPanel.add(getOKButton());
		 }
		return okPanel;
	}

	private javax.swing.JButton getOKButton() {
		if (okButton == null) {
			okButton = new javax.swing.JButton();
			okButton.setSize(20, 20);
			okButton.setText("    OK     ");
			okButton.setHorizontalAlignment(SwingConstants.CENTER);
		    okButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					frameActive = false;
					closeWindow();
				}
			});
		}
		return okButton;
	}


	/**
	 * This method returns status of variable start box
	 *  * @return integer (1 or 0)
	 *  	 */

	public int getVStart() {

		if (vstart.isSelected()) 
		{
		 return 1;
		}
		else
		{
		 return 0;
		}
	}	

	/**
	 * This method returns status of chill box
	 *  * @return integer (1 or 0)
	 *  	 */
	
	public int getChill() {

		if (chill.isSelected()) 
		{
		 return 1;
		}
		else
		{
		 return 0;
		}
	}

	/**
	 * This method returns status of shake box
	 *  * @return integer (1 or 0)
	 *  	 */

	public int getShake() {

		if (shake.isSelected()) 
		{
		 return 1;
		}
		else
		{
		 return 0;
		}
	}	

	/**
	 * This method sets the SHAKE button
	 *  * @return void 
	 *  	 */

	public void setShake(boolean t) {
		shake.setSelected(t);
	}	

	/**
	 * This method sets the status of chill box
	 *  * @return integer (1 or 0)
	 *  	 */

	public void setChill(boolean c) {
		chill.setSelected(c);
	}	
	
	/**
	 * This method sets the status of variable start box
	 *  * @return void
	 *  	 *  	 */

	public void setVStart(boolean v) {
		vstart.setSelected(v);
	}	

	/**
	 * This method returns aspirate mode
	 *  * @return String
	 *  	 */

	public String getMode() {
		 return asp;
	}	

	/**
	 * This method sets the visability of chill box
	 *  *   
	 *  	 */

	public void showChillBox(boolean c) {
		chill.setVisible(c);
		label6.setVisible(c);
	}	

	/**
	 * This method sets the visability of chill box
	 *  *   
	 *  	 */

	public void showShakeBox(boolean c) {
		shake.setVisible(c);
		label7.setVisible(c);
	}	

	/**
	 * This method returns MPA value
	 *  * @return String
	 *  	 */

	public String getMPA() {
		 return mp;
	}	

	/**
	 * This method sets the status of MPA mode 
	 *  * @return void
	 *  	 *  	 */

	public void setMPA(int v) {
		mpasp.setSelectedIndex(v-1);
	}	
	/**
	 * This method sets the status of ASP mode 
	 *  * @return void
	 *  	 *  	 */

	public void setASPMode(String s) {
        if (s.equals("Auto"))
        {
    		aspmode.setSelectedIndex(0);
        }
        if (s.equals("Surface"))
        {
    		aspmode.setSelectedIndex(1);
        }
        if (s.equals("Surface Walk Away"))
        {
    		aspmode.setSelectedIndex(2);
        }
        if (s.equals("Bottom"))
        {
    		aspmode.setSelectedIndex(3);
        }
	}	

	private void closeWindow() {
        this.setVisible(false);
		
	}

}
