package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.print.PrinterException;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.text.DateFormatSymbols;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;


public class AuditTrail extends JFrame{
	private static final long serialVersionUID = 1L;
	private static FileReader input;
	
	private JPanel jContentPane = null;
	private JPanel advPanel = null;
	private JPanel okPanel = null;
	private JButton okButton = null ; 
	private JButton printButton = null ;
	JScrollPane scrollPane = null;
	
	private static String newline = System.getProperty("line.separator");
	private static String DateStamp;
	private static String TimeStamp;
	private static String DateTimeStamp;
	
	private static File file_AuditTrail = new File ("C:\\Program Files\\Telos\\AutoPilot\\System\\AT.dat");
	
	public static JTextArea textArea1 = new JTextArea( 100 , 50 );
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				AuditTrail thisClass = new AuditTrail();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	public AuditTrail(){
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(600, 550);
		this.setContentPane(getJContentPane());
		this.setTitle("AutoPilot AuditTrail");
	    this.setIconImage(Toolkit.getDefaultToolkit()
	    		   .getImage("C:/Program Files/TELOS/AutoPilot/Config/molecule.png"));
	}
	
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getAdvPanel(), BorderLayout.CENTER);
			jContentPane.add(getOKPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}
	
	private JPanel getOKPanel() {
		if (okPanel == null) {
			FlowLayout flow = new FlowLayout();
			okPanel = new JPanel();
			okPanel.setLayout(flow);
            okPanel.add(getOKButton());
            okPanel.add(getPrintButton());
		 }
		return okPanel;
	}

	private javax.swing.JButton getOKButton() {
		if (okButton == null) {
			okButton = new javax.swing.JButton();
			okButton.setSize(20, 20);
			okButton.setText("    OK     ");
			okButton.setHorizontalAlignment(SwingConstants.CENTER);
		    okButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					
					closeWindow();
				}
			});
		}
		return okButton;
	}
	
	private javax.swing.JButton getPrintButton() {
		if (printButton == null) {
			printButton = new javax.swing.JButton();
			printButton.setSize(20, 20);
			printButton.setText("    PRINT     ");
			printButton.setHorizontalAlignment(SwingConstants.CENTER);
		    printButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					
					try {
						textArea1.print();
					} catch (PrinterException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			});
		}
		return printButton;
	}
	
	
	private JPanel getAdvPanel() {
		if (advPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setColumns(1);
			advPanel = new JPanel();
			advPanel.setLayout(gridLayout);
			advPanel.add(getScrollPane());
			
		 }
		return advPanel;
	}
	public javax.swing.JScrollPane getScrollPane() {

		if (scrollPane == null) {
			scrollPane = new JScrollPane(textArea1) ;
			scrollPane.setSize(300, 300);
		}
		return scrollPane;
}
	
	public static void writeTo(String User, String component, String message) {
		java.util.Date date = new java.util.Date();
		Calendar cal = Calendar.getInstance(); 
		cal.setTime(date); 
		int day = cal.get(Calendar.DAY_OF_MONTH);
		int month = cal.get(Calendar.MONTH); 
		int year = cal.get(Calendar.YEAR);
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
		DateStamp = Integer.toString(day) + "-" + ((new DateFormatSymbols().getMonths()[month]).substring(0,3))  + "-" + Integer.toString(year);
		TimeStamp = sdf.format(date); 
		DateTimeStamp = DateStamp + "_" + TimeStamp + "  ";
		String S = "     ";
		
		try{
		BufferedWriter output = new BufferedWriter(new FileWriter(file_AuditTrail, true));
		
			output.write(DateTimeStamp +S+ User + newline);
			output.write(DateTimeStamp +S+ component + newline);
			output.write(DateTimeStamp +S+ message + newline);
			output.write(newline);
			output.write(newline);
			
			
			output.close();
		
	} catch (Exception e){
		JOptionPane.showMessageDialog(null, e);
	} finally {}

	}
	public void loadWindow(){
		String readline = "";
		AuditTrail.textArea1.setText("");
		
		int stringSize = TabWindow.security_auditTrailString.split(",").length;
		
		for (int i=1; i<stringSize; i++){//Starts at element 1 to skip the Validation state which is at 0
			
			for (int x=0; x<5; x++){  //Format of each field is DateTime;Author;Action;Version
				String s = "";
				
				if (x == 0){s = "DATE:	";}
				if (x == 1){s = "USER:	";}
				if (x == 2){s = "ACTION:	";}
				if (x == 3){s = "CHANGE:	";}
				if (x == 4){s = "VERSION:	";}
				AuditTrail.textArea1.append(s + TabWindow.security_auditTrailString.split(",")[i].split(";")[x] + "\n");
			}
			
			AuditTrail.textArea1.append("\n\n");
		}
		
		
	}
	
	/**
	 * This method closes the window 
	 *  * @return void
	 *  	 *  	 */

	private void closeWindow() {
        this.setVisible(false);
		
	}
	
	public void viewWindow(){
		loadWindow();
		AuditTrail.textArea1.setEditable(false);
		this.setVisible(true);
	}
}
