/**
 	 * AutoPilot - CherryPanel02
	 * Copyright 	- Telos Scientific - 
	 * Author 		- Jesse A. Campbell
	 * Description	- Move Plate  
	 * 
	 * Version update information
	 * 
	 * 02.08.14 RSC - Class created - Move Plate V02.  
	 * 02.14.14 RSC - platesAll change.				
	 * 11.23.14 RSC - Added tubes with additional pull downs.				
	 * 11.27.14 RSC - Revisions to tubes screen.				
	 * 				*/

package TelosV2Pkg;

import javax.swing.JPanel;

import java.awt.GridBagLayout;

import javax.swing.JLabel;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerListModel;
import javax.swing.SpinnerModel;
import javax.swing.SwingConstants;

import java.awt.Component;

import javax.swing.JButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

import javax.swing.SpinnerNumberModel;


public class CherryPanel02 extends JPanel {
	private JTextField chp_text_1;
	private JTextField chp_text_1T;
	public JTextField chp_text_2;
	private JTextField chp_text_3;
	private JTextField chp_text_4;
	private String plateloc;
	private String tubeloc;
	private String workfile;
	private String splate;
	private String dplate;
	private String liqtype;
	private String smcycle;
	private String dmcycle;
	private String scycle;
	private String dcycle;
	private String smixvol;
	private String dmixvol;
	
    private String path = " ";
    private String[] tubesAll;
    private String[] platesAll;
    private String[] cycles = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10",
    		 					"11", "12", "13", "14", "15", "16", "17", "18", "19", "20",
    		 					"21", "22", "23", "24", "25", "26", "27", "28", "29", "30",
    		 					"31", "32", "33", "34", "35", "36", "37", "38", "39", "40",
    		 					"41", "42", "43", "44", "45", "46", "47", "48", "49", "50",
    		 					"51", "52", "53", "54", "55", "56", "57", "58", "59", "60",
    		 					"61", "62", "63", "64", "65", "66", "67", "68", "69", "70",
    		 					"71", "72", "73", "74", "75", "76", "77", "78", "79", "80",
    		 					"81", "82", "83", "84", "85", "86", "87", "88", "89", "90",
    		 					"91", "92", "93", "94", "95", "96", "97", "98", "99", "100" };
	
	private Color panelColor = new Color(248, 248, 255);
    private JComboBox chp_comboBox_1 = null;
    private JComboBox chp_comboBox_2 = null;
    private JComboBox chp_comboBox_3 = null;
    private JComboBox chp_comboBox_4 = null;
    private JComboBox chp_comboBox_5 = null;
    private JComboBox chp_comboBox_6 = null;
    private JComboBox chp_comboBox_7 = null;
    private JComboBox chp_comboBox_8 = null;
	private JSpinner chp_spinner_1 = null;
	private JSpinner chp_spinner_2 = null;
    private JFileChooser jFileChooser3 = null;
	private JButton btnBrowse = null;
    private int tindex = 0;
    private int cindex = 0;
    private int spindex = 0;
    private int dpindex = 0;
    private int lindex = 0;
    private int smindex = 0;
    private int scindex = 0;
    private int dmindex = 0;
    private int bcindex = 0;
    private int labindex = 0;
    private int labindex2 = 0;
    private Dimension mvpSize1 = null, mvpSize2 = null, mvpSize3 = null, 
    				  mvpSize4 = null, mvpSize5 = null;
    private JTextField textField;
//    private TabWindow tab = new TabWindow();
	/**
	 * This is the default constructor
	 */

	public CherryPanel02(String[] plates, String[] liqtypes, String[] tubes) {
		setAlignmentY(Component.TOP_ALIGNMENT);
 		  platesAll = new String [plates.length];
 		  String [] liqTypes = new String [liqtypes.length];
 		  tubesAll = new String [tubes.length];
	      for (int i = 0; i < plates.length; i++) {
	          platesAll[i] = plates[i] ;
	        }
	      for (int i = 0; i < liqtypes.length; i++) {
	          liqTypes[i] = liqtypes[i] ;
	        }
	      for (int i = 0; i < tubes.length; i++) {
	          tubesAll[i] = tubes[i] ;
	        }

		setSize(600, 424);
	    setBackground(panelColor);
	    setAlignmentX(Component.LEFT_ALIGNMENT);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 150, 0, 30, 76, 700, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
		setLayout(gridBagLayout);

		
		JLabel lblNewLabel_3 = new JLabel(" Worklist file: ");
		GridBagConstraints gbc_lblNewLabel_3 = new GridBagConstraints();
		gbc_lblNewLabel_3.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_3.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_3.gridx = 0;
		gbc_lblNewLabel_3.gridy = 0;
		add(lblNewLabel_3, gbc_lblNewLabel_3);
		
		chp_text_2 = new JTextField();
		GridBagConstraints gbc_text_2 = new GridBagConstraints();
		gbc_text_2.insets = new Insets(0, 0, 5, 5);
		gbc_text_2.anchor = GridBagConstraints.WEST;
		gbc_text_2.gridx = 1;
		gbc_text_2.gridy = 0;
	    chp_text_2.setPreferredSize(new Dimension(145, 28));
		add(chp_text_2, gbc_text_2);
//		textField.setColumns(10);
		
		JLabel label_2 = new JLabel("");
		GridBagConstraints gbc_label_2 = new GridBagConstraints();
		gbc_label_2.anchor = GridBagConstraints.WEST;
		gbc_label_2.insets = new Insets(0, 0, 5, 5);
		gbc_label_2.gridx = 3;
		gbc_label_2.gridy = 0;
		add(label_2, gbc_label_2);
		
		btnBrowse = new JButton("Browse");
		btnBrowse.addActionListener(new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            workFile();
	          } } );
		
		GridBagConstraints gbc_btnBrowse = new GridBagConstraints();
		gbc_btnBrowse.anchor = GridBagConstraints.WEST;
		gbc_btnBrowse.insets = new Insets(0, 0, 5, 5);
		gbc_btnBrowse.gridx = 4;
		gbc_btnBrowse.gridy = 0;
		add(btnBrowse, gbc_btnBrowse);
		
		JLabel lblNewLabel_4 = new JLabel("");
		GridBagConstraints gbc_lblNewLabel_4 = new GridBagConstraints();
		gbc_lblNewLabel_4.insets = new Insets(0, 0, 5, 0);
		gbc_lblNewLabel_4.gridx = 6;
		gbc_lblNewLabel_4.gridy = 0;
		add(lblNewLabel_4, gbc_lblNewLabel_4);
		
		JLabel lblNewLabel = new JLabel(" Plate position/s:");
		lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.gridx = 0;
		gbc_lblNewLabel.gridy = 4;
	    mvpSize2 = lblNewLabel.getPreferredSize();      
		add(lblNewLabel, gbc_lblNewLabel);
		
		JLabel lblNewLabel_5 = new JLabel(" Tube position/s:");
		lblNewLabel_5.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel_5 = new GridBagConstraints();
		gbc_lblNewLabel_5.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_5.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_5.gridx = 0;
		gbc_lblNewLabel_5.gridy = 5;
	    mvpSize2 = lblNewLabel_5.getPreferredSize();      
		add(lblNewLabel_5, gbc_lblNewLabel_5);
		
        this.chp_comboBox_1 = new JComboBox( platesAll );
        chp_comboBox_1.setMinimumSize(new Dimension(245, 35));
        chp_comboBox_1.setPreferredSize(new Dimension(145, 28));
        chp_comboBox_1.setSelectedIndex(0);
        splate = ((String)chp_comboBox_1.getSelectedItem());
        spindex = this.chp_comboBox_1.getSelectedIndex();
        chp_comboBox_1.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            JComboBox cb = (JComboBox)e.getSource();
            splate = ((String)cb.getSelectedItem());
            spindex = (cb.getSelectedIndex());
          } } );
        
        GridBagConstraints gbc_comboBox_1 = new GridBagConstraints();
        gbc_comboBox_1.insets = new Insets(0, 0, 5, 5);
        gbc_comboBox_1.anchor = GridBagConstraints.WEST;
        gbc_comboBox_1.gridwidth = 1;
        gbc_comboBox_1.gridx = 4;
        gbc_comboBox_1.gridy = 1;
        add(chp_comboBox_1, gbc_comboBox_1);
		
		        this.chp_comboBox_3 = new JComboBox( liqTypes );
		        chp_comboBox_3.setMinimumSize(new Dimension(245, 35));
		        chp_comboBox_3.setPreferredSize(new Dimension(145, 28));
		        chp_comboBox_3.setSelectedIndex(0);
		        liqtype = ((String)chp_comboBox_3.getSelectedItem());
		        lindex = this.chp_comboBox_3.getSelectedIndex();
		        chp_comboBox_3.addActionListener(new ActionListener() {
		          public void actionPerformed(ActionEvent e) {
		            JComboBox cb = (JComboBox)e.getSource();
		           liqtype = ((String)cb.getSelectedItem());
           lindex = (cb.getSelectedIndex());
		          } } );
		        
       this.chp_comboBox_2 = new JComboBox( platesAll );
       chp_comboBox_2.setMinimumSize(new Dimension(245, 35));
       chp_comboBox_2.setPreferredSize(new Dimension(145, 28));
       chp_comboBox_2.setSelectedIndex(0);
       dplate = ((String)chp_comboBox_2.getSelectedItem());
       dpindex = this.chp_comboBox_2.getSelectedIndex();
       chp_comboBox_2.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
           JComboBox cb = (JComboBox)e.getSource();
           dplate = ((String)cb.getSelectedItem());
            dpindex = (cb.getSelectedIndex());
         } } );
       
		GridBagConstraints gbc_comboBox_2 = new GridBagConstraints();
		gbc_comboBox_2.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_2.anchor = GridBagConstraints.WEST;
		gbc_comboBox_2.gridwidth = 1;
		gbc_comboBox_2.gridx = 4;
		gbc_comboBox_2.gridy = 2;
		add(chp_comboBox_2, gbc_comboBox_2);
		        
		        GridBagConstraints gbc_comboBox_3 = new GridBagConstraints();
		        gbc_comboBox_3.insets = new Insets(0, 0, 5, 5);
		        gbc_comboBox_3.anchor = GridBagConstraints.WEST;
		        gbc_comboBox_3.gridwidth = 1;
		        gbc_comboBox_3.gridx = 1;
		        gbc_comboBox_3.gridy = 3;
		        add(chp_comboBox_3, gbc_comboBox_3);
		
		chp_text_1 = new JTextField();
		chp_text_1.setEnabled(false);
		GridBagConstraints gbc_text_1 = new GridBagConstraints();
		gbc_text_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_text_1.insets = new Insets(0, 0, 5, 5);
		gbc_text_1.gridx = 1;
		gbc_text_1.gridy = 4;
	    mvpSize3 = chp_text_1.getPreferredSize();
	    chp_text_1.setPreferredSize(new Dimension(145, 28));
		add(chp_text_1, gbc_text_1);
		
		chp_text_1T = new JTextField();
		chp_text_1T.setEnabled(false);
		GridBagConstraints gbc_text_1T = new GridBagConstraints();
		gbc_text_1T.fill = GridBagConstraints.HORIZONTAL;
		gbc_text_1T.insets = new Insets(0, 0, 5, 5);
		gbc_text_1T.gridx = 1;
		gbc_text_1T.gridy = 5;
	    mvpSize3 = chp_text_1T.getPreferredSize();
	    chp_text_1T.setPreferredSize(new Dimension(145, 28));
		add(chp_text_1T, gbc_text_1T);
		
		ImageIcon icon = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/question.png");

		JLabel label_7 = new JLabel(icon);
		GridBagConstraints gbc_label_7 = new GridBagConstraints();
		gbc_label_7.anchor = GridBagConstraints.WEST;
		gbc_label_7.insets = new Insets(0, 0, 5, 5);
		gbc_label_7.gridx = 3;
		gbc_label_7.gridy = 0;
		label_7.setToolTipText("Enter or Browse and Select the worklist file");
		add(label_7, gbc_label_7);
		
		JLabel label_13 = new JLabel(icon);
		label_13.setToolTipText("<html>"
                + "Are the plates Barcoded?"
                +"<br><br>"
                + "If so, <br>(1) Select the picture of the barcode in the pulldown to the right.<br>(2) Enter a range of deck positions where the plates will be placed.   For example, 1-10<br>          AutoPilot will use the AutoLoader to search for the plates at those positions."
                + "</html>");
		
		GridBagConstraints gbc_label_13 = new GridBagConstraints();
		gbc_label_13.anchor = GridBagConstraints.WEST;
		gbc_label_13.insets = new Insets(0, 0, 5, 5);
		gbc_label_13.gridx = 3;
		gbc_label_13.gridy = 4;
		add(label_13, gbc_label_13);
		
		JLabel label_14 = new JLabel(icon);
		label_14.setToolTipText("<html>"
                + "Are the plates Barcoded?"
                +"<br><br>"
                + "If so, <br>(1) Select the picture of the barcode in the pulldown to the right.<br>(2) Enter a range of deck positions where the plates will be placed.   For example, 1-10<br>          AutoPilot will use the AutoLoader to search for the plates at those positions."
                + "</html>");
		
		GridBagConstraints gbc_label_14 = new GridBagConstraints();
		gbc_label_14.anchor = GridBagConstraints.WEST;
		gbc_label_14.insets = new Insets(0, 0, 5, 5);
		gbc_label_14.gridx = 3;
		gbc_label_14.gridy = 5;
		add(label_14, gbc_label_14);
		
		JLabel lblNewLabel_1 = new JLabel(" Source labware: ");
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel_1 = new GridBagConstraints();
		gbc_lblNewLabel_1.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_1.gridx = 0;
		gbc_lblNewLabel_1.gridy = 1;
		add(lblNewLabel_1, gbc_lblNewLabel_1);

		this.chp_comboBox_7 = new JComboBox();
		chp_comboBox_7.addItem("Source labware");
		chp_comboBox_7.addItem("Tubes");
		chp_comboBox_7.addItem("Plates");
		chp_comboBox_7.setMinimumSize(new Dimension(245, 35));
	    chp_comboBox_7.setPreferredSize(new Dimension(145, 28));
	    chp_comboBox_7.setSelectedIndex(0);
	    chp_comboBox_7.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
   	          JComboBox cb = (JComboBox)e.getSource();
    	      labindex = chp_comboBox_7.getSelectedIndex();
   	          if (labindex < 1 || labindex2 < 1)
	    	  {
		 		  chp_comboBox_6.setEnabled(false);
	    	  }
   	          else
	    	  {
		 		  chp_comboBox_6.setEnabled(true);
	    	  }
   	        	  
   	          if (labindex == 0)
	    	  {
	    		  chp_comboBox_1.removeAllItems();
	   	    	   for (int i = 0; i < platesAll.length; i++) {
	  	    		  chp_comboBox_1.addItem(platesAll[i]);
	  	    	   }
   	        	  chp_comboBox_1.setSelectedIndex(0);
	    	  }
   	          if (labindex > 0)
	    	  {
	    		  chp_comboBox_1.removeAllItems();
	    	  }
   	          if (labindex == 1)
	    	  {
	    	   for (int i = 0; i < tubesAll.length; i++) {
	    		  chp_comboBox_1.addItem(tubesAll[i]);
	    	   }
	    	  }
   	          if (labindex > 1)
	    	  {
	    	   for (int i = 0; i < platesAll.length; i++) {
	    		  chp_comboBox_1.addItem(platesAll[i]);
	    	   }
	    	  }
              if (bcindex != 0)
              {
     	          if (labindex == 1 && labindex2 == 1)
     	    	  {
     	         	   chp_text_1.setEnabled(false);
     	         	   chp_text_1.setText("");
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 1 && labindex2 == 2)
     	    	  {
     	         	   chp_text_1.setEnabled(true);
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 2 && labindex2 == 1)
     	    	  {
     	         	   chp_text_1.setEnabled(true);
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 2 && labindex2 == 2)
     	    	  {
     	         	   chp_text_1.setEnabled(true);
     	         	   chp_text_1T.setEnabled(false);
     	         	   chp_text_1T.setText("");
     	    	  }
     	          if (labindex < 1)
     	    	  {
     	         	   chp_text_1.setEnabled(false);
     	         	   chp_text_1.setText("");
     	    	  }
     	          if (labindex2 < 1)
     	    	  {
     	        	   chp_text_1T.setText("");
     	         	   chp_text_1T.setEnabled(false);
     	    	  }
              }
	      } } );
		
		GridBagConstraints gbc_comboBox_7 = new GridBagConstraints();
		gbc_comboBox_7.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_7.anchor = GridBagConstraints.WEST;
		gbc_comboBox_7.gridwidth = 1;
		gbc_comboBox_7.gridx = 1;
		gbc_comboBox_7.gridy = 1;
		add(chp_comboBox_7, gbc_comboBox_7);
		
 		JLabel lblNewLabel_2 = new JLabel(" Destination labware:");
		GridBagConstraints gbc_lblNewLabel_2 = new GridBagConstraints();
		gbc_lblNewLabel_2.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_2.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_2.gridx = 0;
		gbc_lblNewLabel_2.gridy = 2;
		add(lblNewLabel_2, gbc_lblNewLabel_2);

		this.chp_comboBox_8 = new JComboBox();
		chp_comboBox_8.addItem("Destination labware");
		chp_comboBox_8.addItem("Tubes");
		chp_comboBox_8.addItem("Plates");
		chp_comboBox_8.setMinimumSize(new Dimension(245, 35));
	    chp_comboBox_8.setPreferredSize(new Dimension(145, 28));
	    chp_comboBox_8.setSelectedIndex(0);
//	    splate = ((String)chp_comboBox_1.getSelectedItem());
//      spindex = this.chp_comboBox_1.getSelectedIndex();
	    chp_comboBox_8.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	      JComboBox cb = (JComboBox)e.getSource();
  	      labindex2 = chp_comboBox_8.getSelectedIndex();
          if (labindex < 1 || labindex2 < 1)
    	  {
        	  chp_comboBox_6.setEnabled(false);
    	  }
	          else
    	  {
	 		  chp_comboBox_6.setEnabled(true);
    	  }
	          if (labindex2 == 0)
    	  {
    		  chp_comboBox_2.removeAllItems();
   	    	   for (int i = 0; i < platesAll.length; i++) {
  	    		  chp_comboBox_2.addItem(platesAll[i]);
  	    	   }
	        	  chp_comboBox_2.setSelectedIndex(0);
    	  }
	          if (labindex2 > 0)
    	  {
    		  chp_comboBox_2.removeAllItems();
    	  }
	          if (labindex2 == 1)
    	  {
    	   for (int i = 0; i < tubesAll.length; i++) {
    		  chp_comboBox_2.addItem(tubesAll[i]);
    	   }
    	  }
	          if (labindex2 > 1)
    	  {
    	   for (int i = 0; i < platesAll.length; i++) {
    		  chp_comboBox_2.addItem(platesAll[i]);
    	   }
    	  }
              if (bcindex != 0)
              {
     	          if (labindex == 1 && labindex2 == 1)
     	    	  {
    	         	   chp_text_1.setText("");
     	         	   chp_text_1.setEnabled(false);
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 1 && labindex2 == 2)
     	    	  {
     	         	   chp_text_1.setEnabled(true);
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 2 && labindex2 == 1)
     	    	  {
     	         	   chp_text_1.setEnabled(true);
     	         	   chp_text_1T.setEnabled(true);
     	    	  }
     	          if (labindex == 2 && labindex2 == 2)
     	    	  {
     	        	   chp_text_1T.setText("");
     	        	   chp_text_1T.setEnabled(false);
     	         	   chp_text_1.setEnabled(true);
     	    	  }
     	          if (labindex < 1)
     	    	  {
     	         	   chp_text_1.setEnabled(false);
     	         	   chp_text_1.setText("");
     	    	  }
     	          if (labindex2 < 1)
     	    	  {
              	   chp_text_1T.setText("");
     	         	   chp_text_1T.setEnabled(false);
     	    	  }
              }
	      } } );
		
		GridBagConstraints gbc_comboBox_8 = new GridBagConstraints();
		gbc_comboBox_8.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_8.anchor = GridBagConstraints.WEST;
		gbc_comboBox_8.gridwidth = 1;
		gbc_comboBox_8.gridx = 1;
		gbc_comboBox_8.gridy = 2;
		add(chp_comboBox_8, gbc_comboBox_8);
		
		JLabel label_3 = new JLabel(icon);
		GridBagConstraints gbc_label_3 = new GridBagConstraints();
		gbc_label_3.anchor = GridBagConstraints.WEST;
		gbc_label_3.insets = new Insets(0, 0, 5, 5);
		gbc_label_3.gridx = 3;
		gbc_label_3.gridy = 1;
		label_3.setToolTipText("Select source plate type");
		add(label_3, gbc_label_3);

		JLabel label_6 = new JLabel(icon);
		GridBagConstraints gbc_label_6 = new GridBagConstraints();
		gbc_label_6.anchor = GridBagConstraints.WEST;
		gbc_label_6.insets = new Insets(0, 0, 5, 5);
		gbc_label_6.gridx = 3;
		gbc_label_6.gridy = 2;
		label_6.setToolTipText("Select destination plate type");
		add(label_6, gbc_label_6);
		
		JLabel lblLiquidType = new JLabel(" Liquid type:");
		GridBagConstraints gbc_lblLiquidType = new GridBagConstraints();
		gbc_lblLiquidType.anchor = GridBagConstraints.WEST;
		gbc_lblLiquidType.insets = new Insets(0, 0, 5, 5);
		gbc_lblLiquidType.gridx = 0;
		gbc_lblLiquidType.gridy = 3;
		add(lblLiquidType, gbc_lblLiquidType);
		
		JLabel label_8 = new JLabel(icon);
		GridBagConstraints gbc_label_8 = new GridBagConstraints();
		gbc_label_8.anchor = GridBagConstraints.WEST;
		gbc_label_8.insets = new Insets(0, 0, 5, 5);
		gbc_label_8.gridx = 3;
		gbc_label_8.gridy = 3;
		label_8.setToolTipText("Select the liquid type");
		add(label_8, gbc_label_8);
		
		Object[] items =
	        {
			    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/nobarcode.png"),
	            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/barcode.png")
	        };
		  this.chp_comboBox_6 = new JComboBox( items );
		  chp_comboBox_6.setMinimumSize(new Dimension(70, 28));
		  chp_comboBox_6.setMaximumSize(new Dimension(70, 28));
		  chp_comboBox_6.setEnabled(false);
          this.chp_comboBox_6.setSelectedIndex(0);
          bcindex = this.chp_comboBox_6.getSelectedIndex();
          this.chp_comboBox_6.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            JComboBox cb = (JComboBox)e.getSource();
            bcindex = (cb.getSelectedIndex());
            if (bcindex != 0)
            {
   	          if (labindex == 1 && labindex2 == 1)
   	    	  {
   	         	   chp_text_1.setEnabled(false);
            	   chp_text_1.setText("");
   	         	   chp_text_1T.setEnabled(true);
   	    	  }
   	          if (labindex == 1 && labindex2 == 2)
   	    	  {
   	         	   chp_text_1.setEnabled(true);
   	         	   chp_text_1T.setEnabled(true);
   	    	  }
 	          if (labindex == 2 && labindex2 == 1)
 	    	  {
 	         	   chp_text_1.setEnabled(true);
 	         	   chp_text_1T.setEnabled(true);
 	    	  }
   	          if (labindex == 2 && labindex2 == 2)
   	    	  {
   	         	   chp_text_1.setEnabled(true);
   	         	   chp_text_1T.setEnabled(false);
            	   chp_text_1T.setText("");
   	    	  }
   	          if (labindex < 1)
   	    	  {
   	         	   chp_text_1.setEnabled(false);
   	         	   chp_text_1.setText("");
   	    	  }
   	          if (labindex2 < 1)
   	    	  {
            	   chp_text_1T.setText("");
   	         	   chp_text_1T.setEnabled(false);
   	    	  }
            }
            else
            {
         	   chp_text_1.setText("");
         	   chp_text_1.setEnabled(false);
         	   chp_text_1T.setText("");
         	   chp_text_1T.setEnabled(false);
            }
        } } );
	
        chp_comboBox_6.setBackground(panelColor);
        chp_comboBox_6.setMinimumSize(new Dimension(72, 28));
		chp_comboBox_6.setMaximumSize(new Dimension(72, 28));
	    chp_comboBox_6.setPreferredSize(new Dimension(72, 28));
	    GridBagConstraints gbc_chp_comboBox_6 = new GridBagConstraints();
	    gbc_chp_comboBox_6.anchor = GridBagConstraints.WEST;
	    gbc_chp_comboBox_6.gridwidth = 1;
	    gbc_chp_comboBox_6.insets = new Insets(0, 0, 5, 5);
	    gbc_chp_comboBox_6.gridx = 4;
	    gbc_chp_comboBox_6.gridy = 4;
	    add(chp_comboBox_6, gbc_chp_comboBox_6);
	
	
		JLabel chp_blank = new JLabel(" ");
		GridBagConstraints gbc_chp_blank = new GridBagConstraints();
		gbc_chp_blank.anchor = GridBagConstraints.WEST;
		gbc_chp_blank.insets = new Insets(0, 0, 5, 5);
		gbc_chp_blank.gridx = 0;
		gbc_chp_blank.gridy = 5;
		add(chp_blank, gbc_chp_blank);
		
		JLabel label_1 = new JLabel(" ");
		GridBagConstraints gbc_label_1 = new GridBagConstraints();
		gbc_label_1.insets = new Insets(0, 0, 5, 5);
		gbc_label_1.gridx = 0;
		gbc_label_1.gridy = 6;
		add(label_1, gbc_label_1);
		
		JLabel lblMixing = new JLabel("\n " + " MIXING");
//		lblMixing.setVerticalAlignment(SwingConstants.BOTTOM);
//		lblMixing.setAlignmentY(Component.BOTTOM_ALIGNMENT);
		GridBagConstraints gbc_lblMixing = new GridBagConstraints();
		gbc_lblMixing.anchor = GridBagConstraints.BELOW_BASELINE_LEADING;
		gbc_lblMixing.insets = new Insets(0, 0, 5, 5);
		gbc_lblMixing.gridx = 0;
		gbc_lblMixing.gridy = 7;
		add(lblMixing, gbc_lblMixing);
		
		JLabel label_4 = new JLabel("--------------------------------------------------------------------");
		label_4.setVerticalAlignment(SwingConstants.BOTTOM);
		GridBagConstraints gbc_label_4 = new GridBagConstraints();
		gbc_label_4.anchor = GridBagConstraints.SOUTHWEST;
		gbc_label_4.insets = new Insets(0, 0, 5, 5);
		gbc_label_4.gridwidth =2;
		gbc_label_4.gridx = 0;
		gbc_label_4.gridy = 8;
		add(label_4, gbc_label_4);

		JLabel lblSrcMix = new JLabel(" Source cycles:");
		GridBagConstraints gbc_lblSrcMix = new GridBagConstraints();
		gbc_lblSrcMix.anchor = GridBagConstraints.WEST;
		gbc_lblSrcMix.insets = new Insets(0, 0, 5, 5);
		gbc_lblSrcMix.gridx = 0;
		gbc_lblSrcMix.gridy = 9;
		add(lblSrcMix, gbc_lblSrcMix);

        this.chp_comboBox_4 = new JComboBox( cycles );
		chp_comboBox_4.setMinimumSize(new Dimension(245, 35));
	    chp_comboBox_4.setPreferredSize(new Dimension(145, 28));
	    chp_comboBox_4.setSelectedIndex(0);
	    smcycle = ((String)chp_comboBox_4.getSelectedItem());
        smindex = this.chp_comboBox_4.getSelectedIndex();
	    chp_comboBox_4.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        JComboBox cb = (JComboBox)e.getSource();
	       smcycle = ((String)cb.getSelectedItem());
           smindex = (cb.getSelectedIndex());
           if (smindex != 0)
           {
        	   chp_text_3.setEnabled(true);
           }
           else
           {
        	   chp_text_3.setText("");
        	   chp_text_3.setEnabled(false);
           }
        	   
	      } } );
		
		GridBagConstraints gbc_comboBox_4 = new GridBagConstraints();
		gbc_comboBox_4.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_4.anchor = GridBagConstraints.WEST;
		gbc_comboBox_4.gridwidth = 1;
		gbc_comboBox_4.gridx = 1;
		gbc_comboBox_4.gridy = 10;
//		add(chp_comboBox_4, gbc_comboBox_4);
		
		JLabel label_9 = new JLabel(icon);
		GridBagConstraints gbc_label_9 = new GridBagConstraints();
		gbc_label_9.anchor = GridBagConstraints.WEST;
		gbc_label_9.insets = new Insets(0, 0, 5, 5);
		gbc_label_9.gridx = 3;
		gbc_label_9.gridy = 9;
		label_9.setToolTipText("To activate mixing at the Source, select the number of mix cycles to peform.");
		add(label_9, gbc_label_9);
		
		JLabel lblSrcVol = new JLabel(" Mix volume(ul):");
		GridBagConstraints gbc_lblSrcVol = new GridBagConstraints();
		gbc_lblSrcVol.anchor = GridBagConstraints.WEST;
		gbc_lblSrcVol.insets = new Insets(0, 0, 5, 5);
		gbc_lblSrcVol.gridx = 0;
		gbc_lblSrcVol.gridy = 10;
		add(lblSrcVol, gbc_lblSrcVol);

		chp_text_3 = new JTextField();
		chp_text_3.setEnabled(false);
		GridBagConstraints gbc_text_3 = new GridBagConstraints();
		gbc_text_3.anchor = GridBagConstraints.WEST;
		gbc_text_3.insets = new Insets(0, 0, 5, 5);
		gbc_text_3.gridx = 1;
		gbc_text_3.gridy = 10;
	    chp_text_3.setPreferredSize(new Dimension(145, 28));
		add(chp_text_3, gbc_text_3);
		
		JLabel label_10 = new JLabel(icon);
		GridBagConstraints gbc_label_10 = new GridBagConstraints();
		gbc_label_10.anchor = GridBagConstraints.WEST;
		gbc_label_10.insets = new Insets(0, 0, 5, 5);
		gbc_label_10.gridx = 3;
		gbc_label_10.gridy = 10;
		label_10.setToolTipText("Enter the volume to mix for each cycle at the Source.");
		add(label_10, gbc_label_10);
		
		JLabel label_5 = new JLabel(" ");
		GridBagConstraints gbc_label_5 = new GridBagConstraints();
		gbc_label_5.insets = new Insets(0, 0, 5, 5);
		gbc_label_5.gridx = 0;
		gbc_label_5.gridy = 11;
		add(label_5, gbc_label_5);
		
		JLabel lblDestinationCycles = new JLabel(" Destination cycles:");
		GridBagConstraints gbc_lblDestinationCycles = new GridBagConstraints();
		gbc_lblDestinationCycles.anchor = GridBagConstraints.WEST;
		gbc_lblDestinationCycles.insets = new Insets(0, 0, 5, 5);
		gbc_lblDestinationCycles.gridx = 0;
		gbc_lblDestinationCycles.gridy = 12;
		add(lblDestinationCycles, gbc_lblDestinationCycles);
		
        this.chp_comboBox_5 = new JComboBox( cycles );
		chp_comboBox_5.setMinimumSize(new Dimension(245, 35));
	    chp_comboBox_5.setPreferredSize(new Dimension(145, 28));
	    chp_comboBox_5.setSelectedIndex(0);
	    dmcycle = ((String)chp_comboBox_5.getSelectedItem());
        dmindex = this.chp_comboBox_5.getSelectedIndex();
	    chp_comboBox_5.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        JComboBox cb = (JComboBox)e.getSource();
	       dmcycle = ((String)cb.getSelectedItem());
           dmindex = (cb.getSelectedIndex());
           if (dmindex != 0)
           {
        	   chp_text_4.setEnabled(true);
           }
           else
           {
        	   chp_text_4.setText("");
        	   chp_text_4.setEnabled(false);
           }

	      } } );
		
		GridBagConstraints gbc_comboBox_5 = new GridBagConstraints();
		gbc_comboBox_5.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_5.anchor = GridBagConstraints.WEST;
		gbc_comboBox_5.gridwidth = 1;
		gbc_comboBox_5.gridx = 1;
		gbc_comboBox_5.gridy = 13;
//		add(chp_comboBox_5, gbc_comboBox_5);
		
		JLabel label_11 = new JLabel(icon);
		GridBagConstraints gbc_label_11 = new GridBagConstraints();
		gbc_label_11.anchor = GridBagConstraints.WEST;
		gbc_label_11.insets = new Insets(0, 0, 5, 5);
		gbc_label_11.gridx = 3;
		gbc_label_11.gridy = 12;
		label_11.setToolTipText("To activate mixing at the Destination, select the number of mix cycles to peform.");
		add(label_11, gbc_label_11);

		JLabel lblMixVolumeul = new JLabel(" Mix volume(ul):");
		GridBagConstraints gbc_lblMixVolumeul = new GridBagConstraints();
		gbc_lblMixVolumeul.anchor = GridBagConstraints.WEST;
		gbc_lblMixVolumeul.insets = new Insets(0, 0, 5, 5);
		gbc_lblMixVolumeul.gridx = 0;
		gbc_lblMixVolumeul.gridy = 13;
		add(lblMixVolumeul, gbc_lblMixVolumeul);
		
		chp_text_4 = new JTextField();
		chp_text_4.setEnabled(false);
		GridBagConstraints gbc_text_4 = new GridBagConstraints();
		gbc_text_4.anchor = GridBagConstraints.WEST;
		gbc_text_4.insets = new Insets(0, 0, 5, 5);
		gbc_text_4.gridx = 1;
		gbc_text_4.gridy = 13;
	    chp_text_4.setPreferredSize(new Dimension(145, 28));
		add(chp_text_4, gbc_text_4);
		
		JLabel label_12 = new JLabel(icon);
		GridBagConstraints gbc_label_12 = new GridBagConstraints();
		gbc_label_12.anchor = GridBagConstraints.WEST;
		gbc_label_12.insets = new Insets(0, 0, 5, 5);
		gbc_label_12.gridx = 3;
		gbc_label_12.gridy = 13;
		label_12.setToolTipText("Enter the volume to mix for each cycle at the Destination");
		add(label_12, gbc_label_12);
		
		 ChangeListener listener1 = new ChangeListener() {
		      public void stateChanged(ChangeEvent e) {
	        	   smcycle = chp_spinner_1.getModel().getValue().toString();	
		           if (Integer.parseInt(smcycle) != 0)
		           {
		        	   chp_text_3.setEnabled(true);
		           }
		           else
		           {
		        	   chp_text_3.setText("");
		        	   chp_text_3.setEnabled(false);
		           }
		      }
		    };

		chp_spinner_1 = new JSpinner(new SpinnerNumberModel(0, 0, 100, 1));
		JFormattedTextField tf1 = ((JSpinner.DefaultEditor)chp_spinner_1.getEditor()).getTextField();
      	tf1.setHorizontalAlignment(JFormattedTextField.LEFT);
      	chp_spinner_1.setMaximumSize(new Dimension(245, 35));
		chp_spinner_1.setMinimumSize(new Dimension(245, 35));
		chp_spinner_1.setPreferredSize(new Dimension(145, 28));
		chp_spinner_1.addChangeListener(listener1);


		GridBagConstraints gbc_spinner_1 = new GridBagConstraints();
		gbc_spinner_1.anchor = GridBagConstraints.WEST;
		gbc_spinner_1.insets = new Insets(0, 0, 5, 5);
		gbc_spinner_1.gridx = 1;
		gbc_spinner_1.gridy = 9;
		add(chp_spinner_1, gbc_spinner_1);

		 ChangeListener listener2 = new ChangeListener() {
		      public void stateChanged(ChangeEvent e) {
	        	   dmcycle = chp_spinner_2.getModel().getValue().toString();	
		           if (Integer.parseInt(dmcycle) != 0)
		           {
		        	   chp_text_4.setEnabled(true);
		           }
		           else
		           {
		        	   chp_text_4.setText("");
		        	   chp_text_4.setEnabled(false);
		           }
		      }
		    };

		chp_spinner_2 = new JSpinner(new SpinnerNumberModel(0, 0, 100, 1));
		JFormattedTextField tf2 = ((JSpinner.DefaultEditor)chp_spinner_2.getEditor()).getTextField();
      	tf2.setHorizontalAlignment(JFormattedTextField.LEFT);
		chp_spinner_2.setMaximumSize(new Dimension(245, 35));
		chp_spinner_2.setMinimumSize(new Dimension(245, 35));
		chp_spinner_2.setPreferredSize(new Dimension(145, 28));
		chp_spinner_2.addChangeListener(listener2);


		GridBagConstraints gbc_spinner_2 = new GridBagConstraints();
		gbc_spinner_2.anchor = GridBagConstraints.WEST;
		gbc_spinner_2.insets = new Insets(0, 0, 5, 5);
		gbc_spinner_2.gridx = 1;
		gbc_spinner_2.gridy = 12;
		add(chp_spinner_2, gbc_spinner_2);

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}
	
	public String getPlateLoc() {
	plateloc = chp_text_1.getText();	
	return plateloc;
	}

	public boolean PlateLocEnabled() {
	return chp_text_1.isEnabled() ;
	}

	public String getTubeLoc() {
	tubeloc = chp_text_1T.getText();	
	return tubeloc;
	}

	public boolean TubeLocEnabled() {
	return chp_text_1T.isEnabled() ;
	}

	public String getWorkFile() {
	workfile = chp_text_2.getText();	
	return workfile;
	}

	public int getBarIndex() {
	return bcindex;
	}

	public int getLiqIndex() {
	return lindex;
	}

	public String getLiqType() {
	return liqtype;
	}

	public String getSPlateType() {
	return splate;
	}

	public String getDPlateType() {
	return dplate;
	}

	public int getSPlateIndex() {
	return spindex;
	}

	public int getDPlateIndex() {
	return dpindex;
	}

	public int getSCycleIndex() {
	return smindex;
	}

	public int getDCycleIndex() {
	return dmindex;
	}

	public int getSLabIndex() {
	return labindex;
	}

	public int getDLabIndex() {
	return labindex2;
	}

	public String getSMix() {
	smixvol = chp_text_3.getText();	
	return smixvol;
	}

	public String getDMix() {
	dmixvol = chp_text_4.getText();	
	return dmixvol;
	}

	public String getSCycle() {
	scycle = chp_spinner_1.getModel().getValue().toString();	
	return scycle;
	}

	public String getDCycle() {
	dcycle = chp_spinner_2.getModel().getValue().toString();	
	return dcycle;
	}

	
	private String removeWhiteSpace(String s)
	  {
		  String stringIn = s;
		  String stringTrim = stringIn.trim();
		  String stringOut = stringTrim.replaceAll("\\s", "");
		  return stringOut;
	  }

	  private boolean cytCheckInputs(String c, String d){
		  boolean returnVal = true;
		  int commasc = 0;
		  for(int i = 0; i < c.length(); i++) {
		      if(c.charAt(i) == ',') commasc++;
		  }
		  int commasd = 0;
		  for(int i = 0; i < d.length(); i++) {
		      if(d.charAt(i) == ',') commasd++;
		  }
		  if (commasc != commasd)
		  returnVal = false;
		  
		  return returnVal;
	  }

	  private JFileChooser getJFileChooser3()
	  {
	    if (this.jFileChooser3 == null) {
	      this.jFileChooser3 = new JFileChooser();
	      this.jFileChooser3.setDialogTitle("Select Cherry Picking File");
	      this.jFileChooser3.setApproveButtonText("Select");
	      this.jFileChooser3.setMultiSelectionEnabled(false);
	      FileFilter filter3 = new textFileFilter(".csv", new String[] { "CSV" });
	      this.jFileChooser3.setFileFilter(filter3);
	    }

	    return this.jFileChooser3;
	  }

	  
	  private void workFile()
	  {
	    int state = getJFileChooser3().showOpenDialog(this);
	    if (state == 0) {
	      File f = getJFileChooser3().getSelectedFile();
	      this.path = f.getPath();
	      this.chp_text_2.setText(this.path);
	      this.chp_text_2.setEditable(false);
	      
	      String errorMessage="";
	      boolean cherryInputCheck = true;
	      
//	      errorMessage = VAStools.CP_WorklistConfirm(chp_text_2.getText(), getPlateLoc());
	      
	      if (!errorMessage.equals("")){cherryInputCheck = false;}
	      
	
          if (!cherryInputCheck){
        	JOptionPane.showMessageDialog(null, errorMessage); 
          }
	    }
	  }


	public void setText1( String s ){
		chp_text_1.setText(s);
	}
	  
	public void setText1T( String s ){
		chp_text_1T.setText(s);
	}
	  
	public void setText2( String s ){
		chp_text_2.setText(s);
	}
	  
	public void setText3( String s ){
		chp_text_3.setText(s);
	}

	public void setText4( String s ){
		chp_text_4.setText(s);
	}
	
	public void setSPlateIndex( int index ){
		chp_comboBox_1.setSelectedIndex(index);
	}
	
	public void setDPlateIndex( int index ){
		chp_comboBox_2.setSelectedIndex(index);
	}
	
	public void setLiqIndex( int index ){
		chp_comboBox_3.setSelectedIndex(index);
	}
	
	public void setSCycleIndex( int index ){
		chp_comboBox_4.setSelectedIndex(index);
	}
	
	public void setDCycleIndex( int index ){
		chp_comboBox_5.setSelectedIndex(index);
	}
	
	public void setBarIndex( int index ){
		chp_comboBox_6.setSelectedIndex(index);
	}
	
	public void setSLabIndex( int index ){
		chp_comboBox_7.setSelectedIndex(index);
	}
	
	public void setDLabIndex( int index ){
		chp_comboBox_8.setSelectedIndex(index);
	}
	
	public void setT1Enabled( boolean t ){
		chp_text_1.setEnabled(t);
	}

	public void setT1TEnabled( boolean t ){
		chp_text_1.setEnabled(t);
	}

	public void setT3Enabled( boolean t ){
		chp_text_3.setEnabled(t);
	}
	public void setT4Enabled( boolean t ){
		chp_text_4.setEnabled(t);
	}

	public void setSCycle1( int v ){
		chp_spinner_1.setValue(v);
	}

	public void setDCycle1( int v ){
		chp_spinner_2.setValue(v);
	}

}
