package TelosV2Pkg;

/**
 * Copyright 	- Telos Scientific - 06/17/2014
 * Author 		- Jesse A Campbell
 * Description	- User Account Entry window for Autopilot (Auto Pilot 1.0)
 * 
 * 06/17/14 - RSC - Program written
 */


import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.DateFormatSymbols;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Scanner;
import java.util.concurrent.CountDownLatch;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.filechooser.FileFilter;

import java.util.Calendar;

import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.DatabaseBuilder;
import com.healthmarketscience.jackcess.Row;
import com.healthmarketscience.jackcess.Table;
import com.itextpdf.text.io.RandomAccessSourceFactory;
import com.itextpdf.text.pdf.RandomAccessFileOrArray;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.parser.PdfReaderContentParser;
import com.itextpdf.text.pdf.parser.SimpleTextExtractionStrategy;
import com.itextpdf.text.pdf.parser.TextExtractionStrategy;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Dimension;

public class DirectorySelectionWindow extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel loginPanel = null;
	private static JButton saveButton = null ; 
	private static JButton deleteButton = null ;
	private static JButton cancelButton = null ; 

	private JPanel okPanel = null;
	private JLabel labelBlank1 = new JLabel("                    ");
	private JLabel labelBlank2 = new JLabel("                    ");
	private JLabel labelBlank3 = new JLabel("                    ");
	private JLabel labelBlank4 = new JLabel("                    ");
	private JLabel labelBlank5 = new JLabel("                    ");
	private JLabel labelBlank6 = new JLabel("                    ");
	private JLabel labelBlank7 = new JLabel("                    ");
	private JLabel labelBlank8 = new JLabel("                    ");
	private JLabel labelBlank9 = new JLabel("                    ");
	private JLabel labelBlank10 = new JLabel("                    ");
	private JLabel labelDirectoryList = new JLabel("Directory List:");
	private JLabel labelDirectoryNew = new JLabel("New Directory:");

	private JTextField textField_DirectoryNew= new JTextField(20); 

	private final JLabel lblType = new JLabel("Type:");
	
	private JComboBox comboBox_Directories = new JComboBox();

	private JFileChooser directoryChooser = new JFileChooser();

	private String directorySelected = "";
   
	private FileInputStream input;

	public ArrayList<String> arrayList_directoryData = new ArrayList();

	/**
	 * @param args
	 */
	public void main(String[] args) {

		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		// TODO Auto-generated method stub
		UserAccountWindow thisClass = new UserAccountWindow();
		thisClass.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		thisClass.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public DirectorySelectionWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(475, 225);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle("AutoPilot Secure Directories");

		comboBox_Directories.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		    	  directorySelected = String.valueOf(comboBox_Directories.getSelectedItem());  
		      } 
		} );
		
    	directoryChooser.setCurrentDirectory(new java.io.File("."));
    	directoryChooser.setDialogTitle("Select Secure Directory");
    	directoryChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    	directoryChooser.setAcceptAllFileFilterUsed(false);
    	
    	
    	textField_DirectoryNew.addMouseListener(new MouseListener()
        {


			@Override
			public void mouseClicked(MouseEvent arg0) {
				// TODO Auto-generated method stub

		          if (directoryChooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
		        	  textField_DirectoryNew.setText(directoryChooser.getSelectedFile().getAbsolutePath());
		          } else {
		              System.out.println("No Selection ");
		          }  
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			} 
		} );
    	


		loadAccount();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getLoginPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	private JPanel getOKPanel() {
		if (okPanel == null) {
			FlowLayout flow = new FlowLayout();
			okPanel = new JPanel();
			okPanel.setLayout(flow);
            okPanel.add(getsaveButton());
            okPanel.add(getdeleteButton());
            okPanel.add(getcancelButton());
		 }
		return okPanel;
	}
	
	private JPanel getLoginPanel() {
		if (loginPanel == null) {
			loginPanel = new JPanel();
			GridBagLayout gbl_loginPanel = new GridBagLayout();
			gbl_loginPanel.columnWidths = new int[]{60, 56, 166, 60, 0};
			gbl_loginPanel.rowHeights = new int[]{0, 0, 0};
			gbl_loginPanel.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			gbl_loginPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			loginPanel.setLayout(gbl_loginPanel);
						
			GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
			gbc_lblNewLabel.anchor = GridBagConstraints.EAST;
			gbc_lblNewLabel.insets = new Insets(20, 0, 20, 5);
			gbc_lblNewLabel.gridx = 1;
			gbc_lblNewLabel.gridy = 1;
			loginPanel.add(labelDirectoryList, gbc_lblNewLabel);
			
			GridBagConstraints gbc_comboBox = new GridBagConstraints();
			gbc_comboBox.anchor = GridBagConstraints.WEST;
			gbc_comboBox.insets = new Insets(20, 0, 20, 0);
			gbc_comboBox.gridx = 2;
			gbc_comboBox.gridy = 1;
			comboBox_Directories.setMinimumSize(new Dimension(275, 20));
			comboBox_Directories.setPreferredSize(new Dimension(275, 20));
			loginPanel.add(comboBox_Directories, gbc_comboBox);
		
			GridBagConstraints gbc_labelUsername = new GridBagConstraints();
			gbc_labelUsername.anchor = GridBagConstraints.EAST;
			gbc_labelUsername.insets = new Insets(0, 0, 5, 5);
			gbc_labelUsername.gridx = 1;
			gbc_labelUsername.gridy = 2;
			loginPanel.add(labelDirectoryNew, gbc_labelUsername); 
			
			GridBagConstraints gbc_textField_Uername = new GridBagConstraints();
			gbc_textField_Uername.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Uername.anchor = GridBagConstraints.NORTH;
			gbc_textField_Uername.insets = new Insets(0, 0, 0, 0);
			gbc_textField_Uername.gridx = 2;
			gbc_textField_Uername.gridy = 2;
			loginPanel.add(textField_DirectoryNew, gbc_textField_Uername);
			
			GridBagConstraints gbc_saveButton = new GridBagConstraints();
			gbc_saveButton.anchor = GridBagConstraints.NORTH;
			gbc_saveButton.insets = new Insets(20, 0, 0, 0);
			gbc_saveButton.gridx = 2;
			gbc_saveButton.gridy = 6;
			loginPanel.add(getOKPanel(), gbc_saveButton
					);

		 }
		return loginPanel;
	}

    
	private javax.swing.JButton getsaveButton() {
		if (saveButton == null) {
			saveButton = new javax.swing.JButton();
			saveButton.setSize(20, 20);
			saveButton.setText("  Save   ");
			saveButton.setHorizontalAlignment(SwingConstants.CENTER);
		    saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {


					if (textField_DirectoryNew.getText().equals("")){
						JOptionPane.showMessageDialog(null, "Please enter new directory.");
						return;
					}
					
					arrayList_directoryData.add(textField_DirectoryNew.getText().trim());

		 		
	   				saveAccount();
					JOptionPane.showMessageDialog(null, "Directory saved"," ", JOptionPane.INFORMATION_MESSAGE);
				}
			});
					
		}
		return saveButton;
	}
	
	private javax.swing.JButton getdeleteButton() {
		if (deleteButton == null) {
			deleteButton = new javax.swing.JButton();
			deleteButton.setSize(20, 20);
			deleteButton.setText("  Delete   ");
			deleteButton.setHorizontalAlignment(SwingConstants.CENTER);
		    deleteButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
    
				    int state = JOptionPane.showConfirmDialog(null, "Are you sure you want to permanently DELETE this directory from the list?");
				   
				    if (state == 0){
					    for (int i=0; i < arrayList_directoryData.size(); i++){
					    	if (arrayList_directoryData.get(i).split(",")[0].equals(directorySelected)){
					    		arrayList_directoryData.remove(i);
					    		saveAccount();
					    	}
					    }				    	
				    }
   
				}
			});
					
		}
		return deleteButton;
	}
	
	private javax.swing.JButton getcancelButton() {
		if (cancelButton == null) {
			cancelButton = new javax.swing.JButton();
			cancelButton.setSize(20, 20);
			cancelButton.setText("  Cancel   ");
			cancelButton.setHorizontalAlignment(SwingConstants.CENTER);
		    cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					comboBox_Directories.setSelectedIndex(0);
					textField_DirectoryNew.setText("");
				    DirectorySelectionWindow.this.setVisible(false);
				}
			});
					
		}
		return cancelButton;
	}
	
	
	private void saveAccount() {
		
		String filename = "C:/Program Files/TELOS/AutoPilot/System/APDS.dat" ;
		File f = new File(filename);
		try {
			final BufferedWriter bw = new BufferedWriter(new FileWriter(f));
			

			for (int i=0; i < arrayList_directoryData.size(); i++){
			    bw.write(CryptoMessage.encrypt(arrayList_directoryData.get(i))) ;					//APN0052
				bw.newLine();				
			}

			bw.close( );

			
		} catch (final FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (final IOException e1) {
			e1.printStackTrace();
		}

		// reset the screen values 
		comboBox_Directories.setSelectedIndex(0);
		textField_DirectoryNew.setText("");

		loadAccount();
	}



	/**
	 * This method loads scheme data into holding list  	
	 * 	
	 * @return void 	
	 */
	@SuppressWarnings("unchecked")
	private void loadAccount() {
		
		arrayList_directoryData.clear();
		comboBox_Directories.removeAllItems();  comboBox_Directories.addItem("Add new directory");
	    
		try { 
			String data = "";
			String filename = "C:/Program Files/TELOS/AutoPilot/System/APDS.dat" ;
			File f = new File(filename);
			input = new FileInputStream ( f );
			final BufferedReader bw = new BufferedReader(new FileReader(f));
		    
		    
		    while ( data != null ) {
				data = bw.readLine();
				if ( data != null )
				{
					arrayList_directoryData.add(CryptoMessage.decrypt(data));								//APN0052
					comboBox_Directories.addItem(CryptoMessage.decrypt(data.split(",")[0]));				//APN0052
				}
		   }
		    
		    comboBox_Directories.setSelectedIndex(0);
		} 
		catch ( EOFException eof ) {
			try { 
				input.close();
				} catch ( IOException e ) {
				JOptionPane.showMessageDialog( this, 
						"Error Closing File" , 
						"Error", 
						JOptionPane.ERROR_MESSAGE );
				}
		}
		catch ( IOException e ) {
			JOptionPane.showMessageDialog( this, 
					"Error Opening File" , 
					"Error", 
					JOptionPane.ERROR_MESSAGE );
		}

		try { 
		input.close();
		} catch ( IOException e ) {
		JOptionPane.showMessageDialog( this, 
				"Error Closing File" , 
				"Error", 
				JOptionPane.ERROR_MESSAGE );
		}
	}
	
}
