/**
 	 * AutoPilot 	- LicoPanel
	 * Copyright 	- Telos Scientific - 
	 * Author 		- Jesse A. Campbell
	 * Description	- Liconic data entry screen. 
	 * 
	 * Version update information
	 * 
	 * 11.29.15 RSC - Class created - Liconic module.  
	 * 				*/

package TelosV2Pkg;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JLabel;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import java.awt.Component;
import javax.swing.JButton;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;


public class LicoPanel extends JPanel {
	private JTextField lic_text_1;
	private JTextField lic_text_2;
	private String licoloc;
	private String deckloc;
	private String licotsp;
	private String plate;
	private Color panelColor = new Color(248, 248, 255);
    private JComboBox lic_comboBox = null;
    private JComboBox lic_comboBox_2 = null;
    private JComboBox lic_comboBox_3 = null;
    private JComboBox lic_comboBox_4 = null;
    private int ftindex = 0;
    private int cindex = 0;
    private int pindex = 0;
    private Dimension licoSize1 = null, licoSize2 = null, licoSize3 = null, 
    				  licoSize4 = null, licoSize5 = null;
//    private TabWindow tab = new TabWindow();
	/**
	 * This is the default constructor
	 */

	public LicoPanel(String[] plates, String[] platetypes) {
 		  String [] platesAll = new String [plates.length];
 		  String [] plateTypes = new String [platetypes.length - 1];
	      for (int i = 0; i < plates.length; i++) {
	          platesAll[i] = plates[i] ;
	        }
	      for (int i = 1; i < platetypes.length; i++) {
	          plateTypes[i - 1] = platetypes[i] ;
	        }

		setSize(650, 424);
	    setBackground(panelColor);
	    setAlignmentX(Component.LEFT_ALIGNMENT);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{53, 15, 146, 96, 57, 75, 40};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 1.0, 0.0, 0.0,0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		JLabel label_4 = new JLabel("       ");
		GridBagConstraints gbc_label_4 = new GridBagConstraints();
		gbc_label_4.insets = new Insets(0, 0, 5, 5);
		gbc_label_4.anchor = GridBagConstraints.EAST;
		gbc_label_4.gridx = 0;
		gbc_label_4.gridy = 2;
		add(label_4, gbc_label_4);

		
		Object[] items =
		        {
				    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Liconic_From.png"),
		            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Liconic_To.png")
		        };
			  this.lic_comboBox = new JComboBox( items );
	          this.lic_comboBox.setSelectedIndex(0);
	          ftindex = this.lic_comboBox.getSelectedIndex();
	          this.lic_comboBox.addActionListener(new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            JComboBox cb = (JComboBox)e.getSource();
	            ftindex = (cb.getSelectedIndex());
	        } } );
		
  	    licoSize1 = lic_comboBox.getPreferredSize();      
	    lic_comboBox.setBackground(panelColor);
		GridBagConstraints gbc_lic_comboBox = new GridBagConstraints();
		gbc_lic_comboBox.anchor = GridBagConstraints.WEST;
		gbc_lic_comboBox.gridwidth = 2;
		gbc_lic_comboBox.insets = new Insets(0, 0, 5, 5);
		gbc_lic_comboBox.gridx = 1;
		gbc_lic_comboBox.gridy = 2;
		add(lic_comboBox, gbc_lic_comboBox);
		
		JLabel label_2 = new JLabel("");
		GridBagConstraints gbc_label_2 = new GridBagConstraints();
		gbc_label_2.insets = new Insets(0, 0, 5, 5);
		gbc_label_2.gridx = 3;
		gbc_label_2.gridy = 2;
		add(label_2, gbc_label_2);
		
		JLabel label = new JLabel("");
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.gridx = 1;
		gbc_label.gridy = 3;
		add(label, gbc_label);
		
		JLabel label_5 = new JLabel("");
		GridBagConstraints gbc_label_5 = new GridBagConstraints();
		gbc_label_5.insets = new Insets(0, 0, 5, 5);
		gbc_label_5.gridx = 0;
		gbc_label_5.gridy = 4;
		add(label_5, gbc_label_5);
		
		JLabel lblNewLabel = new JLabel(" Liconic location/s:");
		lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.gridx = 1;
		gbc_lblNewLabel.gridy = 4;
	    licoSize2 = lblNewLabel.getPreferredSize();      
		add(lblNewLabel, gbc_lblNewLabel);
		
		lic_text_1 = new JTextField();
		GridBagConstraints gbc_text_1 = new GridBagConstraints();
		gbc_text_1.anchor = GridBagConstraints.WEST;
		gbc_text_1.insets = new Insets(0, 0, 5, 5);
		gbc_text_1.gridx = 2;
		gbc_text_1.gridy = 4;
//		lic_text_1.setColumns(11);
	    licoSize3 = lic_text_1.getPreferredSize();
	    lic_text_1.setPreferredSize(new Dimension(130, 28));
		add(lic_text_1, gbc_text_1);
		
		ImageIcon icon = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/question.png");

		JLabel label_7 = new JLabel(icon);
		GridBagConstraints gbc_label_7 = new GridBagConstraints();
		gbc_label_7.anchor = GridBagConstraints.WEST;
		gbc_label_7.insets = new Insets(0, 0, 5, 5);
		gbc_label_7.gridx = 3;
		gbc_label_7.gridy = 2;
		label_7.setToolTipText("Send plates from/to Liconic");
		add(label_7, gbc_label_7);
		
		JLabel lblTest = new JLabel(icon);
		lblTest.setToolTipText("Enter liconic locations");
		GridBagConstraints gbc_lblTest = new GridBagConstraints();
		gbc_lblTest.anchor = GridBagConstraints.WEST;
		gbc_lblTest.insets = new Insets(0, 0, 5, 5);
		gbc_lblTest.gridx = 3;
		gbc_lblTest.gridy = 4;
		add(lblTest, gbc_lblTest);
		
		JLabel label_1 = new JLabel("");
		GridBagConstraints gbc_label_1 = new GridBagConstraints();
		gbc_label_1.insets = new Insets(0, 0, 5, 5);
		gbc_label_1.gridx = 1;
		gbc_label_1.gridy = 5;
		add(label_1, gbc_label_1);
		
		JLabel lblNewLabel_1 = new JLabel(" Deck location/s:");
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel_1 = new GridBagConstraints();
		gbc_lblNewLabel_1.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_1.gridx = 1;
		gbc_lblNewLabel_1.gridy = 6;
		add(lblNewLabel_1, gbc_lblNewLabel_1);
		
		lic_text_2 = new JTextField();
		GridBagConstraints gbc_text_2 = new GridBagConstraints();
		gbc_text_2.anchor = GridBagConstraints.WEST;
		gbc_text_2.insets = new Insets(0, 0, 5, 5);
		gbc_text_2.gridx = 2;
		gbc_text_2.gridy = 6;
		add(lic_text_2, gbc_text_2);
	    lic_text_2.setPreferredSize(new Dimension(130, 28));
//		lic_text_2.setColumns(11);
		
		Object[] covers =
	        {
			    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_Without_Cover.png"),
	            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_With_Cover.png")
	        };
		  this.lic_comboBox_4 = new JComboBox( covers );
          this.lic_comboBox_4.setSelectedIndex(0);
          cindex = this.lic_comboBox_4.getSelectedIndex();
          this.lic_comboBox_4.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            JComboBox cb = (JComboBox)e.getSource();
            cindex = (cb.getSelectedIndex());
        } } );
	
  	    lic_comboBox_4.setBackground(panelColor);
		GridBagConstraints gbc_lic_comboBox_4 = new GridBagConstraints();
		gbc_lic_comboBox_4.insets = new Insets(0, 0, 5, 5);
		lic_comboBox_4.setPreferredSize(new Dimension(licoSize1));
		gbc_lic_comboBox_4.anchor = GridBagConstraints.WEST;
		gbc_lic_comboBox_4.gridwidth = 2;
		gbc_lic_comboBox_4.gridx = 1;
		gbc_lic_comboBox_4.gridy = 7;
		add(lic_comboBox_4, gbc_lic_comboBox_4);

		JLabel label_9 = new JLabel(icon);
		GridBagConstraints gbc_label_9 = new GridBagConstraints();
		gbc_label_9.anchor = GridBagConstraints.WEST;
		gbc_label_9.insets = new Insets(0, 0, 5, 5);
		gbc_label_9.gridx = 3;
		gbc_label_9.gridy = 7;
		label_9.setToolTipText("Enter with or without plate cover");
		add(label_9, gbc_label_9);

		
        this.lic_comboBox_2 = new JComboBox( platesAll );
		lic_comboBox_2.setPreferredSize(new Dimension(licoSize1));
		lic_comboBox_2.setMinimumSize(new Dimension(licoSize1));
	    lic_comboBox_2.setSelectedIndex(0);
	    plate = ((String)lic_comboBox_2.getSelectedItem());
        pindex = this.lic_comboBox_2.getSelectedIndex();
	    lic_comboBox_2.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        JComboBox cb = (JComboBox)e.getSource();
	        plate = ((String)cb.getSelectedItem());
            pindex = (cb.getSelectedIndex());
	      } } );
		
		GridBagConstraints gbc_comboBox_2 = new GridBagConstraints();
		gbc_comboBox_2.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_2.anchor = GridBagConstraints.WEST;
		gbc_comboBox_2.gridwidth = 2;
		gbc_comboBox_2.gridx = 1;
		gbc_comboBox_2.gridy = 8;
		add(lic_comboBox_2, gbc_comboBox_2);
		
		JLabel label_3 = new JLabel(icon);
		GridBagConstraints gbc_label_3 = new GridBagConstraints();
		gbc_label_3.anchor = GridBagConstraints.WEST;
		gbc_label_3.insets = new Insets(0, 0, 5, 5);
		gbc_label_3.gridx = 3;
		gbc_label_3.gridy = 6;
		label_3.setToolTipText("Enter deck locations");
		add(label_3, gbc_label_3);

		JLabel label_6 = new JLabel(icon);
		GridBagConstraints gbc_label_6 = new GridBagConstraints();
		gbc_label_6.anchor = GridBagConstraints.WEST;
		gbc_label_6.insets = new Insets(0, 0, 5, 5);
		gbc_label_6.gridx = 3;
		gbc_label_6.gridy = 8;
		label_6.setToolTipText("Select plate type");
		add(label_6, gbc_label_6);
		
		this.lic_comboBox_3 = new JComboBox(plateTypes);
		GridBagConstraints gbc_comboBox_3 = new GridBagConstraints();
		lic_comboBox_3.setPreferredSize(new Dimension(licoSize1));
		lic_comboBox_3.setMinimumSize(new Dimension(licoSize1));
	      lic_comboBox_3.setSelectedIndex(0);
	      licotsp = ((String)lic_comboBox_3.getSelectedItem());
	      lic_comboBox_3.addActionListener(new ActionListener() {
	        public void actionPerformed(ActionEvent e) {
	          JComboBox cb = (JComboBox)e.getSource();
	          licotsp = ((String)cb.getSelectedItem());
	        } } );
		gbc_comboBox_3.insets = new Insets(0, 0, 0, 5);
		gbc_comboBox_3.anchor = GridBagConstraints.WEST;
		gbc_comboBox_3.gridwidth = 2;
		gbc_comboBox_3.gridx = 1;
		gbc_comboBox_3.gridy = 9;
		lic_comboBox_3.setVisible(false);
		add(lic_comboBox_3, gbc_comboBox_3);
		
		JLabel label_8 = new JLabel(icon);
		GridBagConstraints gbc_label_8 = new GridBagConstraints();
		gbc_label_8.anchor = GridBagConstraints.WEST;
		gbc_label_8.insets = new Insets(0, 0, 0, 5);
		gbc_label_8.gridx = 3;
		gbc_label_8.gridy = 9;
		label_8.setToolTipText("Transfer station position");
		label_8.setVisible(false);
		add(label_8, gbc_label_8);
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}
	

	public String getLicoLoc() {
	licoloc = lic_text_1.getText();	
	return licoloc;

	}
	public String getDeckLoc() {
	deckloc = lic_text_2.getText();	
	return deckloc;
	}

	public int getFTIndex() {
	return ftindex;
	}

	public int getCoverIndex() {
	return cindex;
	}

	public String getPlateType() {
	return plate;
	}

	public int getPlateIndex() {
	return pindex;
	}

	public String getTSP() {
	return licotsp;
	}

	private String removeWhiteSpace(String s)
	  {
		  String stringIn = s;
		  String stringTrim = stringIn.trim();
		  String stringOut = stringTrim.replaceAll("\\s", "");
		  return stringOut;
	  }

	  private boolean cytCheckInputs(String c, String d){
		  boolean returnVal = true;
		  int commasc = 0;
		  for(int i = 0; i < c.length(); i++) {
		      if(c.charAt(i) == ',') commasc++;
		  }
		  int commasd = 0;
		  for(int i = 0; i < d.length(); i++) {
		      if(d.charAt(i) == ',') commasd++;
		  }
		  if (commasc != commasd)
		  returnVal = false;
		  
		  return returnVal;
	  }

	public void setText1( String s ){
		lic_text_1.setText(s);
	}
	  
	public void setText2( String s ){
		lic_text_2.setText(s);
	}
	  
	public void setPlateIndex( int index ){
		lic_comboBox_2.setSelectedIndex(index);
	}
	
	public void setFTIndex( int index ){
		lic_comboBox.setSelectedIndex(index);
	}
	
	public void setCoverIndex( int index ){
		lic_comboBox_4.setSelectedIndex(index);
	}
	
	public void setTSPIndex( int index ){
		lic_comboBox_3.setSelectedIndex(index - 1);
	}
 
}
