	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- List Object  (Auto Pilot 1.0)
	 */

package TelosV2Pkg;

public class List {
	private ListNode firstNode;
	private ListNode lastNode;
	private String name;
	
	public List( String s )
	{ 
		name = s;
		firstNode = lastNode = null;
	}
	
	public List() 
	
	{
		this ( "list" );
	}
	
	public synchronized void insertAtBack( Object insertItem )
	{
		if ( isEmpty() )
			firstNode = lastNode = new ListNode( insertItem );
		else
			lastNode = lastNode.next = new ListNode( insertItem );
		
	}
	
	public synchronized Object removeFromBack() throws EmptyListException
	{
		Object removeItem = null;
		if ( isEmpty() )
			throw new EmptyListException( name );	
		
		removeItem = lastNode.data;
		
		if ( firstNode.equals( lastNode ) )
			firstNode = lastNode = null;
		else 
		{ 
			ListNode current = firstNode;
			while ( current.next != lastNode )
				current = current.next;
		    lastNode = current;
		    current.next = null;
		 
		}

		return removeItem;
		
	}
	
	public synchronized boolean isEmpty()
	{
		return firstNode == null;
	}
	
	public synchronized ListNode getFirstNode()
	{
		return firstNode ;
	}
	public synchronized ListNode getLastNode()
	{
		return lastNode ;
	}

	
}

