	/**
 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Advanced function window (Auto Pilot 1.0)
	 * 
	 */


package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.Scanner;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.DatabaseBuilder;
import com.healthmarketscience.jackcess.Row;
import com.healthmarketscience.jackcess.Table;
import com.itextpdf.text.io.RandomAccessSourceFactory;
import com.itextpdf.text.pdf.RandomAccessFileOrArray;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.parser.PdfReaderContentParser;
import com.itextpdf.text.pdf.parser.SimpleTextExtractionStrategy;
import com.itextpdf.text.pdf.parser.TextExtractionStrategy;




















import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;

public class LogInWindow extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel loginPanel = null;
	private static JButton loginButton = null ;  
	private static JButton cancelButton = null ;

	private JLabel labelBlank1 = new JLabel("                    ");
	private JLabel labelBlank2 = new JLabel("                    ");
	private JLabel labelBlank3 = new JLabel("                    ");
	private JLabel labelBlank4 = new JLabel("                    ");
	private JLabel labelBlank5 = new JLabel("                    ");
	private JLabel labelBlank6 = new JLabel("                    ");
	private JLabel labelBlank7 = new JLabel("                    ");
	private JLabel labelBlank8 = new JLabel("                    ");
	private JLabel labelBlank9 = new JLabel("                    ");
	private JLabel labelBlank10 = new JLabel("                    ");
	private JLabel labelUsername = new JLabel("User Name:");
	private JLabel labelPassword = new JLabel("Password:  ");
	public static JTextField textField_Username = new JTextField(12); 
	public static JTextField textField_Password = new JPasswordField(12); 
	public String decrypted;													//APN0052
	public static String userNameEntered ="";
	public static String passwordEntered ="";
	public static String userNameRecorded ="";
	public static String userNameConfirmed ="";										//APN0056
	public boolean passwordFailed = false;
	public int passwordAttempts = 0;
	
	public static PanelPasswordReset panelPasswordReset;
	long milliSecondsAccount;
	long milliSecondsToday;
	long milliSecondsDaysPassed;
	long milliSecondsNinetyDays = 7776000000L;

	
	private FileInputStream input;
	
	ArrayList<String> arrayList_userData = new ArrayList();
	ArrayList<String> arrayList_userData_Encrypted = new ArrayList();
	
	public String userName;
	

	/**
	 * @param args
	 */
	public void main(String[] args) {

		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		LogInWindow thisWindow = new LogInWindow();
		thisWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		thisWindow.setVisible(true);
		thisWindow.setAlwaysOnTop(true);
	}
	/**
	 * This is the default constructor
	 */
	public LogInWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(400, 175);
		this.setContentPane(getJContentPane());
		this.setTitle("AutoPilot Log In");
	    this.setIconImage(Toolkit.getDefaultToolkit()
	    		   .getImage("C:/Program Files/TELOS/AutoPilot/Config/molecule.png"));
	    
	    //create a listener for all exit events
	    addWindowListener(new WindowAdapter()				//APN0049
	    {
	       public void windowClosing(WindowEvent e)
	       {							
	    	   onTop(false);
	    	   JOptionPane.showMessageDialog(null, "AutoPilot will abort!");
	           System.exit(0);																													
	    	} 																																		

	    });
	    

	}

	private void setSizeBig() {
		// TODO Auto-generated method stub
		
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getLoginPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}


	private JPanel getLoginPanel() {
		if (loginPanel == null) {
			loginPanel = new JPanel();
			GridBagLayout gbl_loginPanel = new GridBagLayout();
			gbl_loginPanel.columnWidths = new int[]{100, 100};
			gbl_loginPanel.rowHeights = new int[]{20, 20, 20};
			gbl_loginPanel.columnWeights = new double[]{0.0, 0.0, 1.0, 0.0, Double.MIN_VALUE};
			gbl_loginPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			loginPanel.setLayout(gbl_loginPanel);

			GridBagConstraints gbc_labelUsername = new GridBagConstraints();
//			gbc_labelUsername.anchor = GridBagConstraints.EAST;
			gbc_labelUsername.insets = new Insets(0, 0, 5, 0);
			gbc_labelUsername.gridx = 0;
			gbc_labelUsername.gridy = 0;
			loginPanel.add(labelUsername, gbc_labelUsername); 
			
			
			GridBagConstraints gbc_textField_Uername = new GridBagConstraints();
//			gbc_textField_Uername.anchor = GridBagConstraints.NORTH;
			gbc_textField_Uername.insets = new Insets(0, 0, 5, 0);
			gbc_textField_Uername.gridx = 1;
			gbc_textField_Uername.gridy = 0;
			loginPanel.add(textField_Username, gbc_textField_Uername);
			
			GridBagConstraints gbc_labelPassword = new GridBagConstraints();
//			gbc_labelPassword.anchor = GridBagConstraints.EAST;
			gbc_labelPassword.insets = new Insets(0, 0, 0, 0);
			gbc_labelPassword.gridx = 0;
			gbc_labelPassword.gridy = 1;
			loginPanel.add(labelPassword, gbc_labelPassword);
			
			GridBagConstraints gbc_textField_Password = new GridBagConstraints();
//			gbc_textField_Password.anchor = GridBagConstraints.NORTH;
			gbc_textField_Password.insets = new Insets(0, 0, 0, 0);
			gbc_textField_Password.gridx = 1;
			gbc_textField_Password.gridy = 1;
			loginPanel.add(textField_Password, gbc_textField_Password); 
			
			GridBagConstraints gbc_loginButton = new GridBagConstraints();
//			gbc_loginButton.anchor = GridBagConstraints.NORTH;
			gbc_loginButton.insets = new Insets(0, 0, 0, 0);
			gbc_loginButton.gridx = 0;
			gbc_loginButton.gridy = 3;
			loginPanel.add(getloginButton(), gbc_loginButton);
			
			GridBagConstraints gbc_cancelButton = new GridBagConstraints();
			gbc_cancelButton.anchor = GridBagConstraints.WEST;
			gbc_cancelButton.insets = new Insets(0, 0, 0, 0);
			gbc_cancelButton.gridx = 1;
			gbc_cancelButton.gridy = 3;
			loginPanel.add(getCancelButton(), gbc_cancelButton);
			
			
			
		 }
		return loginPanel;
	}

    
	private javax.swing.JButton getloginButton() {
		if (loginButton == null) {
			loginButton = new javax.swing.JButton();
			loginButton.setSize(20, 20);
			loginButton.setText("   Login   ");
			loginButton.setHorizontalAlignment(SwingConstants.CENTER);
		    loginButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {

					userNameEntered = textField_Username.getText().trim();
					passwordEntered = textField_Password.getText().trim();
					
					if (userNameRecorded.equals(userNameEntered)){
						if (passwordFailed){
							if (!userNameEntered.equals("telos")){
								passwordAttempts +=1;	
							}
							
						}
					}else{
						passwordAttempts = 0;
					}
					
					if (passwordAttempts == 2){
						loadAccount();
						saveAccount();
						passwordEntered = "rev";
						passwordAttempts = 0;
					}
					
					userNameRecorded = userNameEntered;
					userNameConfirmed = "";
					String Login = LoginConfirm(userNameEntered, passwordEntered);
					
					if (Login.equals("-3")){//revoked
						textField_Username.setText("");
						textField_Password.setText("");
					}else if (Login.equals("-1") || Login.equals("-2")){//First login or password expired (90 days)
						onTop(false);
			    		if (panelPasswordReset == null){
			    			panelPasswordReset = new PanelPasswordReset();		//APN0056
			    		}
			    		panelPasswordReset.setVisible(true);					//APN0056
			    		panelPasswordReset.setAlwaysOnTop(true);				//APN0056
			    		panelPasswordReset.setLocationRelativeTo(null);			//APN0056
						textField_Username.setText("");							//APN0056
						textField_Password.setText("");							//APN0056
					}else if (!Login.equals("0")){
					  TabWindow.security_userLoggedIn = textField_Username.getText().trim();
					  vis(false);
					  textField_Username.setText("");
					  textField_Password.setText("");
					  
					  TabWindow.loadButton.setEnabled(true);
					  TabWindow.saveButton.setEnabled(true);
					  TabWindow.saveAsButton.setEnabled(true);
					  TabWindow.newButton.setEnabled(true);
					  TabWindow.layoutButton.setEnabled(true);
					  TabWindow.layoutSelectButton.setEnabled(true);
					  TabWindow.LogOffButton.setEnabled(true);

					  
					  if (Login.equals("3")){										//admin
						  TabWindow.security_accessLevel = "3";
						  TabWindow.securityButton.setEnabled(true);
						  TabWindow.securityAccountButton.setEnabled(true);
					  }else if (Login.equals("2")){									//developer
						  TabWindow.security_accessLevel = "2";
						  TabWindow.securityButton.setEnabled(true);
					  }else{
						  TabWindow.security_accessLevel = "1";
					  }
					  
					  try {
						VAStools.copyFile("C://Program Files//TELOS//AutoPilot//Config//APASACCT.cfg", "C://Program Files//TELOS//AutoPilot//Config//APASACCT2.cfg");
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					}
				
				}
			});
		}
		return loginButton;
	}
	
	private javax.swing.JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new javax.swing.JButton();
			cancelButton.setSize(20, 20);
			cancelButton.setText("  Cancel  ");
			cancelButton.setHorizontalAlignment(SwingConstants.CENTER);
		    cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					TabWindow.ExitApp();

				}
			});
		}
		return cancelButton;
	}
	
	public String LoginConfirm (String Username, String Password){
		
		//File format:  username,password,type
		//Types: admin,developer,operator
		
		String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
		String newline = "";
		boolean userFound = false;
		File f = new File(filename);

	    try {
	      FileReader input = new FileReader(f);
	      BufferedReader br = new BufferedReader(input);
	      while ((newline = br.readLine()) != null) {																			//APN0052
	    	  
	    	  System.out.println(newline);
	    	  
	    	  decrypted = newline.replace(newline.split(",")[0], CryptoMessage.decrypt(newline));								//APN0052		
	    	  
	    	  System.out.println(decrypted);

	    	  if (decrypted.split(",")[0].equals(Username)){																	//APN0052
	    		  userNameConfirmed = Username;						//APN0056
	    		  userFound = true;
	    		  break;
	    	  }else{
	    		  userNameConfirmed = "";							//APN0056
	    	  }
	      }
	      input.close();
	    }catch (Exception e) {
	    	VAStools.errorMessageProcess("VAS ERROR::Failed to retrieve user account information.\n\nError::"+e);
	    }
	    onTop(false);//APN0049
	    if (userFound){
	    	
	    	//Check for Revoked account
	    	if (decrypted.split(",")[1].equals("rev") || passwordEntered.equals("rev")){
	    		JOptionPane.showMessageDialog(null, "This account has been revoked.");
	    		onTop(true);
	    		return "-3";
	    	}
	    	
	    	if (decrypted.split(",")[1].equals(Password)){						//APN0052
	    		passwordFailed = false;
	    		//Check if this is the first time loging in
		    	if (!decrypted.split(",")[0].equals("telos")){						//APN0056
			    	if (decrypted.split(",").length > 4){							//APN0056
				    	if (decrypted.split(",")[4].equals("1")){					//APN0056
				    		JOptionPane.showMessageDialog(null, "First Login.  Please reset your password.");
				    		onTop(true);											//APN0056
				    		return "-1";											//APN0056
				    	}	    													//APN0056
			    	}else{															//APN0056
			    		JOptionPane.showMessageDialog(null, "First Login.  Please reset your password.");
			    		onTop(true);												//APN0056
			    		return "-1";												//APN0056
			    	}	    														//APN0056
		    	}																	//APN0056
	    		
		    	//Check if Password has expired
		    	if (!decrypted.split(",")[0].equals("telos")){
		    		Date date=new Date();
			    	milliSecondsAccount = Long.parseLong(decrypted.split(",")[3]);
			    	milliSecondsToday = date.getTime();
			    	milliSecondsDaysPassed = milliSecondsToday-milliSecondsAccount;
			    	System.out.println("Account Date " + milliSecondsAccount); 
			    	System.out.println("Today is " + milliSecondsToday); 
			    	System.out.println("Today is " + String.valueOf(milliSecondsToday)); 
			    	System.out.println("Days Passed " + milliSecondsDaysPassed); 
			    	System.out.println("Ninety Days " + milliSecondsNinetyDays); 
		    	
		    	
			    	if (milliSecondsDaysPassed>milliSecondsNinetyDays){
			    		System.out.println("Password EXPIRED");
			    		JOptionPane.showMessageDialog(null, "Your password has expired.");
			    		return "-2";
			    	}	
			    	System.out.println("Password NOT Expired");	
		    	}

		    	
		    	
		    	
	    		if (decrypted.split(",")[2].equals("Administrator")){
	    			return "3"; //Administrator
	    		}else if (decrypted.split(",")[2].equals("Method Developer")){
	    			return "2"; //developer
	    		}else{
	    			return "1"; //operator
	    		}
	    	}else{//password did not match
	    		JOptionPane.showMessageDialog(null, "Incorrect Password");
	    		onTop(true);//APN0049
	    		passwordFailed = true;
	    		return "0"; //Failed to Login
	    	}
	    }else{//Username was not found
	    	JOptionPane.showMessageDialog(null, "Username not found!");
	    	onTop(true);//APN0049
	    	return "0";  //Failed to Login
	    }	    
	}

	/**
	 * This method loads scheme data into holding list  	
	 * 	
	 * @return void 	
	 */
	@SuppressWarnings("unchecked")
	public void loadAccount() {
		
		arrayList_userData.clear();
		arrayList_userData_Encrypted.clear();
	    
		try { 
			String data = "";
			String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
			File f = new File(filename);
			input = new FileInputStream ( f );
			final BufferedReader bw = new BufferedReader(new FileReader(f));

			userName = "";
		    while ((data = bw.readLine()) != null) {	
				
				System.out.println("UAW   -   " + data);
		    	  
		    	decrypted = CryptoMessage.decrypt(data);
		    	  
		    	System.out.println("UAW   -   " + decrypted);
		    	  
		    	arrayList_userData.add(decrypted);
		   }
		} 
		catch ( EOFException eof ) {
			try { 
				input.close();
				} catch ( IOException e ) {
				JOptionPane.showMessageDialog( this, 
						"Error Closing File" , 
						"Error", 
						JOptionPane.ERROR_MESSAGE );
				}
		}
		catch ( IOException e ) {
			JOptionPane.showMessageDialog( this, 
					"Error Opening File" , 
					"Error", 
					JOptionPane.ERROR_MESSAGE );
		}

		try { 
		input.close();
		} catch ( IOException e ) {
		JOptionPane.showMessageDialog( this, 
				"Error Closing File" , 
				"Error", 
				JOptionPane.ERROR_MESSAGE );
		}
	}
	
	private void saveAccount() {
		String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
		File f = new File(filename);
		try {
			final BufferedWriter bw = new BufferedWriter(new FileWriter(f));

			String saveData = "";
			String accountData = "";
			String encrypted ="";
			arrayList_userData_Encrypted.clear();
			for (int i=0; i < arrayList_userData.size(); i++){
				accountData = arrayList_userData.get(i);
				userName = accountData.split(",")[0];
				
				//APN0056  Setting password as deactivated with string "rev".
		    	if (userName.equals(userNameEntered)){
		    		saveData = userName + "," + "rev" + ","  + accountData.split(",")[2] + "," + accountData.split(",")[3] + "," + "2";
					encrypted = CryptoMessage.encrypt(saveData);
					arrayList_userData.set(i,saveData);
					System.out.println("Account Revoked " + saveData); 
		    	}else{
		    		encrypted = CryptoMessage.encrypt(accountData);
		    	}

		    	arrayList_userData_Encrypted.add(encrypted);		
			}		

			for (int i=0; i < arrayList_userData_Encrypted.size(); i++){
			    bw.write(arrayList_userData_Encrypted.get(i)) ;
				bw.newLine();				
			}
			bw.close( );

		} catch (final FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (final IOException e1) {
			e1.printStackTrace();
		}
	}
	
	private void onTop (boolean b){//APN0049
		this.setAlwaysOnTop(b);
	}
	private void vis (boolean b){
		this.setVisible(b);
	}

}
