/**
 	 * AutoPilot - MovePlatePanel02
	 * Copyright 	- Telos Scientific - 
	 * Author 		- Jesse A. Campbell
	 * Description	- Move Plate  
	 * 
	 * Version update information
	 * 
	 * 02.08.14 RSC - Class created - Move Plate V02.  
	 * 02.14.14 RSC - platesAll change.				
	 * 				*/

package TelosV2Pkg;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JLabel;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import java.awt.Component;
import javax.swing.JButton;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;


public class MovePlatePanel02 extends JPanel {
	private JTextField mvp_text_1;
	private JTextField mvp_text_2;
	private String startloc;
	private String endloc;
	private String plate;
	private Color panelColor = new Color(248, 248, 255);
    private JComboBox mvp_comboBox = null;
    private JComboBox mvp_comboBox_2 = null;
    private JComboBox mvp_comboBox_3 = null;
    private JComboBox mvp_comboBox_4 = null;
    private int tindex = 0;
    private int cindex = 0;
    private int pindex = 0;
    private Dimension mvpSize1 = null, mvpSize2 = null, mvpSize3 = null, 
    				  mvpSize4 = null, mvpSize5 = null;
//    private TabWindow tab = new TabWindow();
	/**
	 * This is the default constructor
	 */

	public MovePlatePanel02(String[] plates, String[] platetypes) {
 		  String [] platesAll = new String [plates.length];
 		  String [] plateTypes = new String [platetypes.length - 1];
	      for (int i = 0; i < plates.length; i++) {
	          platesAll[i] = plates[i] ;
	        }
	      for (int i = 1; i < platetypes.length; i++) {
	          plateTypes[i - 1] = platetypes[i] ;
	        }

		setSize(650, 424);
	    setBackground(panelColor);
	    setAlignmentX(Component.LEFT_ALIGNMENT);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{53, 15, 146, 96, 57, 75, 40};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 1.0, 0.0, 0.0,0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		JLabel label_4 = new JLabel("       ");
		GridBagConstraints gbc_label_4 = new GridBagConstraints();
		gbc_label_4.insets = new Insets(0, 0, 5, 5);
		gbc_label_4.anchor = GridBagConstraints.EAST;
		gbc_label_4.gridx = 0;
		gbc_label_4.gridy = 2;
		add(label_4, gbc_label_4);

		
		Object[] items =
		        {
				    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_Instruction.png"),
				    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_Without_Cover.png"),
				    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_With_Cover.png"),
		            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/Move_Cover.png")
		        };
			  this.mvp_comboBox = new JComboBox( items );
			  mvp_comboBox.setPreferredSize(new Dimension(238, 35));
			  mvp_comboBox.setMinimumSize(new Dimension(238, 35));
	          this.mvp_comboBox.setSelectedIndex(0);
	          tindex = this.mvp_comboBox.getSelectedIndex();
	          this.mvp_comboBox.addActionListener(new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            JComboBox cb = (JComboBox)e.getSource();
	            tindex = (cb.getSelectedIndex());
	        } } );
  	    mvp_comboBox.setSize(new Dimension(230, 35));
  	    mvp_comboBox.setMaximumSize(new Dimension(230, 35));
  	    mvpSize1 = mvp_comboBox.getPreferredSize();      
	    mvp_comboBox.setBackground(panelColor);
		GridBagConstraints gbc_mvp_comboBox = new GridBagConstraints();
		gbc_mvp_comboBox.anchor = GridBagConstraints.WEST;
		gbc_mvp_comboBox.gridwidth = 2;
		gbc_mvp_comboBox.insets = new Insets(0, 0, 5, 5);
		gbc_mvp_comboBox.gridx = 1;
		gbc_mvp_comboBox.gridy = 2;
		add(mvp_comboBox, gbc_mvp_comboBox);
		
		JLabel label_2 = new JLabel("");
		GridBagConstraints gbc_label_2 = new GridBagConstraints();
		gbc_label_2.insets = new Insets(0, 0, 5, 5);
		gbc_label_2.gridx = 3;
		gbc_label_2.gridy = 2;
		add(label_2, gbc_label_2);
		
		JLabel label = new JLabel("");
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.gridx = 1;
		gbc_label.gridy = 3;
		add(label, gbc_label);
		
		JLabel label_5 = new JLabel("");
		GridBagConstraints gbc_label_5 = new GridBagConstraints();
		gbc_label_5.insets = new Insets(0, 0, 5, 5);
		gbc_label_5.gridx = 0;
		gbc_label_5.gridy = 4;
		add(label_5, gbc_label_5);
		
		JLabel lblNewLabel = new JLabel(" Start location/s:");
		lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.gridx = 1;
		gbc_lblNewLabel.gridy = 4;
	    mvpSize2 = lblNewLabel.getPreferredSize();      
		add(lblNewLabel, gbc_lblNewLabel);
		
		mvp_text_1 = new JTextField();
		GridBagConstraints gbc_text_1 = new GridBagConstraints();
		gbc_text_1.anchor = GridBagConstraints.WEST;
		gbc_text_1.insets = new Insets(0, 0, 5, 5);
		gbc_text_1.gridx = 2;
		gbc_text_1.gridy = 4;
//		mvp_text_1.setColumns(11);
	    mvpSize3 = mvp_text_1.getPreferredSize();
	    mvp_text_1.setPreferredSize(new Dimension(145, 28));
		add(mvp_text_1, gbc_text_1);
		
		ImageIcon icon = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/question.png");

		JLabel label_7 = new JLabel(icon);
		GridBagConstraints gbc_label_7 = new GridBagConstraints();
		gbc_label_7.anchor = GridBagConstraints.WEST;
		gbc_label_7.insets = new Insets(0, 0, 5, 5);
		gbc_label_7.gridx = 3;
		gbc_label_7.gridy = 2;
		label_7.setToolTipText("Select the move type");
		add(label_7, gbc_label_7);
		

		
		JLabel lblTest = new JLabel(icon);
		lblTest.setToolTipText("Enter START locations and/or location ranges.  For example, 1,2,5-7");
		GridBagConstraints gbc_lblTest = new GridBagConstraints();
		gbc_lblTest.anchor = GridBagConstraints.WEST;
		gbc_lblTest.insets = new Insets(0, 0, 5, 5);
		gbc_lblTest.gridx = 3;
		gbc_lblTest.gridy = 4;
		add(lblTest, gbc_lblTest);
		
		JLabel label_1 = new JLabel("");
		GridBagConstraints gbc_label_1 = new GridBagConstraints();
		gbc_label_1.insets = new Insets(0, 0, 5, 5);
		gbc_label_1.gridx = 1;
		gbc_label_1.gridy = 5;
		add(label_1, gbc_label_1);
		
		JLabel lblNewLabel_1 = new JLabel(" End location/s:");
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_lblNewLabel_1 = new GridBagConstraints();
		gbc_lblNewLabel_1.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_1.gridx = 1;
		gbc_lblNewLabel_1.gridy = 6;
		add(lblNewLabel_1, gbc_lblNewLabel_1);
		
		mvp_text_2 = new JTextField();
		GridBagConstraints gbc_text_2 = new GridBagConstraints();
		gbc_text_2.anchor = GridBagConstraints.WEST;
		gbc_text_2.insets = new Insets(0, 0, 5, 5);
		gbc_text_2.gridx = 2;
		gbc_text_2.gridy = 6;
		add(mvp_text_2, gbc_text_2);
	    mvp_text_2.setPreferredSize(new Dimension(145, 28));
//		mvp_text_2.setColumns(11);
		
        this.mvp_comboBox_2 = new JComboBox( platesAll );
		mvp_comboBox_2.setMinimumSize(new Dimension(245, 35));
	    mvp_comboBox_2.setPreferredSize(new Dimension(145, 28));
	    mvp_comboBox_2.setSelectedIndex(0);
	    plate = ((String)mvp_comboBox_2.getSelectedItem());
        pindex = this.mvp_comboBox_2.getSelectedIndex();
	    mvp_comboBox_2.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        JComboBox cb = (JComboBox)e.getSource();
	        plate = ((String)cb.getSelectedItem());
            pindex = (cb.getSelectedIndex());
	      } } );
		
		JLabel lblNewLabel_2 = new JLabel(" Plate type:");
		GridBagConstraints gbc_lblNewLabel_2 = new GridBagConstraints();
		gbc_lblNewLabel_2.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_2.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel_2.gridx = 1;
		gbc_lblNewLabel_2.gridy = 7;
		add(lblNewLabel_2, gbc_lblNewLabel_2);
		
		GridBagConstraints gbc_comboBox_2 = new GridBagConstraints();
		gbc_comboBox_2.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_2.anchor = GridBagConstraints.WEST;
		gbc_comboBox_2.gridwidth = 1;
		gbc_comboBox_2.gridx = 2;
		gbc_comboBox_2.gridy = 7;
		add(mvp_comboBox_2, gbc_comboBox_2);
		
		JLabel label_3 = new JLabel(icon);
		GridBagConstraints gbc_label_3 = new GridBagConstraints();
		gbc_label_3.anchor = GridBagConstraints.WEST;
		gbc_label_3.insets = new Insets(0, 0, 5, 5);
		gbc_label_3.gridx = 3;
		gbc_label_3.gridy = 6;
		label_3.setToolTipText("Enter END locations and/or location ranges.  For example, 1,2,5-7");
		add(label_3, gbc_label_3);

		JLabel label_6 = new JLabel(icon);
		GridBagConstraints gbc_label_6 = new GridBagConstraints();
		gbc_label_6.anchor = GridBagConstraints.WEST;
		gbc_label_6.insets = new Insets(0, 0, 5, 5);
		gbc_label_6.gridx = 3;
		gbc_label_6.gridy = 7;
		label_6.setToolTipText("Select the type of plate that will be moved.");
		add(label_6, gbc_label_6);
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}
	

	public String getStartLoc() {
	startloc = mvp_text_1.getText();	
	return startloc;

	}
	public String getEndLoc() {
	endloc = mvp_text_2.getText();	
	return endloc;
	}

	public int getTypeIndex() {
	return tindex;
	}

	public String getPlateType() {
	return plate;
	}

	public int getPlateIndex() {
	return pindex;
	}

	
	private String removeWhiteSpace(String s)
	  {
		  String stringIn = s;
		  String stringTrim = stringIn.trim();
		  String stringOut = stringTrim.replaceAll("\\s", "");
		  return stringOut;
	  }

	  private boolean cytCheckInputs(String c, String d){
		  boolean returnVal = true;
		  int commasc = 0;
		  for(int i = 0; i < c.length(); i++) {
		      if(c.charAt(i) == ',') commasc++;
		  }
		  int commasd = 0;
		  for(int i = 0; i < d.length(); i++) {
		      if(d.charAt(i) == ',') commasd++;
		  }
		  if (commasc != commasd)
		  returnVal = false;
		  
		  return returnVal;
	  }

	public void setText1( String s ){
		mvp_text_1.setText(s);
	}
	  
	public void setText2( String s ){
		mvp_text_2.setText(s);
	}
	  
	public void setPlateIndex( int index ){
		mvp_comboBox_2.setSelectedIndex(index);
	}
	
	public void setTypeIndex( int index ){
		mvp_comboBox.setSelectedIndex(index);
	}
	
}
