	/**
	 * Copyright 	- Telos Scientific - 05/24/2014
	 * Author 		- Jesse A Campbell
	 * Description	- Panel Object - 48 well plate object (Auto Pilot 1.0)
	 * 
 	 * Version update information
	 * 
	 * 05.27.14 RSC - Class created - Update SetButtons method with icon flip. 
	 * 01.03.14 JC  - update 001 - Modified Borders to add padding and shadow 
	 * 				  update 002   Standardized button text
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridLayout;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import javax.swing.border.Border;

import org.jdesktop.swingx.JXPanel;
import org.jdesktop.swingx.border.DropShadowBorder;

import java.awt.Insets;

public class Panel24 extends JXPanel {
	
	private static final long serialVersionUID = 1L;
	
	private JPanel trayPanel = null;

    Border blackline = BorderFactory.createLineBorder(Color.black, 3);

    private Color plateColor = new Color(240, 240, 240);		//update 001
    private Color panelColor = new Color(248, 248, 255);		//update 001

    private String tray = "";

	Icon buttonicon1 = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/radiobutton6.png"); 
	Icon buttonicon2 = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/radiobutton5.png"); 

	private JRadioButton JRadioButton1 = null;
	
	private JRadioButton JRadioButton2 = null;
	
	private JRadioButton JRadioButton3 = null;
	
	private JRadioButton JRadioButton4 = null;
	
	private JRadioButton JRadioButton5 = null;
	
	private JRadioButton JRadioButton6 = null;
	
	private JRadioButton JRadioButton7 = null;
	
	private JRadioButton JRadioButton8 = null;
	
	private JRadioButton JRadioButton9 = null;
	
	private JRadioButton JRadioButton10 = null;
	
	private JRadioButton JRadioButton11 = null;
	
	private JRadioButton JRadioButton12 = null;
	
	private JRadioButton JRadioButton13 = null;
	
	private JRadioButton JRadioButton14 = null;
	
	private JRadioButton JRadioButton15 = null;
	
	private JRadioButton JRadioButton16 = null;
	
	private JRadioButton JRadioButton17 = null;
	
	private JRadioButton JRadioButton18 = null;
	
	private JRadioButton JRadioButton19 = null;
	
	private JRadioButton JRadioButton20 = null;
	
	private JRadioButton JRadioButton21 = null;
	
	private JRadioButton JRadioButton22 = null;
	
	private JRadioButton JRadioButton23 = null;
	
	private JRadioButton JRadioButton24 = null;
	
	
	private JButton allButton = null;

	private JButton oneButton = null;

	private JButton twoButton = null;

	private JButton thrButton = null;

	private JButton fouButton = null;

	private JButton fivButton = null;

	private JButton sixButton = null;

	private JButton aButton = null;

	private JButton bButton = null;

	private JButton cButton = null;

	private JButton dButton = null;

	private JLabel label1 = new JLabel( "     ");  

    Font font96 = new Font("Arial", Font.PLAIN, 10);				//update 002
	
    private boolean allselect = false;
    
	/**
	 * This is the default constructor
	 */
	public Panel24() {
		super();
		initialize();
	}

	/**
	 * This repaint the JPanel */
	
	public void paintComponent( Graphics g ) {
		super.paintComponent( g );
//      if ( pane == 1 )
//		
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(650, 424);
		this.setLayout(new BorderLayout());
		this.setBorder(BorderFactory.createEmptyBorder(10,0,10,10));			//update 001
		this.setBackground(panelColor);											//update 001
		this.add(getTrayPanel(), BorderLayout.CENTER);

	}


	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getallButton() {
		if (allButton == null) {
			allButton = new JButton();
		    allButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (allselect == false) 
					{
					JRadioButton1.setSelected(true);
					JRadioButton1.setIcon(buttonicon2);
					JRadioButton2.setSelected(true);
					JRadioButton2.setIcon(buttonicon2);
					JRadioButton3.setSelected(true);
					JRadioButton3.setIcon(buttonicon2);
					JRadioButton4.setSelected(true);
					JRadioButton4.setIcon(buttonicon2);
					JRadioButton5.setSelected(true);
					JRadioButton5.setIcon(buttonicon2);
					JRadioButton6.setSelected(true);
					JRadioButton6.setIcon(buttonicon2);
					JRadioButton7.setSelected(true);
					JRadioButton7.setIcon(buttonicon2);
					JRadioButton8.setSelected(true);
					JRadioButton8.setIcon(buttonicon2);
					JRadioButton9.setSelected(true);
					JRadioButton9.setIcon(buttonicon2);
					JRadioButton10.setSelected(true);
					JRadioButton10.setIcon(buttonicon2);
					JRadioButton11.setSelected(true);
					JRadioButton11.setIcon(buttonicon2);
					JRadioButton12.setSelected(true);
					JRadioButton12.setIcon(buttonicon2);
					JRadioButton13.setSelected(true);
					JRadioButton13.setIcon(buttonicon2);
					JRadioButton14.setSelected(true);
					JRadioButton14.setIcon(buttonicon2);
					JRadioButton15.setSelected(true);
					JRadioButton15.setIcon(buttonicon2);
					JRadioButton16.setSelected(true);
					JRadioButton16.setIcon(buttonicon2);
					JRadioButton17.setSelected(true);
					JRadioButton17.setIcon(buttonicon2);
					JRadioButton18.setSelected(true);
					JRadioButton18.setIcon(buttonicon2);
					JRadioButton19.setSelected(true);
					JRadioButton19.setIcon(buttonicon2);
					JRadioButton20.setSelected(true);
					JRadioButton20.setIcon(buttonicon2);
					JRadioButton21.setSelected(true);
					JRadioButton21.setIcon(buttonicon2);
					JRadioButton22.setSelected(true);
					JRadioButton22.setIcon(buttonicon2);
					JRadioButton23.setSelected(true);
					JRadioButton23.setIcon(buttonicon2);
					JRadioButton24.setSelected(true);
					JRadioButton24.setIcon(buttonicon2);
					allselect = true;
				    }
					else 
					{
					JRadioButton1.setSelected(false);
					JRadioButton1.setIcon(buttonicon1);
					JRadioButton2.setSelected(false);
					JRadioButton2.setIcon(buttonicon1);
					JRadioButton3.setSelected(false);
					JRadioButton3.setIcon(buttonicon1);
					JRadioButton4.setSelected(false);
					JRadioButton4.setIcon(buttonicon1);
					JRadioButton5.setSelected(false);
					JRadioButton5.setIcon(buttonicon1);
					JRadioButton6.setSelected(false);
					JRadioButton6.setIcon(buttonicon1);
					JRadioButton7.setSelected(false);
					JRadioButton7.setIcon(buttonicon1);
					JRadioButton8.setSelected(false);
					JRadioButton8.setIcon(buttonicon1);
					JRadioButton9.setSelected(false);
					JRadioButton9.setIcon(buttonicon1);
					JRadioButton10.setSelected(false);
					JRadioButton10.setIcon(buttonicon1);
					JRadioButton11.setSelected(false);
					JRadioButton11.setIcon(buttonicon1);
					JRadioButton12.setSelected(false);
					JRadioButton12.setIcon(buttonicon1);
					JRadioButton13.setSelected(false);
					JRadioButton13.setIcon(buttonicon1);
					JRadioButton14.setSelected(false);
					JRadioButton14.setIcon(buttonicon1);
					JRadioButton15.setSelected(false);
					JRadioButton15.setIcon(buttonicon1);
					JRadioButton16.setSelected(false);
					JRadioButton16.setIcon(buttonicon1);
					JRadioButton17.setSelected(false);
					JRadioButton17.setIcon(buttonicon1);
					JRadioButton18.setSelected(false);
					JRadioButton18.setIcon(buttonicon1);
					JRadioButton19.setSelected(false);
					JRadioButton19.setIcon(buttonicon1);
					JRadioButton20.setSelected(false);
					JRadioButton20.setIcon(buttonicon1);
					JRadioButton21.setSelected(false);
					JRadioButton21.setIcon(buttonicon1);
					JRadioButton22.setSelected(false);
					JRadioButton22.setIcon(buttonicon1);
					JRadioButton23.setSelected(false);
					JRadioButton23.setIcon(buttonicon1);
					JRadioButton24.setSelected(false);
					JRadioButton24.setIcon(buttonicon1);
					allselect = false;
				    }
              }
			});

		}
		return allButton;
	}

	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getoneButton() {
		if (oneButton == null) {
			oneButton = new JButton();
			oneButton.setText("1");
		    oneButton.setFont( font96 ); 
		    oneButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton1.isSelected() && JRadioButton2.isSelected() &&
							JRadioButton3.isSelected() && JRadioButton4.isSelected() 
							) 
					{
					JRadioButton1.setSelected(false);
					JRadioButton1.setIcon(buttonicon1);
					JRadioButton2.setSelected(false);
					JRadioButton2.setIcon(buttonicon1);
					JRadioButton3.setSelected(false);
					JRadioButton3.setIcon(buttonicon1);
					JRadioButton4.setSelected(false);
					JRadioButton4.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
					JRadioButton1.setSelected(true);
					JRadioButton1.setIcon(buttonicon2);
					JRadioButton2.setSelected(true);
					JRadioButton2.setIcon(buttonicon2);
					JRadioButton3.setSelected(true);
					JRadioButton3.setIcon(buttonicon2);
					JRadioButton4.setSelected(true);
					JRadioButton4.setIcon(buttonicon2);
					}
				}
			});

		}
		return oneButton;
	}
	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton gettwoButton() {
		if (twoButton == null) {
			twoButton = new JButton();
			twoButton.setText("2");
		    twoButton.setFont( font96 ); 
		    twoButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton5.isSelected() && JRadioButton6.isSelected() &&
							JRadioButton7.isSelected() && JRadioButton8.isSelected()  
							) 
					{
						JRadioButton5.setSelected(false);
						JRadioButton5.setIcon(buttonicon1);
						JRadioButton6.setSelected(false);
						JRadioButton6.setIcon(buttonicon1);
						JRadioButton7.setSelected(false);
						JRadioButton7.setIcon(buttonicon1);
						JRadioButton8.setSelected(false);
						JRadioButton8.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton5.setSelected(true);
						JRadioButton5.setIcon(buttonicon2);
						JRadioButton6.setSelected(true);
						JRadioButton6.setIcon(buttonicon2);
						JRadioButton7.setSelected(true);
						JRadioButton7.setIcon(buttonicon2);
						JRadioButton8.setSelected(true);
						JRadioButton8.setIcon(buttonicon2);
					}
				}
			});

		}
		return twoButton;
	}
	
	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getthrButton() {
		if (thrButton == null) {
			thrButton = new JButton();
			thrButton.setText("3");
		    thrButton.setFont( font96 ); 
		    thrButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton9.isSelected() && JRadioButton10.isSelected() &&
							JRadioButton11.isSelected() && JRadioButton12.isSelected() 
							) 
					{
					JRadioButton9.setSelected(false);
					JRadioButton9.setIcon(buttonicon1);
					JRadioButton10.setSelected(false);
					JRadioButton10.setIcon(buttonicon1);
					JRadioButton11.setSelected(false);
					JRadioButton11.setIcon(buttonicon1);
					JRadioButton12.setSelected(false);
					JRadioButton12.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton9.setSelected(true);
						JRadioButton9.setIcon(buttonicon2);
						JRadioButton10.setSelected(true);
						JRadioButton10.setIcon(buttonicon2);
						JRadioButton11.setSelected(true);
						JRadioButton11.setIcon(buttonicon2);
						JRadioButton12.setSelected(true);
						JRadioButton12.setIcon(buttonicon2);
					}
				}
			});

		}
		return thrButton;
	}
	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getfouButton() {
		if (fouButton == null) {
			fouButton = new JButton();
			fouButton.setText("4");
		    fouButton.setFont( font96 ); 
		    fouButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton13.isSelected() && JRadioButton14.isSelected() &&
							JRadioButton15.isSelected() && JRadioButton16.isSelected() 
							) 
					{
						JRadioButton13.setSelected(false);
						JRadioButton13.setIcon(buttonicon1);
						JRadioButton14.setSelected(false);
						JRadioButton14.setIcon(buttonicon1);
						JRadioButton15.setSelected(false);
						JRadioButton15.setIcon(buttonicon1);
						JRadioButton16.setSelected(false);
						JRadioButton16.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton13.setSelected(true);
						JRadioButton13.setIcon(buttonicon2);
						JRadioButton14.setSelected(true);
						JRadioButton14.setIcon(buttonicon2);
						JRadioButton15.setSelected(true);
						JRadioButton15.setIcon(buttonicon2);
						JRadioButton16.setSelected(true);
						JRadioButton16.setIcon(buttonicon2);
					}
				}
			});

		}
		return fouButton;
	}
	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getfivButton() {
		if (fivButton == null) {
			fivButton = new JButton();
			fivButton.setText("5");
		    fivButton.setFont( font96 ); 
		    fivButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton17.isSelected() && JRadioButton18.isSelected() &&
							JRadioButton19.isSelected() && JRadioButton20.isSelected() 
							) 
					{
						JRadioButton17.setSelected(false);
						JRadioButton17.setIcon(buttonicon1);
						JRadioButton18.setSelected(false);
						JRadioButton18.setIcon(buttonicon1);
						JRadioButton19.setSelected(false);
						JRadioButton19.setIcon(buttonicon1);
						JRadioButton20.setSelected(false);
						JRadioButton20.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton17.setSelected(true);
						JRadioButton17.setIcon(buttonicon2);
						JRadioButton18.setSelected(true);
						JRadioButton18.setIcon(buttonicon2);
						JRadioButton19.setSelected(true);
						JRadioButton19.setIcon(buttonicon2);
						JRadioButton20.setSelected(true);
						JRadioButton20.setIcon(buttonicon2);
					}
				}
			});

		}
		return fivButton;
	}
	/**
	 * This method initializes oneBon	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getsixButton() {
		if (sixButton == null) {
			sixButton = new JButton();
			sixButton.setText("6");
		    sixButton.setFont( font96 ); 
		    sixButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton21.isSelected() && JRadioButton22.isSelected() &&
							JRadioButton23.isSelected() && JRadioButton24.isSelected() 
							) 
					{
						JRadioButton21.setSelected(false);
						JRadioButton21.setIcon(buttonicon1);
						JRadioButton22.setSelected(false);
						JRadioButton22.setIcon(buttonicon1);
						JRadioButton23.setSelected(false);
						JRadioButton23.setIcon(buttonicon1);
						JRadioButton24.setSelected(false);
						JRadioButton24.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton21.setSelected(true);
						JRadioButton21.setIcon(buttonicon2);
						JRadioButton22.setSelected(true);
						JRadioButton22.setIcon(buttonicon2);
						JRadioButton23.setSelected(true);
						JRadioButton23.setIcon(buttonicon2);
						JRadioButton24.setSelected(true);
						JRadioButton24.setIcon(buttonicon2);
					}
				}
			});

		}
		return sixButton;
	}
	
	/**
	 * This method initializes aButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getaButton() {
		if (aButton == null) {
			aButton = new JButton();
			aButton.setText("A");
			aButton.setFont( font96 ); 															//update 002
		    aButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton1.isSelected() && JRadioButton5.isSelected() &&
							JRadioButton9.isSelected() && JRadioButton13.isSelected() &&
							JRadioButton17.isSelected() && JRadioButton21.isSelected() 
							) 
					{
						JRadioButton1.setSelected(false);
						JRadioButton1.setIcon(buttonicon1);
						JRadioButton5.setSelected(false);
						JRadioButton5.setIcon(buttonicon1);
						JRadioButton9.setSelected(false);
						JRadioButton9.setIcon(buttonicon1);
						JRadioButton13.setSelected(false);
						JRadioButton13.setIcon(buttonicon1);
						JRadioButton17.setSelected(false);
						JRadioButton17.setIcon(buttonicon1);
						JRadioButton21.setSelected(false);
						JRadioButton21.setIcon(buttonicon1);
						select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton1.setSelected(true);
						JRadioButton1.setIcon(buttonicon2);
						JRadioButton5.setSelected(true);
						JRadioButton5.setIcon(buttonicon2);
						JRadioButton9.setSelected(true);
						JRadioButton9.setIcon(buttonicon2);
						JRadioButton13.setSelected(true);
						JRadioButton13.setIcon(buttonicon2);
						JRadioButton17.setSelected(true);
						JRadioButton17.setIcon(buttonicon2);
						JRadioButton21.setSelected(true);
						JRadioButton21.setIcon(buttonicon2);
					}
			
				}
			});

		}
		return aButton;
	}
	
	/**
	 * This method initializes bButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getbButton() {
		if (bButton == null) {
			bButton = new JButton();
			bButton.setText("B");
			bButton.setFont( font96 ); 															//update 002
		    bButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton2.isSelected() && JRadioButton6.isSelected() &&
							JRadioButton10.isSelected() && JRadioButton14.isSelected()&&  
							JRadioButton18.isSelected() && JRadioButton22.isSelected() 
							) 
					{
						JRadioButton2.setSelected(false);
						JRadioButton2.setIcon(buttonicon1);
						JRadioButton6.setSelected(false);
						JRadioButton6.setIcon(buttonicon1);
						JRadioButton10.setSelected(false);
						JRadioButton10.setIcon(buttonicon1);
						JRadioButton14.setSelected(false);
						JRadioButton14.setIcon(buttonicon1);
						JRadioButton18.setSelected(false);
						JRadioButton18.setIcon(buttonicon1);
						JRadioButton22.setSelected(false);
						JRadioButton22.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton2.setSelected(true);
						JRadioButton2.setIcon(buttonicon2);
						JRadioButton6.setSelected(true);
						JRadioButton6.setIcon(buttonicon2);
						JRadioButton10.setSelected(true);
						JRadioButton10.setIcon(buttonicon2);
						JRadioButton14.setSelected(true);
						JRadioButton14.setIcon(buttonicon2);
						JRadioButton18.setSelected(true);
						JRadioButton18.setIcon(buttonicon2);
						JRadioButton22.setSelected(true);
						JRadioButton22.setIcon(buttonicon2);
					}
					
				}
			});

		}
		return bButton;
	}
	
	/**
	 * This method initializes cButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getcButton() {
		if (cButton == null) {
			cButton = new JButton();
			cButton.setText("C");
			cButton.setFont( font96 ); 															//update 002
		    cButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton3.isSelected() && JRadioButton7.isSelected() &&
							JRadioButton11.isSelected() && JRadioButton15.isSelected() && 
							JRadioButton19.isSelected() && JRadioButton23.isSelected() 
							) 
					{
						JRadioButton3.setSelected(false);
						JRadioButton3.setIcon(buttonicon1);
						JRadioButton7.setSelected(false);
						JRadioButton7.setIcon(buttonicon1);
						JRadioButton11.setSelected(false);
						JRadioButton11.setIcon(buttonicon1);
						JRadioButton15.setSelected(false);
						JRadioButton15.setIcon(buttonicon1);
						JRadioButton19.setSelected(false);
						JRadioButton19.setIcon(buttonicon1);
						JRadioButton23.setSelected(false);
						JRadioButton23.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton3.setSelected(true);
						JRadioButton3.setIcon(buttonicon2);
						JRadioButton7.setSelected(true);
						JRadioButton7.setIcon(buttonicon2);
						JRadioButton11.setSelected(true);
						JRadioButton11.setIcon(buttonicon2);
						JRadioButton15.setSelected(true);
						JRadioButton15.setIcon(buttonicon2);
						JRadioButton19.setSelected(true);
						JRadioButton19.setIcon(buttonicon2);
						JRadioButton23.setSelected(true);
						JRadioButton23.setIcon(buttonicon2);
					}
			
				}
			});

		}
		return cButton;
	}
	
	/**
	 * This method initializes aButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getdButton() {
		if (dButton == null) {
			dButton = new JButton();
			dButton.setText("D");
			dButton.setFont( font96 ); 															//update 002
		    dButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					boolean select = false;
					if (JRadioButton4.isSelected() && JRadioButton8.isSelected() &&
							JRadioButton12.isSelected() && JRadioButton16.isSelected() &&
							JRadioButton20.isSelected() && JRadioButton24.isSelected() 
							) 
					{
						JRadioButton4.setSelected(false);
						JRadioButton4.setIcon(buttonicon1);
						JRadioButton8.setSelected(false);
						JRadioButton8.setIcon(buttonicon1);
						JRadioButton12.setSelected(false);
						JRadioButton12.setIcon(buttonicon1);
						JRadioButton16.setSelected(false);
						JRadioButton16.setIcon(buttonicon1);
						JRadioButton20.setSelected(false);
						JRadioButton20.setIcon(buttonicon1);
						JRadioButton24.setSelected(false);
						JRadioButton24.setIcon(buttonicon1);
					select = true;
					}
					if ( select == false ) 
					{	
						JRadioButton4.setSelected(true);
						JRadioButton4.setIcon(buttonicon2);
						JRadioButton8.setSelected(true);
						JRadioButton8.setIcon(buttonicon2);
						JRadioButton12.setSelected(true);
						JRadioButton12.setIcon(buttonicon2);
						JRadioButton16.setSelected(true);
						JRadioButton16.setIcon(buttonicon2);
						JRadioButton20.setSelected(true);
						JRadioButton20.setIcon(buttonicon2);
						JRadioButton24.setSelected(true);
						JRadioButton24.setIcon(buttonicon2);
					}
				}
			});

		}
		return dButton;
	}
	
	
	/**
	 * This method initializes JRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton1() {
		if (JRadioButton1 == null) {
			JRadioButton1 = new JRadioButton();
	        JRadioButton1.setIcon(buttonicon1);
	        JRadioButton1.setForeground(Color.black);
		    JRadioButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton1.isSelected())
					{
					  JRadioButton1.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton1.setIcon(buttonicon1);
					}
             }
			});

		}
		return JRadioButton1;
	}
	
	/**
	 * This method initializes JRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton2() {
		if (JRadioButton2 == null) {
			JRadioButton2 = new JRadioButton();
	        JRadioButton2.setIcon(buttonicon1);
		    JRadioButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton2.isSelected())
					{
					  JRadioButton2.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton2.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton2;
	}

	/**
	 * This method initializes JRadioButton3	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton3() {
		if (JRadioButton3 == null) {
			JRadioButton3 = new JRadioButton();
	        JRadioButton3.setIcon(buttonicon1);
		    JRadioButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton3.isSelected())
					{
					  JRadioButton3.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton3.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton3;
	}

	/**
	 * This method initializes JRadioButton4	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton4() {
		if (JRadioButton4 == null) {
			JRadioButton4 = new JRadioButton();
	        JRadioButton4.setIcon(buttonicon1);
		    JRadioButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton4.isSelected())
					{
					  JRadioButton4.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton4.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton4;
	}
	/**
	 * This method initializes JRadioButton5	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton5() {
		if (JRadioButton5 == null) {
			JRadioButton5 = new JRadioButton();
	        JRadioButton5.setIcon(buttonicon1);
		    JRadioButton5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton5.isSelected())
					{
					  JRadioButton5.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton5.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton5;
	}
	/**
	 * This method initializes JRadioButton6	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton6() {
		if (JRadioButton6 == null) {
			JRadioButton6 = new JRadioButton();
	        JRadioButton6.setIcon(buttonicon1);
		    JRadioButton6.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton6.isSelected())
					{
					  JRadioButton6.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton6.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton6;
	}
	/**
	 * This method initializes JRadioButton7	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton7() {
		if (JRadioButton7 == null) {
			JRadioButton7 = new JRadioButton();
	        JRadioButton7.setIcon(buttonicon1);
		    JRadioButton7.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton7.isSelected())
					{
					  JRadioButton7.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton7.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton7;
	}
	/**
	 * This method initializes JRadioButton8	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton8() {
		if (JRadioButton8 == null) {
			JRadioButton8 = new JRadioButton();
	        JRadioButton8.setIcon(buttonicon1);
		    JRadioButton8.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton8.isSelected())
					{
					  JRadioButton8.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton8.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton8;
	}
	/**
	 * This method initializes JRadioButton9	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton9() {
		if (JRadioButton9 == null) {
			JRadioButton9 = new JRadioButton();
	        JRadioButton9.setIcon(buttonicon1);
		    JRadioButton9.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton9.isSelected())
					{
					  JRadioButton9.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton9.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton9;
	}
	/**
	 * This method initializes JRadioButton10	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton10() {
		if (JRadioButton10 == null) {
			JRadioButton10 = new JRadioButton();
	        JRadioButton10.setIcon(buttonicon1);
		    JRadioButton10.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton10.isSelected())
					{
					  JRadioButton10.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton10.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton10;
	}
	/**
	 * This method initializes JRadioButton11	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton11() {
		if (JRadioButton11 == null) {
			JRadioButton11 = new JRadioButton();
	        JRadioButton11.setIcon(buttonicon1);
		    JRadioButton11.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton11.isSelected())
					{
					  JRadioButton11.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton11.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton11;
	}
	/**
	 * This method initializes JRadioButton12	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton12() {
		if (JRadioButton12 == null) {
			JRadioButton12 = new JRadioButton();
	        JRadioButton12.setIcon(buttonicon1);
		    JRadioButton12.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton12.isSelected())
					{
					  JRadioButton12.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton12.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton12;
	}
	/**
	 * This method initializes JRadioButton13	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton13() {
		if (JRadioButton13 == null) {
			JRadioButton13 = new JRadioButton();
	        JRadioButton13.setIcon(buttonicon1);
		    JRadioButton13.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton13.isSelected())
					{
					  JRadioButton13.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton13.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton13;
	}
	/**
	 * This method initializes JRadioButton14	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton14() {
		if (JRadioButton14 == null) {
			JRadioButton14 = new JRadioButton();
	        JRadioButton14.setIcon(buttonicon1);
		    JRadioButton14.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton14.isSelected())
					{
					  JRadioButton14.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton14.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton14;
	}
	/**
	 * This method initializes JRadioButton15	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton15() {
		if (JRadioButton15 == null) {
			JRadioButton15 = new JRadioButton();
	        JRadioButton15.setIcon(buttonicon1);
		    JRadioButton15.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton15.isSelected())
					{
					  JRadioButton15.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton15.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton15;
	}
	/**
	 * This method initializes JRadioButton16	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton16() {
		if (JRadioButton16 == null) {
			JRadioButton16 = new JRadioButton();
	        JRadioButton16.setIcon(buttonicon1);
		    JRadioButton16.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton16.isSelected())
					{
					  JRadioButton16.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton16.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton16;
	}
	/**
	 * This method initializes JRadioButton17	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton17() {
		if (JRadioButton17 == null) {
			JRadioButton17 = new JRadioButton();
	        JRadioButton17.setIcon(buttonicon1);
		    JRadioButton17.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton17.isSelected())
					{
					  JRadioButton17.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton17.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton17;
	}
	/**
	 * This method initializes JRadioButton18	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton18() {
		if (JRadioButton18 == null) {
			JRadioButton18 = new JRadioButton();
	        JRadioButton18.setIcon(buttonicon1);
		    JRadioButton18.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton18.isSelected())
					{
					  JRadioButton18.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton18.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton18;
	}
	/**
	 * This method initializes JRadioButton19	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton19() {
		if (JRadioButton19 == null) {
			JRadioButton19 = new JRadioButton();
	        JRadioButton19.setIcon(buttonicon1);
		    JRadioButton19.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton19.isSelected())
					{
					  JRadioButton19.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton19.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton19;
	}
	/**
	 * This method initializes JRadioButton20	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton20() {
		if (JRadioButton20 == null) {
			JRadioButton20 = new JRadioButton();
	        JRadioButton20.setIcon(buttonicon1);
		    JRadioButton20.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton20.isSelected())
					{
					  JRadioButton20.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton20.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton20;
	}
	/**
	 * This method initializes JRadioButton21	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton21() {
		if (JRadioButton21 == null) {
			JRadioButton21 = new JRadioButton();
	        JRadioButton21.setIcon(buttonicon1);
		    JRadioButton21.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton21.isSelected())
					{
					  JRadioButton21.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton21.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton21;
	}
	/**
	 * This method initializes JRadioButton22	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton22() {
		if (JRadioButton22 == null) {
			JRadioButton22 = new JRadioButton();
	        JRadioButton22.setIcon(buttonicon1);
		    JRadioButton22.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton22.isSelected())
					{
					  JRadioButton22.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton22.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton22;
	}
	/**
	 * This method initializes JRadioButton23	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton23() {
		if (JRadioButton23 == null) {
			JRadioButton23 = new JRadioButton();
	        JRadioButton23.setIcon(buttonicon1);
		    JRadioButton23.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton23.isSelected())
					{
					  JRadioButton23.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton23.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton23;
	}
	/**
	 * This method initializes JRadioButton24	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButton24() {
		if (JRadioButton24 == null) {
			JRadioButton24 = new JRadioButton();
	        JRadioButton24.setIcon(buttonicon1);
		    JRadioButton24.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					if (JRadioButton24.isSelected())
					{
					  JRadioButton24.setIcon(buttonicon2);
					}
					else
					{
					  JRadioButton24.setIcon(buttonicon1);
					}
             }
			});
		}
		return JRadioButton24;
	}
	/**
	 * This method initializes trayPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getTrayPanel() {
		if (trayPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(5);
			gridLayout.setColumns(7);
			trayPanel = new JPanel();
			trayPanel.setBackground(this.plateColor);			//update 001
			DropShadowBorder shadow = new DropShadowBorder();	//update 001
			shadow.setShadowColor(Color.black);					//update 001
			shadow.setShadowOpacity((float) 0.6);				//update 001
			shadow.setShadowSize(6);							//update 001
			shadow.setShowLeftShadow(true);						//update 001
			shadow.setShowRightShadow(true);					//update 001
			shadow.setShowBottomShadow(true);					//update 001
			shadow.setShowTopShadow(true);						//update 001
			trayPanel.setBorder(shadow);						//update 001
			
			trayPanel.setLayout(gridLayout);

			
			trayPanel.add(getallButton());
			trayPanel.add(getoneButton());
			trayPanel.add(gettwoButton());
			trayPanel.add(getthrButton());
			trayPanel.add(getfouButton());
			trayPanel.add(getfivButton());
			trayPanel.add(getsixButton());
			
			trayPanel.add(getaButton());
			trayPanel.add(getJRadioButton1());
			trayPanel.add(getJRadioButton5());
			trayPanel.add(getJRadioButton9());
			trayPanel.add(getJRadioButton13());
			trayPanel.add(getJRadioButton17());
			trayPanel.add(getJRadioButton21());

			trayPanel.add(getbButton());
			trayPanel.add(getJRadioButton2());
			trayPanel.add(getJRadioButton6());
			trayPanel.add(getJRadioButton10());
			trayPanel.add(getJRadioButton14());
			trayPanel.add(getJRadioButton18());
			trayPanel.add(getJRadioButton22());

			trayPanel.add(getcButton());
			trayPanel.add(getJRadioButton3());
			trayPanel.add(getJRadioButton7());
			trayPanel.add(getJRadioButton11());
			trayPanel.add(getJRadioButton15());
			trayPanel.add(getJRadioButton19());
			trayPanel.add(getJRadioButton23());
			
			trayPanel.add(getdButton());
			trayPanel.add(getJRadioButton4());
			trayPanel.add(getJRadioButton8());
			trayPanel.add(getJRadioButton12());
			trayPanel.add(getJRadioButton16());
			trayPanel.add(getJRadioButton20());
			trayPanel.add(getJRadioButton24());
			
			
			JRadioButton1.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton2.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton3.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton4.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton5.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton6.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton7.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton8.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton9.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton10.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton11.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton12.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton13.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton14.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton15.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton16.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton17.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton18.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton19.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton20.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton21.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton22.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton23.setHorizontalAlignment(SwingConstants.CENTER);
			JRadioButton24.setHorizontalAlignment(SwingConstants.CENTER);

		 }
		return trayPanel;
	}

	
	public double dwnCount() {
		
		double dwn = 0;
		
		if (JRadioButton1.isSelected()) 
		{
			 dwn++;
		}
		if (JRadioButton2.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton3.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton4.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton5.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton6.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton7.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton8.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton9.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton10.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton11.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton12.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton13.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton14.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton15.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton16.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton17.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton18.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton19.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton20.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton21.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton22.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton23.isSelected()) 
		{
			dwn++;
		}
		if (JRadioButton24.isSelected()) 
		{
			dwn++;
		}
		
		return dwn;
	}
	
	
	public boolean CheckTray() {
		
		String tray_Check = "";
		boolean pass = true;
		
		if (JRadioButton1.isSelected()) 
		{
			tray_Check += "1," ;
		}
		if (JRadioButton2.isSelected()) 
		{
			tray_Check += "2," ;
		}
		if (JRadioButton3.isSelected()) 
		{
			tray_Check += "3," ;
		}
		if (JRadioButton4.isSelected()) 
		{
			tray_Check += "4," ;
		}
		if (JRadioButton5.isSelected()) 
		{
			tray_Check += "5," ;
		}
		if (JRadioButton6.isSelected()) 
		{
			tray_Check += "6," ;
		}
		if (JRadioButton7.isSelected()) 
		{
			tray_Check += "7," ;
		}
		if (JRadioButton8.isSelected()) 
		{
			tray_Check += "8," ;
		}
		if (JRadioButton9.isSelected()) 
		{
			tray_Check += "9," ;
		}
		if (JRadioButton10.isSelected()) 
		{
			tray_Check += "10," ;
		}
		if (JRadioButton11.isSelected()) 
		{
			tray_Check += "11," ;
		}
		if (JRadioButton12.isSelected()) 
		{
			tray_Check += "12," ;
		}
		if (JRadioButton13.isSelected()) 
		{
			tray_Check += "13," ;
		}
		if (JRadioButton14.isSelected()) 
		{
			tray_Check += "14," ;
		}
		if (JRadioButton15.isSelected()) 
		{
			tray_Check += "15," ;
		}
		if (JRadioButton16.isSelected()) 
		{
			tray_Check += "16," ;
		}
		if (JRadioButton17.isSelected()) 
		{
			tray_Check += "17," ;
		}
		if (JRadioButton18.isSelected()) 
		{
			tray_Check += "18," ;
		}
		if (JRadioButton19.isSelected()) 
		{
			tray_Check += "19," ;
		}
		if (JRadioButton20.isSelected()) 
		{
			tray_Check += "20," ;
		}
		if (JRadioButton21.isSelected()) 
		{
			tray_Check += "21," ;
		}
		if (JRadioButton22.isSelected()) 
		{
			tray_Check += "22," ;
		}
		if (JRadioButton23.isSelected()) 
		{
			tray_Check += "23," ;
		}
		if (JRadioButton24.isSelected()) 
		{
			tray_Check += "24," ;
		}
		if (tray_Check.equals("")){pass = false;}
		return pass;
	}
	
	
	void loadTray() {
		
		tray = "";

		if (JRadioButton1.isSelected()) 
		{
			 tray += "1," ;
		}
		if (JRadioButton2.isSelected()) 
		{
			 tray += "2," ;
		}
		if (JRadioButton3.isSelected()) 
		{
			 tray += "3," ;
		}
		if (JRadioButton4.isSelected()) 
		{
			 tray += "4," ;
		}
		if (JRadioButton5.isSelected()) 
		{
			 tray += "5," ;
		}
		if (JRadioButton6.isSelected()) 
		{
			 tray += "6," ;
		}
		if (JRadioButton7.isSelected()) 
		{
			 tray += "7," ;
		}
		if (JRadioButton8.isSelected()) 
		{
			 tray += "8," ;
		}
		if (JRadioButton9.isSelected()) 
		{
			 tray += "9," ;
		}
		if (JRadioButton10.isSelected()) 
		{
			 tray += "10," ;
		}
		if (JRadioButton11.isSelected()) 
		{
			 tray += "11," ;
		}
		if (JRadioButton12.isSelected()) 
		{
			 tray += "12," ;
		}
		if (JRadioButton13.isSelected()) 
		{
			 tray += "13," ;
		}
		if (JRadioButton14.isSelected()) 
		{
			 tray += "14," ;
		}
		if (JRadioButton15.isSelected()) 
		{
			 tray += "15," ;
		}
		if (JRadioButton16.isSelected()) 
		{
			 tray += "16," ;
		}
		if (JRadioButton17.isSelected()) 
		{
			 tray += "17," ;
		}
		if (JRadioButton18.isSelected()) 
		{
			 tray += "18," ;
		}
		if (JRadioButton19.isSelected()) 
		{
			 tray += "19," ;
		}
		if (JRadioButton20.isSelected()) 
		{
			 tray += "20," ;
		}
		if (JRadioButton21.isSelected()) 
		{
			 tray += "21," ;
		}
		if (JRadioButton22.isSelected()) 
		{
			 tray += "22," ;
		}
		if (JRadioButton23.isSelected()) 
		{
			 tray += "23," ;
		}
		if (JRadioButton24.isSelected()) 
		{
			 tray += "24," ;
		}
		JRadioButton1.setSelected(false);
		JRadioButton1.setIcon(buttonicon1);
		JRadioButton2.setSelected(false);
		JRadioButton2.setIcon(buttonicon1);
		JRadioButton3.setSelected(false);
		JRadioButton3.setIcon(buttonicon1);
		JRadioButton4.setSelected(false);
		JRadioButton4.setIcon(buttonicon1);
		JRadioButton5.setSelected(false);
		JRadioButton5.setIcon(buttonicon1);
		JRadioButton6.setSelected(false);
		JRadioButton6.setIcon(buttonicon1);
		JRadioButton7.setSelected(false);
		JRadioButton7.setIcon(buttonicon1);
		JRadioButton8.setSelected(false);
		JRadioButton8.setIcon(buttonicon1);
		JRadioButton9.setSelected(false);
		JRadioButton9.setIcon(buttonicon1);
		JRadioButton10.setSelected(false);
		JRadioButton10.setIcon(buttonicon1);
		JRadioButton11.setSelected(false);
		JRadioButton11.setIcon(buttonicon1);
		JRadioButton12.setSelected(false);
		JRadioButton12.setIcon(buttonicon1);
		JRadioButton13.setSelected(false);
		JRadioButton13.setIcon(buttonicon1);
		JRadioButton14.setSelected(false);
		JRadioButton14.setIcon(buttonicon1);
		JRadioButton15.setSelected(false);
		JRadioButton15.setIcon(buttonicon1);
		JRadioButton16.setSelected(false);
		JRadioButton16.setIcon(buttonicon1);
		JRadioButton17.setSelected(false);
		JRadioButton17.setIcon(buttonicon1);
		JRadioButton18.setSelected(false);
		JRadioButton18.setIcon(buttonicon1);
		JRadioButton19.setSelected(false);
		JRadioButton19.setIcon(buttonicon1);
		JRadioButton20.setSelected(false);
		JRadioButton20.setIcon(buttonicon1);
		JRadioButton21.setSelected(false);
		JRadioButton21.setIcon(buttonicon1);
		JRadioButton22.setSelected(false);
		JRadioButton22.setIcon(buttonicon1);
		JRadioButton23.setSelected(false);
		JRadioButton23.setIcon(buttonicon1);
		JRadioButton24.setSelected(false);
		JRadioButton24.setIcon(buttonicon1);
	}

	public String getTray() {
		
	return tray;

	}

	void clearTray() {
		JRadioButton1.setSelected(false);
		JRadioButton1.setIcon(buttonicon1);
		JRadioButton2.setSelected(false);
		JRadioButton2.setIcon(buttonicon1);
		JRadioButton3.setSelected(false);
		JRadioButton3.setIcon(buttonicon1);
		JRadioButton4.setSelected(false);
		JRadioButton4.setIcon(buttonicon1);
		JRadioButton5.setSelected(false);
		JRadioButton5.setIcon(buttonicon1);
		JRadioButton6.setSelected(false);
		JRadioButton6.setIcon(buttonicon1);
		JRadioButton7.setSelected(false);
		JRadioButton7.setIcon(buttonicon1);
		JRadioButton8.setSelected(false);
		JRadioButton8.setIcon(buttonicon1);
		JRadioButton9.setSelected(false);
		JRadioButton9.setIcon(buttonicon1);
		JRadioButton10.setSelected(false);
		JRadioButton10.setIcon(buttonicon1);
		JRadioButton11.setSelected(false);
		JRadioButton11.setIcon(buttonicon1);
		JRadioButton12.setSelected(false);
		JRadioButton12.setIcon(buttonicon1);
		JRadioButton13.setSelected(false);
		JRadioButton13.setIcon(buttonicon1);
		JRadioButton14.setSelected(false);
		JRadioButton14.setIcon(buttonicon1);
		JRadioButton15.setSelected(false);
		JRadioButton15.setIcon(buttonicon1);
		JRadioButton16.setSelected(false);
		JRadioButton16.setIcon(buttonicon1);
		JRadioButton17.setSelected(false);
		JRadioButton17.setIcon(buttonicon1);
		JRadioButton18.setSelected(false);
		JRadioButton18.setIcon(buttonicon1);
		JRadioButton19.setSelected(false);
		JRadioButton19.setIcon(buttonicon1);
		JRadioButton20.setSelected(false);
		JRadioButton20.setIcon(buttonicon1);
		JRadioButton21.setSelected(false);
		JRadioButton21.setIcon(buttonicon1);
		JRadioButton22.setSelected(false);
		JRadioButton22.setIcon(buttonicon1);
		JRadioButton23.setSelected(false);
		JRadioButton23.setIcon(buttonicon1);
		JRadioButton24.setSelected(false);
		JRadioButton24.setIcon(buttonicon1);
	}	

	/**
	 * @param s
	 */
	public void setButtons( String s ) {
		
		int index = 0;
		String seq = s;
		seq += ",";

		if ( seq.startsWith("1,"))
		{
			JRadioButton1.setSelected(true);
			JRadioButton1.setIcon(buttonicon2);
		}

// Check the index for the value an also if it starts with the value 
		
		index = seq.indexOf(",2,");
		if (index > 0 )
		{
			JRadioButton2.setSelected(true);
			JRadioButton2.setIcon(buttonicon2);
		}
		if ( seq.startsWith("2,"))
		{
			JRadioButton2.setSelected(true);
			JRadioButton2.setIcon(buttonicon2);
		}

		index = seq.indexOf(",3,");
		if (index > 0)
		{
			JRadioButton3.setSelected(true);
			JRadioButton3.setIcon(buttonicon2);
		}
		if ( seq.startsWith("3,"))
		{
			JRadioButton3.setSelected(true);
			JRadioButton3.setIcon(buttonicon2);
		}
		index = seq.indexOf(",4,");
		if (index > 0)
		{
			JRadioButton4.setSelected(true);
			JRadioButton4.setIcon(buttonicon2);
		}
		if ( seq.startsWith("4,"))
		{
			JRadioButton4.setSelected(true);
			JRadioButton4.setIcon(buttonicon2);
		}
		index = seq.indexOf(",5,");
		if (index > 0)
		{
			JRadioButton5.setSelected(true);
			JRadioButton5.setIcon(buttonicon2);
		}
		if ( seq.startsWith("5,"))
		{
			JRadioButton5.setSelected(true);
			JRadioButton5.setIcon(buttonicon2);
		}
		index = seq.indexOf(",6,");
	
		if (index > 0)
		{
			JRadioButton6.setSelected(true);
			JRadioButton6.setIcon(buttonicon2);
		}
		if ( seq.startsWith("6,"))
		{
			JRadioButton6.setSelected(true);
			JRadioButton6.setIcon(buttonicon2);
		}
		index = seq.indexOf(",7,");
		if (index > 0)
		{
			JRadioButton7.setSelected(true);
			JRadioButton7.setIcon(buttonicon2);
		}
		if ( seq.startsWith("7,"))
		{
			JRadioButton7.setSelected(true);
			JRadioButton7.setIcon(buttonicon2);
		}
		index = seq.indexOf(",8," );
		if (index > 0 )
		{
			JRadioButton8.setSelected(true);
			JRadioButton8.setIcon(buttonicon2);
		}
		if ( seq.startsWith("8,"))
		{
			JRadioButton8.setSelected(true);
			JRadioButton8.setIcon(buttonicon2);
		}
		index = seq.indexOf(",9,");
		if (index > 0)
		{
			JRadioButton9.setSelected(true);
			JRadioButton9.setIcon(buttonicon2);
		}
		if ( seq.startsWith("9,"))
		{
			JRadioButton9.setSelected(true);
			JRadioButton9.setIcon(buttonicon2);
		}
		index = seq.indexOf(",10,");
		if (index > 0)
		{
			JRadioButton10.setSelected(true);
			JRadioButton10.setIcon(buttonicon2);
		}
		if ( seq.startsWith("10,"))
		{
			JRadioButton10.setSelected(true);
			JRadioButton10.setIcon(buttonicon2);
		}
		index = seq.indexOf(",11,");
		if (index > 0)
		{
			JRadioButton11.setSelected(true);
			JRadioButton11.setIcon(buttonicon2);
		}
		if ( seq.startsWith("11,"))
		{
			JRadioButton11.setSelected(true);
			JRadioButton11.setIcon(buttonicon2);
		}
		index = seq.indexOf(",12,");
		if (index > 0)
		{
			JRadioButton12.setSelected(true);
			JRadioButton12.setIcon(buttonicon2);
		}
		if ( seq.startsWith("12,"))
		{
			JRadioButton12.setSelected(true);
			JRadioButton12.setIcon(buttonicon2);
		}
		index = seq.indexOf(",13,");
		if (index > 0)
		{
			JRadioButton13.setSelected(true);
			JRadioButton13.setIcon(buttonicon2);
		}
		if ( seq.startsWith("13,"))
		{
			JRadioButton13.setSelected(true);
			JRadioButton13.setIcon(buttonicon2);
		}
		index = seq.indexOf(",14,");
		if (index > 0)
		{
			JRadioButton14.setSelected(true);
			JRadioButton14.setIcon(buttonicon2);
		}
		if ( seq.startsWith("14,"))
		{
			JRadioButton14.setSelected(true);
			JRadioButton14.setIcon(buttonicon2);
		}
		index = seq.indexOf(",15,");
		if (index > 0)
		{
			JRadioButton15.setSelected(true);
			JRadioButton15.setIcon(buttonicon2);
		}
		if ( seq.startsWith("15,"))
		{
			JRadioButton15.setSelected(true);
			JRadioButton15.setIcon(buttonicon2);
		}
		index = seq.indexOf(",16,");
		if (index > 0)
		{
			JRadioButton16.setSelected(true);
			JRadioButton16.setIcon(buttonicon2);
		}
		if ( seq.startsWith("16,"))
		{
			JRadioButton16.setSelected(true);
			JRadioButton16.setIcon(buttonicon2);
		}
		index = seq.indexOf(",17,");
		if (index > 0)
		{
			JRadioButton17.setSelected(true);
			JRadioButton17.setIcon(buttonicon2);
		}
		if ( seq.startsWith("17,"))
		{
			JRadioButton17.setSelected(true);
			JRadioButton17.setIcon(buttonicon2);
		}
		index = seq.indexOf(",18,");
		if (index > 0)
		{
			JRadioButton18.setSelected(true);
			JRadioButton18.setIcon(buttonicon2);
		}
		if ( seq.startsWith("18,"))
		{
			JRadioButton18.setSelected(true);
			JRadioButton18.setIcon(buttonicon2);
		}
		index = seq.indexOf(",19,");
		if (index > 0)
		{
			JRadioButton19.setSelected(true);
			JRadioButton19.setIcon(buttonicon2);
		}
		if ( seq.startsWith("19,"))
		{
			JRadioButton19.setSelected(true);
			JRadioButton19.setIcon(buttonicon2);
		}
		index = seq.indexOf(",20,");
		if (index > 0)
		{
			JRadioButton20.setSelected(true);
			JRadioButton20.setIcon(buttonicon2);
		}
		if ( seq.startsWith("20,"))
		{
			JRadioButton20.setSelected(true);
			JRadioButton20.setIcon(buttonicon2);
		}
		index = seq.indexOf(",21,");
		if (index > 0)
		{
			JRadioButton21.setSelected(true);
			JRadioButton21.setIcon(buttonicon2);
		}
		if ( seq.startsWith("21,"))
		{
			JRadioButton21.setSelected(true);
			JRadioButton21.setIcon(buttonicon2);
		}
		index = seq.indexOf(",22,");
		if (index > 0)
		{
			JRadioButton22.setSelected(true);
			JRadioButton22.setIcon(buttonicon2);
		}
		if ( seq.startsWith("22,"))
		{
			JRadioButton22.setSelected(true);
			JRadioButton22.setIcon(buttonicon2);
		}
		index = seq.indexOf(",23,");
		if (index > 0)
		{
			JRadioButton23.setSelected(true);
			JRadioButton23.setIcon(buttonicon2);
		}
		if ( seq.startsWith("23,"))
		{
			JRadioButton23.setSelected(true);
			JRadioButton23.setIcon(buttonicon2);
		}
		index = seq.indexOf(",24,");
		if (index > 0)
		{
			JRadioButton24.setSelected(true);
			JRadioButton24.setIcon(buttonicon2);
		}
		if ( seq.startsWith("24,"))
		{
			JRadioButton24.setSelected(true);
			JRadioButton24.setIcon(buttonicon2);
		}
      } // end of setButtons 
		
	}

	
