/**
 	 * AutoPilot - DNA Normalization Panel
	 * Copyright 	- Telos Scientific - 
	 * Author 		- Jesse A. Campbell
	 * Description	- DNA Normalization data entry screen. 
	 * 
	 * Version update information
	 * 
	 * 05.13.14 RSC - Class created - DNA Normalization module. 
	 * 05.26.14 JC  - Corielle DNA Normalization - Procedure selection determines required inputs.  Not yet functional!
	 * 				*/

package TelosV2Pkg;

import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import java.awt.Color;
import java.awt.GridBagLayout;

import javax.swing.JTextField;

import java.awt.GridBagConstraints;

import javax.swing.JComboBox;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

import javax.swing.JLabel;
import javax.swing.filechooser.FileFilter;

public class PanelDNAnorm extends JPanel {
    private JFileChooser jFileChooser = null;
	private JTextField textField;
	private JTextField textField_1;
	private JLabel lblNgul;
	private JTextField textField_2;
	private JLabel lblUl;
	private JLabel lblStockLabware;
	private JComboBox comboBox;
	private JComboBox comboBox_1;
	private JLabel lblNormLabware;
	private JComboBox comboBox_2;
	private JLabel lblPlateLabware;
	private JComboBox comboBox_3;
	private JLabel lblDilLabware;
	private JComboBox comboBox_4;
    private JComboBox comboBox_5;
    private JComboBox comboBox_6;
    private JComboBox comboBox_7;
    private JComboBox comboBox_8;
	private String qfile;
	private String procedure;
	private String con;
	private String vol;
	private String slab;
	private String nlab;
	private String plab;
	private String dlab;
	private String deck1;
	private String deck2;
	private String deck3;
	private String deck4;
    private int pindex = 0;
    private int sindex = 0;
    private int nindex = 0;
    private int plindex = 0;
    private int dindex = 0;
	private int deck1index;
	private int deck2index;
	private int deck3index;
	private int deck4index;
    private JLabel label;


	public PanelDNAnorm(String[] plates, String[] tubes, String[] deckpositions, String[] reservoirs) {
	 		  String [] platesAll = new String [plates.length];
	 		  String [] tubesAll = new String [tubes.length];
	 		  String [] reservoirsAll = new String [reservoirs.length];
		      for (int i = 0; i < plates.length; i++) {
		          platesAll[i] = plates[i] ;
		        }
		      for (int i = 1; i < tubes.length; i++) {
		          tubesAll[i] = tubes[i] ;
		        }
		      for (int i = 0; i < reservoirs.length; i++) {
		          reservoirsAll[i] = reservoirs[i] ;
		        }
	 		  String [] deck  = new String [deckpositions.length];
		      for (int i = 1; i < deckpositions.length; i++) {
		          deck[i] = deckpositions[i] ;
		        }
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 25, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		textField = new JTextField("Click here to select the Q file");
		GridBagConstraints gbc_textField = new GridBagConstraints();
		gbc_textField.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField.insets = new Insets(0, 0, 5, 5);
		gbc_textField.gridwidth = 4;
		gbc_textField.gridx = 1;
		gbc_textField.gridy = 1;
		textField.addMouseListener(new MouseListener(){
			@Override
		          public void mouseClicked(MouseEvent e)
		          {
				// TODO Auto-generated method stub
			    int state = getJFileChooser().showSaveDialog(textField);
			    if (state == 0) {
			      File f = getJFileChooser().getSelectedFile();
			      textField.setText(f.getPath());
			    }
			}
	          public void mouseEntered(MouseEvent e){}  
	          public void mouseExited(MouseEvent e){}
	          public void mousePressed(MouseEvent e){}
	          public void mouseReleased(MouseEvent e){}
			 });
		
		label = new JLabel("                    ");
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.anchor = GridBagConstraints.EAST;
		gbc_label.gridx = 0;
		gbc_label.gridy = 1;
		add(label, gbc_label);

		add(textField, gbc_textField);
		textField.setColumns(10);
		ImageIcon icon = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/question.png");

		JLabel label_7 = new JLabel(icon);
		GridBagConstraints gbc_label_7 = new GridBagConstraints();
		gbc_label_7.anchor = GridBagConstraints.WEST;
		gbc_label_7.insets = new Insets(0, 0, 5, 0);
		gbc_label_7.gridx = 5;
		gbc_label_7.gridy = 1;
		label_7.setToolTipText("Choose the Q file");
		add(label_7, gbc_label_7);
		
		
		Object[] procedure =
	        {
			    new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/CORDNA_Select.png"),
	            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/CORDNA_Normalize.png"),
	            new ImageIcon("C:/Program Files/TELOS/AutoPilot/Config/CORDNA_Aliquot.png")
	        };

		comboBox = new JComboBox(procedure);
		GridBagConstraints gbc_comboBox = new GridBagConstraints();
		gbc_comboBox.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox.gridwidth = 4;
		gbc_comboBox.gridx = 1;
		gbc_comboBox.gridy = 2;
        pindex = this.comboBox.getSelectedIndex();
	    comboBox.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
	            pindex = (cb.getSelectedIndex());
	            if (pindex == 1){
	            	comboBox_3.setEnabled(false);
	            	comboBox_8.setEnabled(false);
	            	comboBox_1.setEnabled(true);
	            	comboBox_2.setEnabled(true);
	            	comboBox_6.setEnabled(true);
	            	comboBox_4.setEnabled(true);
	            	comboBox_5.setEnabled(true);
	            	comboBox_7.setEnabled(true);
	            }
	            if (pindex == 2){
	            	comboBox_3.setEnabled(true);
	            	comboBox_8.setEnabled(true);
	            	comboBox_1.setEnabled(false);
	            	comboBox_2.setEnabled(true);
	            	comboBox_6.setEnabled(false);
	            	comboBox_4.setEnabled(false);
	            	comboBox_5.setEnabled(false);
	            	comboBox_7.setEnabled(true);
	            }
		      } } );
		add(comboBox, gbc_comboBox);
		
		textField_1 = new JTextField();
		GridBagConstraints gbc_textField_1 = new GridBagConstraints();
		gbc_textField_1.insets = new Insets(0, 0, 5, 5);
		gbc_textField_1.anchor = GridBagConstraints.WEST;
		gbc_textField_1.gridx = 1;
		gbc_textField_1.gridy = 3;
		add(textField_1, gbc_textField_1);
		textField_1.setColumns(10);
		
		JLabel label_8 = new JLabel(icon);
		GridBagConstraints gbc_label_8 = new GridBagConstraints();
		gbc_label_8.anchor = GridBagConstraints.WEST;
		gbc_label_8.insets = new Insets(0, 0, 5, 0);
		gbc_label_8.gridx = 5;
		gbc_label_8.gridy = 2;
		label_8.setToolTipText("Select procedure type");
		add(label_8, gbc_label_8);
		
		lblNgul = new JLabel("ng/ul");
		GridBagConstraints gbc_lblNgul = new GridBagConstraints();
		gbc_lblNgul.anchor = GridBagConstraints.WEST;
		gbc_lblNgul.insets = new Insets(0, 0, 5, 5);
		gbc_lblNgul.gridx = 2;
		gbc_lblNgul.gridy = 3;
		add(lblNgul, gbc_lblNgul);
		
		textField_2 = new JTextField();
		GridBagConstraints gbc_textField_2 = new GridBagConstraints();
		gbc_textField_2.insets = new Insets(0, 0, 5, 5);
		gbc_textField_2.anchor = GridBagConstraints.WEST;
		gbc_textField_2.gridx = 3;
		gbc_textField_2.gridy = 3;
		add(textField_2, gbc_textField_2);
		textField_2.setColumns(10);
		
		lblUl = new JLabel("ul");
		GridBagConstraints gbc_lblUl = new GridBagConstraints();
		gbc_lblUl.insets = new Insets(0, 0, 5, 5);
		gbc_lblUl.anchor = GridBagConstraints.WEST;
		gbc_lblUl.gridx = 4;
		gbc_lblUl.gridy = 3;
		add(lblUl, gbc_lblUl);
		
		JLabel label_9 = new JLabel(icon);
		GridBagConstraints gbc_label_9 = new GridBagConstraints();
		gbc_label_9.anchor = GridBagConstraints.WEST;
		gbc_label_9.insets = new Insets(0, 0, 5, 0);
		gbc_label_9.gridx = 5;
		gbc_label_9.gridy = 3;
		label_9.setToolTipText("Enter concentration and volume amounts");
		add(label_9, gbc_label_9);
		
		comboBox_5 = new JComboBox(deckpositions);
		GridBagConstraints gbc_comboBox_5 = new GridBagConstraints();
		gbc_comboBox_5.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_5.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_5.gridx = 4;
		gbc_comboBox_5.gridy = 4;
        deck1index = this.comboBox_5.getSelectedIndex();
	    comboBox_5.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck1 = ((String)cb.getSelectedItem());
	            deck1index = (cb.getSelectedIndex());
		      } } );
		add(comboBox_5, gbc_comboBox_5);
		
		lblStockLabware = new JLabel("Stock labware");
		GridBagConstraints gbc_lblStockLabware = new GridBagConstraints();
		gbc_lblStockLabware.anchor = GridBagConstraints.EAST;
		gbc_lblStockLabware.insets = new Insets(0, 0, 5, 5);
		gbc_lblStockLabware.gridx = 1;
		gbc_lblStockLabware.gridy = 5;
		add(lblStockLabware, gbc_lblStockLabware);
		
		comboBox_6 = new JComboBox(deckpositions);
		GridBagConstraints gbc_comboBox_6 = new GridBagConstraints();
		gbc_comboBox_6.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_6.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_6.gridx = 4;
		gbc_comboBox_6.gridy = 5;
        deck2index = this.comboBox_6.getSelectedIndex();
	    comboBox_6.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck2 = ((String)cb.getSelectedItem());
	            deck2index = (cb.getSelectedIndex());
		      } } );
		add(comboBox_6, gbc_comboBox_6);
		
		JLabel label_10 = new JLabel(icon);
		GridBagConstraints gbc_label_10 = new GridBagConstraints();
		gbc_label_10.anchor = GridBagConstraints.WEST;
		gbc_label_10.insets = new Insets(0, 0, 5, 0);
		gbc_label_10.gridx = 5;
		gbc_label_10.gridy = 5;
		label_10.setToolTipText("Choose stock labware");
		add(label_10, gbc_label_10);
		
		comboBox_1 = new JComboBox(tubes);
		GridBagConstraints gbc_comboBox_1 = new GridBagConstraints();
		gbc_comboBox_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_1.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_1.gridx = 2;
		gbc_comboBox_1.gridy = 5;
		gbc_comboBox_1.gridwidth = 2;
        sindex = this.comboBox_1.getSelectedIndex();
	    comboBox_1.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        slab = ((String)cb.getSelectedItem());
	            sindex = (cb.getSelectedIndex());
		      } } );
		add(comboBox_1, gbc_comboBox_1);
		
		lblNormLabware = new JLabel("Norm labware");
		GridBagConstraints gbc_lblNormLabware = new GridBagConstraints();
		gbc_lblNormLabware.anchor = GridBagConstraints.EAST;
		gbc_lblNormLabware.insets = new Insets(0, 0, 5, 5);
		gbc_lblNormLabware.gridx = 1;
		gbc_lblNormLabware.gridy = 6;
		add(lblNormLabware, gbc_lblNormLabware);
		
		comboBox_2 = new JComboBox(platesAll);
		GridBagConstraints gbc_comboBox_2 = new GridBagConstraints();
		gbc_comboBox_2.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_2.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_2.gridx = 2;
		gbc_comboBox_2.gridy = 6;
		gbc_comboBox_2.gridwidth = 2;
        nindex = this.comboBox_2.getSelectedIndex();
	    comboBox_2.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        nlab = ((String)cb.getSelectedItem());
	            nindex = (cb.getSelectedIndex());
		      } } );
		add(comboBox_2, gbc_comboBox_2);
		
		comboBox_7 = new JComboBox(deckpositions);
		GridBagConstraints gbc_comboBox_7 = new GridBagConstraints();
		gbc_comboBox_7.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_7.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_7.gridx = 4;
		gbc_comboBox_7.gridy = 6;
        deck3index = this.comboBox_7.getSelectedIndex();
	    comboBox_7.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck3 = ((String)cb.getSelectedItem());
	            deck3index = (cb.getSelectedIndex());
		      } } );
		add(comboBox_7, gbc_comboBox_7);
		
		JLabel label_11 = new JLabel(icon);
		GridBagConstraints gbc_label_11 = new GridBagConstraints();
		gbc_label_11.anchor = GridBagConstraints.WEST;
		gbc_label_11.insets = new Insets(0, 0, 5, 0);
		gbc_label_11.gridx = 5;
		gbc_label_11.gridy = 6;
		label_11.setToolTipText("Choose norm labware");
		add(label_11, gbc_label_11);
		
		lblPlateLabware = new JLabel("Plate labware");
		GridBagConstraints gbc_lblPlateLabware = new GridBagConstraints();
		gbc_lblPlateLabware.anchor = GridBagConstraints.EAST;
		gbc_lblPlateLabware.insets = new Insets(0, 0, 0, 5);
		gbc_lblPlateLabware.gridx = 1;
		gbc_lblPlateLabware.gridy = 7;
		add(lblPlateLabware, gbc_lblPlateLabware);
		
		comboBox_3 = new JComboBox(platesAll);
		GridBagConstraints gbc_comboBox_3 = new GridBagConstraints();
		gbc_comboBox_3.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_3.insets = new Insets(0, 0, 0, 5);
		gbc_comboBox_3.gridx = 2;
		gbc_comboBox_3.gridy = 7;
		gbc_comboBox_3.gridwidth = 2;
        plindex = this.comboBox_3.getSelectedIndex();
	    comboBox_3.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        plab = ((String)cb.getSelectedItem());
	            plindex = (cb.getSelectedIndex());
		      } } );
		add(comboBox_3, gbc_comboBox_3);
		
		comboBox_8 = new JComboBox(deckpositions);
		GridBagConstraints gbc_comboBox_8 = new GridBagConstraints();
		gbc_comboBox_8.insets = new Insets(0, 0, 0, 5);
		gbc_comboBox_8.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_8.gridx = 4;
		gbc_comboBox_8.gridy = 7;
        deck4index = this.comboBox_8.getSelectedIndex();
	    comboBox_8.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck4 = ((String)cb.getSelectedItem());
	            deck4index = (cb.getSelectedIndex());
		      } } );
		add(comboBox_8, gbc_comboBox_8);

		JLabel label_12 = new JLabel(icon);
		GridBagConstraints gbc_label_12 = new GridBagConstraints();
		gbc_label_12.anchor = GridBagConstraints.WEST;
		gbc_label_12.gridx = 5;
		gbc_label_12.gridy = 7;
		label_12.setToolTipText("Choose plate labware");
		add(label_12, gbc_label_12);
		
		lblDilLabware = new JLabel("Diluent labware");
		GridBagConstraints gbc_lblDilLabware = new GridBagConstraints();
		gbc_lblDilLabware.anchor = GridBagConstraints.EAST;
		gbc_lblDilLabware.insets = new Insets(0, 0, 5, 5);
		gbc_lblDilLabware.gridx = 1;
		gbc_lblDilLabware.gridy = 4;
		add(lblDilLabware, gbc_lblDilLabware);
		
		comboBox_4 = new JComboBox(reservoirsAll);
		GridBagConstraints gbc_comboBox_4 = new GridBagConstraints();
		gbc_comboBox_4.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBox_4.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox_4.gridx = 2;
		gbc_comboBox_4.gridy = 4;
		gbc_comboBox_4.gridwidth = 2;
        dindex = this.comboBox_4.getSelectedIndex();
	    comboBox_4.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dlab = ((String)cb.getSelectedItem());
	            dindex = (cb.getSelectedIndex());
		      } } );
		add(comboBox_4, gbc_comboBox_4);

		JLabel label_13 = new JLabel(icon);
		GridBagConstraints gbc_label_13 = new GridBagConstraints();
		gbc_label_13.insets = new Insets(0, 0, 5, 0);
		gbc_label_13.anchor = GridBagConstraints.WEST;
		gbc_label_13.gridx = 5;
		gbc_label_13.gridy = 4;
		label_13.setToolTipText("Choose plate labware");
		add(label_13, gbc_label_13);
		
	
	}

	  private JFileChooser getJFileChooser()
	  {
	    if (this.jFileChooser == null) {
	      this.jFileChooser = new JFileChooser();
	      jFileChooser.setDialogTitle("Select Worklist");
	      this.jFileChooser.setApproveButtonText("Select");
	      this.jFileChooser.setMultiSelectionEnabled(false);
	      this.jFileChooser.setAcceptAllFileFilterUsed(false);
	      FileFilter filter3 = new textFileFilter(".txt or .pdf", new String[] { "TXT","PDF" });
	      this.jFileChooser.setFileFilter(filter3);
	    }

	    return this.jFileChooser;
	  }

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	public String getQFile() {
	qfile = textField.getText();	
	return qfile;
	}
	
	public String getCon() {
	con = textField_1.getText();	
	return con;
	}

	public String getVol() {
	vol = textField_2.getText();	
	return vol;
	}

	public int getProcIndex() {
	return pindex;
	}
	
	public String getSPlateType() {
	return slab;
	}

	public int getSPlateIndex() {
	return sindex;
	}

	public String getNPlateType() {
	return nlab;
	}

	public int getNPlateIndex() {
	return nindex;
	}

	public String getPlateType() {
	return plab;
	}

	public int getPlateIndex() {
	return plindex;
	}

	public String getDPlateType() {
	return dlab;
	}

	public int getDPlateIndex() {
	return dindex;
	}

	public String getDeck1() {
		if (deck1 == null )
		{
			return "0";
		}
		if (deck1.equals("Pos"))
		{
			return "0";
		}
		else
		{
			return deck1;
		}
	}

	public int getDeckIndex1() {
	return deck1index;
	}

	public String getDeck2() {
		if (deck2 == null )
		{
			return "0";
		}
		if (deck2.equals("Pos"))
		{
			return "0";
		}
		else
		{
			return deck2;
		}
	}

	public int getDeckIndex2() {
	return deck2index;
	}

	public String getDeck3() {
		if (deck3 == null )
		{
			return "0";
		}
		if (deck3.equals("Pos"))
		{
			return "0";
		}
		else
		{
			return deck3;
		}
	}

	public int getDeckIndex3() {
	return deck3index;
	}

	public String getDeck4() {
		if (deck4 == null )
		{
			return "0";
		}
		if (deck4.equals("Pos"))
		{
			return "0";
		}
		else
		{
			return deck4;
		}
	}

	public int getDeckIndex4() {
	return deck4index;
	}

	public void setText( String s ){
		textField.setText(s);
	}
	  
	public void setText1( String s ){
		textField_1.setText(s);
	}
	  
	public void setText2( String s ){
		textField_2.setText(s);
	}
	  
	public void setProcIndex( int index ){
		comboBox.setSelectedIndex(index);
	}
	
	public void setSPlateIndex( int index ){
		if (index > 0)
		{
			comboBox_1.setSelectedIndex(index);
		}
		else
		{
			comboBox_1.setSelectedIndex(0);
		}
	}
	
	public void setNPlateIndex( int index ){
		if (index > 0)
		{
			comboBox_2.setSelectedIndex(index);
		}
		else
		{
			comboBox_2.setSelectedIndex(0);
		}
	}
	
	public void setPlateIndex( int index ){
		if (index > 0)
		{
			comboBox_3.setSelectedIndex(index);
		}
		else
		{
			comboBox_3.setSelectedIndex(0);
		}
	}
	
	public void setDPlateIndex( int index ){
		if (index > 0)
		{
			comboBox_4.setSelectedIndex(index);
		}
		else
		{
			comboBox_4.setSelectedIndex(0);
		}
	}

	public void setDeckIndex1( int index ){
		comboBox_5.setSelectedIndex(index);
	}

	public void setDeckIndex2( int index ){
		comboBox_6.setSelectedIndex(index);
	}

	public void setDeckIndex3( int index ){
		comboBox_7.setSelectedIndex(index);
	}

	public void setDeckIndex4( int index ){
			comboBox_8.setSelectedIndex(index);
	}

	
}
