/**
 * AutoPilot
 * Copyright 	- Telos Scientific - 
 * Author 		- Jesse A. Campbell
 * Description	- PK Main window (Auto Pilot 1.0) 
 * Written 		- 01/01/2014
**/

package TelosV2Pkg;

// Updates
//
// 01/29/14 JC	- APN0046	  PK MODULE 3 with Graphic updates from JC	
// 01/29/15 RSC 
//


import javax.swing.JPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileSystemView;

import java.awt.FlowLayout;

import javax.swing.JTextField;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;

import javax.swing.SwingConstants;

import TelosV2Pkg.TabWindow.DirectoryRestrictedFileSystemView;

import java.awt.Dimension;

public class PanelPK1 extends JPanel {
    Border blackline = BorderFactory.createLineBorder(Color.black);
    Border redline = BorderFactory.createLineBorder(Color.red);
    ImageIcon iconArrow = new ImageIcon("C:\\Program Files\\Telos\\AutoPilot\\Graphics\\BlueArrowT2.png");
    Font font15 = new Font("Calibri", 1, 15);
    
	private PanelPKB panelblank = null;
	public static PanelPKB2 panelblank2 = null;
	private PanelPK2 panel2 = null;
	private PanelPK3 panel3 = null;
	public  PanelPK4 panel4 = null;
	private PanelPK5 panel5 = null;
  
	private JFileChooser jFileChooser3 = null;
    private String path = " ";

    JLabel label = null;
	JLabel label_1 = null;
	JLabel label_2 = null;
	JPanel panel_2 = null;
	JPanel panel_3 = null;		//Properties Buttons Panel - Horizontal panel with dynamic buttons for each process
	JPanel panel_4 = null;		//Hold both lower panels (properties and instruction panels).  This panel isn't seen.

	public JTextField pkm_text_wat;
	JButton btnNewButton = null;
	JButton btnNewButton_1 = null;
	JButton btnNewButton_2 = null;
	JButton btnNewButton_3 = null;
	JButton btnNewButton_4 = null;
	JButton btnMRD = null;
	JButton btnDilution = null;
	JButton btnPreassay = null;
	JButton btnAssay = null;
	private boolean mrdon = false;
    private boolean dilon = false;
    private boolean assayon = false;
    private boolean preassayon = false;
	JLabel lblNewLabel_4 = null;
	JLabel lblNewLabel_5 = null;
    ActionListener alistener = null;
    ActionListener blistener = null;
    ActionListener clistener = null;
    ActionListener dlistener = null;
	
    private Color panelColor = new Color(248, 248, 255);
//    private Color newColor = new Color (169, 200, 229);
//    private Color newColorGreen = new Color (128, 205, 100);
    private Color newColorBlueT2 = new Color (112, 164, 215);

	public PanelPK1(String[] plates, String[] tubes, String[] deckpositions, String[] reservoirs, String[] liqtypes) {
		  String [] platesAll = new String [plates.length];
		  String [] tubesAll = new String [tubes.length];
		  String [] reservoirsAll = new String [reservoirs.length];
	      for (int i = 0; i < plates.length; i++) {
	          platesAll[i] = plates[i] ;
	        }
	      for (int i = 1; i < tubes.length; i++) {
	          tubesAll[i] = tubes[i] ;
	        }
	      for (int i = 0; i < reservoirs.length; i++) {
	          reservoirsAll[i] = reservoirs[i] ;
	        }
		  String [] deck  = new String [deckpositions.length];
	      for (int i = 1; i < deckpositions.length; i++) {
	          deck[i] = deckpositions[i] ;
	        }
		  String [] liquids  = new String [liqtypes.length];
	      for (int i = 1; i < liqtypes.length; i++) {
	          liquids[i] = liqtypes[i] ;
	        }
		  String [] platesTubes = new String [plates.length + tubes.length];
	      for (int i = 0; i < plates.length; i++) {
	          platesTubes[i] = plates[i] ;
	        }
	      for (int i = 1; i < tubes.length; i++) {
	          platesTubes[i] = tubes[i] ;
	        }
	  	  panel2 = new PanelPK2(platesAll, tubesAll, deckpositions, reservoirsAll, liqtypes);
		  panel3 = new PanelPK3(platesAll, tubesAll, deckpositions, reservoirsAll, liqtypes);
		  panel4 = new PanelPK4(platesAll, tubesAll, deckpositions, reservoirsAll, liqtypes);
		  panel5 = new PanelPK5(platesAll);

		setLayout(new BorderLayout(0, 0));
		setSize(800, 300);
		alistener = new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
					panel_4.removeAll();
					panel_4.add(panel2);					
					panel_4.add(panelblank2, get_gbc_panelblank2());
//					panel_4.add(lblNewLabel_5);
		            panel_4.revalidate();
		            panel_4.repaint();
			}
		};
		blistener = new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				panel_4.removeAll();
				if (mrdon)
				{
					panel3.lblMrd.setVisible(false);
					panel3.pkSsource.setVisible(false);
					panel3.pksamdil.setVisible(false);
				}
				else
				{
					panel3.lblMrd.setVisible(true);
					panel3.pkSsource.setVisible(true);
					panel3.pksamdil.setVisible(true);
					if (panel4.getpkstdsrc().contains("_96")){
			          	  panel3.setsamIndex(panel4.getpkstdlindex());

			            }
					
				}
				panel_4.add(panel3);
				panel_4.add(panelblank2, get_gbc_panelblank2());
//				panel_4.add(lblNewLabel_5);
	            panel_4.revalidate();
	            panel_4.repaint();
			}
		};
		clistener = new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				panel_4.removeAll();
				if (mrdon)
				{
					panel4.lbl1.setVisible(false);
					panel4.lblin.setVisible(false);
					panel4.pkm_text_1.setVisible(false);
					panel4.lblStandard.setVisible(false);
					panel4.pkSTDsource.setVisible(false);
					panel4.pkstddil.setVisible(false);
   					panel4.lblDiluent.setVisible(false);
   					panel4.lblLiquid.setVisible(false);
   					panel4.lblPosition.setVisible(false);
					panel4.pkDilsource.setVisible(false);
					panel4.pkmrddil.setVisible(false);
					panel4.pkdeck1.setVisible(false);
				}
				else
				{
					panel4.lbl1.setVisible(true);
					panel4.lblin.setVisible(true);
					panel4.pkm_text_1.setVisible(true);
					panel4.lblStandard.setVisible(true);
					panel4.pkSTDsource.setVisible(true);
					panel4.pkstddil.setVisible(true);
   					panel4.lblDiluent.setVisible(true);
   					panel4.lblLiquid.setVisible(true);
   					panel4.lblPosition.setVisible(true);
					panel4.pkDilsource.setVisible(true);
					panel4.pkmrddil.setVisible(true);
					panel4.pkdeck1.setVisible(true);
					if (panel4.pkm_text_1.getText().equals(""))
					{
						panel4.pkm_text_1.setText("0");
					}
					if (panel3.getpkssrc().contains("_96") && (panel4.getpkstdsrc().contains("_96") || panel4.getpkstdlindex() == 0)){
		          	  panel4.setstdIndex(panel3.getsamlindex());
		            }
		            if (panel3.getpkssrc().contains("_Tube") && (panel4.getpkstdsrc().contains("_96") || panel4.getpkstdlindex() == 0)){
		            	panel4.setstdIndex(panel3.getsamlindex());
		            }
				}
				panel_4.add(panel4);
				panel_4.add(panelblank2, get_gbc_panelblank2());
//				panel_4.add(lblNewLabel_5);
	            panel_4.revalidate();
	            panel_4.repaint();
			}
		};
		dlistener = new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				panel_4.removeAll();
				panel_4.add(panel5);
				panel_4.add(panelblank2, get_gbc_panelblank2());
//				panel_4.add(lblNewLabel_5);
	            panel_4.revalidate();
	            panel_4.repaint();
			}
		};
	
		JPanel panel = new JPanel();
		panel.setBackground(this.panelColor);
		add(panel, BorderLayout.WEST);
		panel.setLayout(new GridLayout(7, 1));
		
		JLabel lblNewLabel = new JLabel("     ");
		panel.add(lblNewLabel);
		
		btnMRD = new javax.swing.JButton("MRD");

		
		btnMRD.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {
				if (!mrdon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkMrd.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove MRD Procedure");	
				}
			}
			public void mouseEntered(MouseEvent arg0) {
				if (!mrdon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkMrd.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove MRD Procedure");	
				}
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
		btnMRD.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				resetScreen();
				if (!mrdon)
				{
					mrdon = true;
					if (dilon && preassayon && assayon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(clistener);
						btnNewButton_3.setText("Pre-Assay");
						label_2.setVisible(true);
						btnNewButton_4.setVisible(true);
						ActionListener[] lis4 = btnNewButton_4.getActionListeners();
						if (lis4.length > 0);
						{
						      for (int i = 0; i < lis4.length; i++) {
									btnNewButton_4.removeActionListener(lis4[i]);
						      }
						}
						btnNewButton_4.addActionListener(dlistener);
						btnNewButton_4.setText("Assay");
					}
					else if (dilon && preassayon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(clistener);
						btnNewButton_3.setText("Pre-Assay");
					}
					else if (dilon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(blistener);
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
					}
					else if (preassayon && assayon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(clistener);
						btnNewButton_2.setText("Pre-Assay");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(dlistener);
						btnNewButton_3.setText("Assay");
					}
					else if (preassayon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(clistener);
						btnNewButton_2.setText("Pre-Assay");
					}
					else
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.setVisible(true);
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
					}
				}
				else
				{
					mrdon = false;
				    panel2.setpkmtext1("");
				    panel2.setpkmtextul("");
				    panel2.setMRDsrcIndex(0);
				    panel2.setsamIndex(0);
				    panel2.setstdIndex(0);
				    panel2.setmrddilIndex(0);
				    panel2.setsamdilIndex(0);
				    panel2.setstddilIndex(0);
				    panel2.setdeck1index(0);
					if (dilon && preassayon && assayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						btnNewButton_2.addActionListener(clistener);
						btnNewButton_2.setText("Pre-Assay");
						label_1.setVisible(true);	
						btnNewButton_3.setVisible(true);
						btnNewButton_3.setText("Assay");
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
//						btnNewButton_3.removeActionListener(clistener);
						btnNewButton_3.addActionListener(dlistener);
						label_2.setVisible(false);	
						btnNewButton_4.setVisible(false);
						ActionListener[] lis4 = btnNewButton_4.getActionListeners();
						if (lis4.length > 0);
						{
						      for (int i = 0; i < lis4.length; i++) {
									btnNewButton_4.removeActionListener(lis4[i]);
						      }
						}
//						btnNewButton_4.removeActionListener(dlistener);
					    setmrdindex(0);
					    setsamindex(0);
					    setstdindex(0);
					    setmrddilindex(0);
					    setsamdilindex(0);
					    setstddilindex(0);
					    setdeck1index(0);
					}
					else if (dilon && preassayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						btnNewButton_2.addActionListener(clistener);
						btnNewButton_2.setText("Pre-Assay");
						label_1.setVisible(false);	
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
					}
					else if (preassayon && assayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(clistener);
						btnNewButton_1.setText("Pre-Assay");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(dlistener);
						btnNewButton_2.setText("Assay");
						label_1.setVisible(false);	
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
					    setmrdindex(0);
					    setsamindex(0);
					    setstdindex(0);
					    setmrddilindex(0);
					    setsamdilindex(0);
					    setstddilindex(0);
					    setdeck1index(0);
//						btnNewButton_3.removeActionListener(clistener);
					}
					else if (preassayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(clistener);
						btnNewButton_1.setText("Pre-Assay");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
					}
					else if (dilon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
					    setmrdindex(0);
					    setsamindex(0);
					    setstdindex(0);
					    setmrddilindex(0);
					    setsamdilindex(0);
					    setstddilindex(0);
					    setdeck1index(0);
//						btnNewButton_2.removeActionListener(blistener);
					}
					else
					{
						btnNewButton_1.setVisible(false);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
					    setmrdindex(0);
					    setsamindex(0);
					    setstdindex(0);
					    setmrddilindex(0);
					    setsamdilindex(0);
					    setstddilindex(0);
					    setdeck1index(0);
					    setdilsrcindex(0);
					}
				}
			}
		});
		panel.add(btnMRD);
		
	    	btnDilution = new JButton("DILUTION");
	    	
	    	btnDilution.addMouseListener(new MouseListener() {
				public void mouseClicked(MouseEvent arg0) {
					if (!dilon){
						VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkDilution.png", -1, "", 360, 220);	
					}else{
						PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
						PanelPKB2.lblPkBlank.setText("Remove Dilution Procedure");	
					}
				}
				public void mouseEntered(MouseEvent arg0) {
					if (!dilon){
						VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkDilution.png", -1, "", 360, 220);	
					}else{
						PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
						PanelPKB2.lblPkBlank.setText("Remove Dilution Procedure");	
					}
				}
				public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
				public void mousePressed(MouseEvent arg0) {}
				public void mouseReleased(MouseEvent arg0) {}
			});
			
			btnDilution.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (!dilon)
					{
						resetScreen();
						dilon = true;
						if (mrdon && preassayon && assayon)
						{
							btnNewButton_1.setVisible(true);
//							btnNewButton_1.addActionListener(alistener);
							btnNewButton_1.setText("MRD");
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
//							btnNewButton_2.removeActionListener(clistener);
							btnNewButton_2.addActionListener(blistener);
							btnNewButton_2.setText("Dilution");
							label_1.setVisible(true);
							btnNewButton_3.setVisible(true);
//							btnNewButton_3.addActionListener(clistener);
							btnNewButton_3.setText("Pre-Assay");
							label_2.setVisible(true);
							btnNewButton_4.setVisible(true);
//							btnNewButton_4.addActionListener(dlistener);
							btnNewButton_4.setText("Assay");
						}
						else if (mrdon && preassayon)
						{
							btnNewButton_1.setVisible(true);
//							btnNewButton_1.addActionListener(alistener);
							btnNewButton_1.setText("MRD");
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
							btnNewButton_2.addActionListener(blistener);
							btnNewButton_2.setText("Dilution");
							label_1.setVisible(true);
							btnNewButton_3.setVisible(true);
//							btnNewButton_3.addActionListener(clistener);
							btnNewButton_3.setText("Pre-Assay");
						}
						else if (preassayon && assayon)
						{
							ActionListener[] lis1 = btnNewButton_1.getActionListeners();
							if (lis1.length > 0);
							{
							      for (int i = 0; i < lis1.length; i++) {
										btnNewButton_1.removeActionListener(lis1[i]);
							      }
							}
							btnNewButton_1.setVisible(true);
							btnNewButton_1.addActionListener(blistener);
							btnNewButton_1.setText("Dilution");
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
							btnNewButton_2.addActionListener(clistener);
							btnNewButton_2.setText("Pre-Assay");
							label_1.setVisible(true);
							ActionListener[] lis3 = btnNewButton_3.getActionListeners();
							if (lis3.length > 0);
							{
							      for (int i = 0; i < lis3.length; i++) {
										btnNewButton_3.removeActionListener(lis3[i]);
							      }
							}
							btnNewButton_3.setVisible(true);
							btnNewButton_3.addActionListener(dlistener);
							btnNewButton_3.setText("Assay");
						}
						else if (preassayon)
						{
							ActionListener[] lis1 = btnNewButton_1.getActionListeners();
							if (lis1.length > 0);
							{
							      for (int i = 0; i < lis1.length; i++) {
										btnNewButton_1.removeActionListener(lis1[i]);
							      }
							}
							btnNewButton_1.setVisible(true);
							btnNewButton_1.addActionListener(blistener);
							btnNewButton_1.setText("Dilution");
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
							btnNewButton_2.addActionListener(clistener);
							btnNewButton_2.setText("Pre-Assay");
							label_1.setVisible(false);	
							btnNewButton_3.setVisible(false);
							ActionListener[] lis3 = btnNewButton_3.getActionListeners();
							if (lis3.length > 0);
							{
							      for (int i = 0; i < lis3.length; i++) {
										btnNewButton_3.removeActionListener(lis3[i]);
							      }
							}
						}
						else if (mrdon)
						{
							btnNewButton_1.setVisible(true);
//							btnNewButton_1.addActionListener(alistener);
							btnNewButton_1.setText("MRD");
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
							btnNewButton_2.addActionListener(blistener);
							btnNewButton_2.setText("Dilution");
						}
						else
						{
							btnNewButton_1.setVisible(true);
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
//							btnNewButton_1.removeActionListener(alistener);
							btnNewButton_1.addActionListener(blistener);
							btnNewButton_1.setText("Dilution");
							label.setVisible(false);
							btnNewButton_2.setVisible(false);
						}
					}
					else
					{
						dilon = false;
					    setdilsrcindex2(0);
					    setdilresindex(0);
					    setdeck2index(0);
					    setpkmpassayul("");
					    panel3.setsamIndex(0);
					    panel3.setsamdilIndex(0);
						if (mrdon && preassayon && assayon)
						{
							btnNewButton_1.setText("MRD");
							label.setVisible(true);	
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
//							btnNewButton_2.removeActionListener(blistener);
							btnNewButton_2.addActionListener(clistener);
							btnNewButton_2.setText("Pre-Assay");
							label_1.setVisible(true);	
							btnNewButton_3.setVisible(true);
							btnNewButton_3.setText("Assay");
							ActionListener[] lis3 = btnNewButton_3.getActionListeners();
							if (lis3.length > 0);
							{
							      for (int i = 0; i < lis3.length; i++) {
										btnNewButton_3.removeActionListener(lis3[i]);
							      }
							}
//							btnNewButton_3.removeActionListener(clistener);
							btnNewButton_3.addActionListener(dlistener);
							label_2.setVisible(false);	
							btnNewButton_4.setVisible(false);
							btnNewButton_4.removeActionListener(dlistener);
							ActionListener[] lis4 = btnNewButton_4.getActionListeners();
							if (lis4.length > 0);
							{
							      for (int i = 0; i < lis4.length; i++) {
										btnNewButton_4.removeActionListener(lis4[i]);
							      }
							}
						    setdilsrcindex2(0);
						    setdilresindex(0);
						    setdeck2index(0);
						    setpkmpassayul("");
						}
						else if (mrdon && preassayon)
						{
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
							btnNewButton_1.addActionListener(alistener);
							btnNewButton_1.setText("MRD");
							label.setVisible(true);	
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
//							btnNewButton_2.removeActionListener(blistener);
							btnNewButton_2.addActionListener(clistener);
							btnNewButton_2.setText("Pre-Assay");
							label_1.setVisible(false);	
							btnNewButton_3.setVisible(false);
							ActionListener[] lis3 = btnNewButton_3.getActionListeners();
							if (lis3.length > 0);
							{
							      for (int i = 0; i < lis3.length; i++) {
										btnNewButton_3.removeActionListener(lis3[i]);
							      }
							}
						    setdilsrcindex2(0);
						    setdilresindex(0);
						    setdeck2index(0);
						    setpkmpassayul("");
//							btnNewButton_3.removeActionListener(clistener);
						}
						else if (preassayon && assayon)
						{
							btnNewButton_1.setVisible(true);
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
							btnNewButton_1.addActionListener(clistener);
							btnNewButton_1.setText("Pre-Assay");
							btnNewButton_1.setVisible(true);
							label.setVisible(true);
							btnNewButton_2.setVisible(true);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
							btnNewButton_2.addActionListener(dlistener);
							btnNewButton_2.setText("Assay");
							label_1.setVisible(false);
							btnNewButton_3.setVisible(false);
							label_2.setVisible(false);
						}
						else if (preassayon)
						{
							btnNewButton_1.setVisible(true);
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
							btnNewButton_1.addActionListener(clistener);
							btnNewButton_1.setText("Pre-Assay");
							btnNewButton_1.setVisible(true);
							label.setVisible(false);
							btnNewButton_2.setVisible(false);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
						}
						else if (mrdon)
						{
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
//							btnNewButton_1.removeActionListener(blistener);
							btnNewButton_1.addActionListener(alistener);
							btnNewButton_1.setText("MRD");
							label.setVisible(false);
							btnNewButton_2.setVisible(false);
							ActionListener[] lis2 = btnNewButton_2.getActionListeners();
							if (lis2.length > 0);
							{
							      for (int i = 0; i < lis2.length; i++) {
										btnNewButton_2.removeActionListener(lis2[i]);
							      }
							}
//							btnNewButton_2.removeActionListener(blistener);
							label_1.setVisible(false);
							btnNewButton_3.setVisible(false);
							ActionListener[] lis3 = btnNewButton_3.getActionListeners();
							if (lis3.length > 0);
							{
							      for (int i = 0; i < lis3.length; i++) {
										btnNewButton_3.removeActionListener(lis3[i]);
							      }
							}
//							btnNewButton_3.removeActionListener(clistener);
							label_2.setVisible(false);
							btnNewButton_4.setVisible(false);
							btnNewButton_4.removeActionListener(dlistener);
						    setdilsrcindex2(0);
						    setdilresindex(0);
						    setdeck2index(0);
						    setpkmpassayul("");
						}
						else
						{
							ActionListener[] lis = btnNewButton_1.getActionListeners();
							if (lis.length > 0);
							{
							      for (int i = 0; i < lis.length; i++) {
										btnNewButton_1.removeActionListener(lis[i]);
							      }
							}
//							btnNewButton_1.removeActionListener(alistener);
							btnNewButton_1.setVisible(false);
							label.setVisible(false);
							btnNewButton_2.setVisible(false);
						    setdilsrcindex2(0);
						    setdilresindex(0);
						    setdeck2index(0);
						    setpkmpassayul("");
						}
					}
				}
			});
			
		panel.add(btnDilution);
		
		btnPreassay = new JButton("PREASSAY");
		
		btnPreassay.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {
				if (!preassayon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkPreAssay.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove Pre-Assay Procedure");	
				}
			}
			public void mouseEntered(MouseEvent arg0) {
				if (!preassayon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkPreAssay.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove Pre-Assay Procedure");	
				}
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
    	
		btnPreassay.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				resetScreen();
				if (!preassayon)
				{
					preassayon = true;
					if (mrdon && dilon && assayon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(clistener);
						btnNewButton_3.setText("Pre-Assay");
						label_2.setVisible(true);
						btnNewButton_4.setVisible(true);
//						btnNewButton_4.addActionListener(dlistener);
						btnNewButton_4.setText("Assay");
					}
					else if (mrdon && dilon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(clistener);
						btnNewButton_3.setText("Pre-Assay");
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (mrdon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						btnNewButton_2.setText("Pre-Assay");
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(clistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
//						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (dilon)
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						btnNewButton_2.setText("Pre-Assay");
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(clistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
//						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else
					{
						btnNewButton_1.setVisible(true);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.addActionListener(clistener);
						btnNewButton_1.setText("Pre-Assay");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
//						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
				}
				else
				{
					preassayon = false;
					assayon = false;
				    setpassaylabindex(0);
				    setpkmpassayul("");
				    setassaylabindex(0);
				    setpkmassayul("");
					if (mrdon && dilon && assayon)
					{
						btnNewButton_1.setText("MRD");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(clistener);
						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(false);	
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
//						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);	
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (mrdon && dilon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(false);	
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						label_2.setVisible(false);	
						btnNewButton_4.setVisible(false);
//						btnNewButton_3.removeActionListener(clistener);
					}
					else if (mrdon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (dilon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.setVisible(false);
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
				}
			}
		});
		panel.add(btnPreassay);
		
		btnAssay = new JButton("ASSAY");
		
		btnAssay.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {
				if (!assayon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkAssay.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove Assay Procedure");	
				}
			}
			public void mouseEntered(MouseEvent arg0) {
				if (!assayon){
					VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkAssay.png", -1, "", 360, 220);			
				}else{
					PanelPKB2.lblPkBlank.setIcon(new ImageIcon(""));
					PanelPKB2.lblPkBlank.setText("Remove Assay Procedure");	
				}
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
		
		btnAssay.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				resetScreen();
				if (!assayon)
				{
					assayon = true;
					if (mrdon && dilon && preassayon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
//						btnNewButton_3.addActionListener(clistener);
						btnNewButton_3.setText("Pre-Assay");
						label_2.setVisible(true);
						btnNewButton_4.setVisible(true);
						ActionListener[] lis4 = btnNewButton_4.getActionListeners();
						if (lis4.length > 0);
						{
						      for (int i = 0; i < lis4.length; i++) {
									btnNewButton_4.removeActionListener(lis4[i]);
						      }
						}
						btnNewButton_4.addActionListener(dlistener);
						btnNewButton_4.setText("Assay");
					}
					else if (mrdon && dilon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (mrdon && preassayon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.setText("Pre-Assay");
						btnNewButton_2.addActionListener(clistener);
						label_1.setVisible(true);
						btnNewButton_3.setVisible(true);
						btnNewButton_3.addActionListener(dlistener);
						btnNewButton_3.setText("Assay");
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (dilon && preassayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(clistener);
						btnNewButton_2.setText("Pre-Assay");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						btnNewButton_3.addActionListener(dlistener);
						btnNewButton_3.setText("Assay");
						label_1.setVisible(true);	
						btnNewButton_3.setVisible(true);
					}
					else if (dilon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(blistener);
						btnNewButton_1.setText("Dilution");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(dlistener);
						btnNewButton_2.setText("Assay");
					}
					else if (preassayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(clistener);
						btnNewButton_1.setText("Pre-Assay");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.addActionListener(dlistener);
						btnNewButton_2.setText("Assay");
					}
					else if (mrdon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(false);	
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
					}
					else
					{
						btnNewButton_1.setVisible(false);
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
				}
				else
				{
					assayon = false;
					setassaylabindex(0);
					if (mrdon && dilon && preassayon)
					{
						btnNewButton_1.setText("MRD");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(true);	
						btnNewButton_3.setVisible(true);
						btnNewButton_3.setText("Pre-Assay");
//						btnNewButton_3.addActionListener(clistener);
						label_2.setVisible(false);	
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
						
					}
					else if (mrdon && dilon)
					{
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);	
						btnNewButton_2.setVisible(true);
//						btnNewButton_2.addActionListener(blistener);
						btnNewButton_2.setText("Dilution");
						label_1.setVisible(false);	
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);	
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
					else if (mrdon && preassayon)
					{
						btnNewButton_1.setVisible(true);
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.setText("Pre-Assay");
						btnNewButton_2.addActionListener(clistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						ActionListener[] lis4 = btnNewButton_4.getActionListeners();
						if (lis4.length > 0);
						{
						      for (int i = 0; i < lis4.length; i++) {
									btnNewButton_4.removeActionListener(lis4[i]);
						      }
						}
					}
					else if (dilon && preassayon)
					{
						ActionListener[] lis1 = btnNewButton_1.getActionListeners();
						if (lis1.length > 0);
						{
						      for (int i = 0; i < lis1.length; i++) {
									btnNewButton_1.removeActionListener(lis1[i]);
						      }
						}
						btnNewButton_1.setText("Dilution");
						btnNewButton_1.setVisible(true);
						btnNewButton_1.addActionListener(blistener);
						
						label.setVisible(true);
						btnNewButton_2.setVisible(true);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
						btnNewButton_2.setText("Pre-Assay");
						btnNewButton_2.addActionListener(clistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						ActionListener[] lis3 = btnNewButton_3.getActionListeners();
						if (lis3.length > 0);
						{
						      for (int i = 0; i < lis3.length; i++) {
									btnNewButton_3.removeActionListener(lis3[i]);
						      }
						}
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						ActionListener[] lis4 = btnNewButton_4.getActionListeners();
						if (lis4.length > 0);
						{
						      for (int i = 0; i < lis4.length; i++) {
									btnNewButton_4.removeActionListener(lis4[i]);
						      }
						}
					}
					else if (mrdon)
					{
//						btnNewButton_1.addActionListener(alistener);
						btnNewButton_1.setText("MRD");
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
						setassaylabindex(0);
					}
					else if (preassayon)
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
						btnNewButton_1.addActionListener(clistener);
						btnNewButton_1.setText("Pre-Assay");
						label.setVisible(false);	
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
					}
					else
					{
						ActionListener[] lis = btnNewButton_1.getActionListeners();
						if (lis.length > 0);
						{
						      for (int i = 0; i < lis.length; i++) {
									btnNewButton_1.removeActionListener(lis[i]);
						      }
						}
//						btnNewButton_1.removeActionListener(alistener);
						btnNewButton_1.setVisible(false);
						label.setVisible(false);
						btnNewButton_2.setVisible(false);
						ActionListener[] lis2 = btnNewButton_2.getActionListeners();
						if (lis2.length > 0);
						{
						      for (int i = 0; i < lis2.length; i++) {
									btnNewButton_2.removeActionListener(lis2[i]);
						      }
						}
//						btnNewButton_2.removeActionListener(blistener);
						label_1.setVisible(false);
						btnNewButton_3.setVisible(false);
						btnNewButton_3.removeActionListener(clistener);
						label_2.setVisible(false);
						btnNewButton_4.setVisible(false);
						btnNewButton_4.removeActionListener(dlistener);
					}
				}
			}
		});
		panel.add(btnAssay);
		
		JPanel panel_top = new JPanel();
		add(panel_top, BorderLayout.NORTH);
		GridBagLayout gbl_panel_top = new GridBagLayout();
		gbl_panel_top.columnWidths = new int[]{110, 450, 0};
		gbl_panel_top.rowHeights = new int[]{23, 0};
		gbl_panel_top.columnWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_top.rowWeights = new double[]{0.0, Double.MIN_VALUE};
		panel_top.setLayout(gbl_panel_top);
		panel_top.setBackground(this.panelColor);
		
		btnNewButton = new JButton("LIMS/LIS     ");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
		          watsonFile();
			}
		});
		btnNewButton.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_btnNewButton = new GridBagConstraints();
		gbc_btnNewButton.anchor = GridBagConstraints.WEST;
		gbc_btnNewButton.fill = GridBagConstraints.VERTICAL;
		gbc_btnNewButton.insets = new Insets(0, 0, 0, 5);
		gbc_btnNewButton.gridx = 0;
		gbc_btnNewButton.gridy = 0;
		panel_top.add(btnNewButton, gbc_btnNewButton);
		
		pkm_text_wat = new JTextField();
		GridBagConstraints gbc_pkm_text_wat = new GridBagConstraints();
		gbc_pkm_text_wat.fill = GridBagConstraints.BOTH;
		gbc_pkm_text_wat.gridx = 1;
		gbc_pkm_text_wat.gridy = 0;
		panel_top.add(pkm_text_wat, gbc_pkm_text_wat);
		pkm_text_wat.setColumns(10);
		
		JPanel panel_1 = new JPanel();	//This panel holds panel_3 and panel_4
		add(panel_1, BorderLayout.CENTER);
		GridBagLayout gbl_panel_1 = new GridBagLayout();
		gbl_panel_1.columnWidths = new int[]{30, 555, 0};
		gbl_panel_1.rowHeights = new int[]{58, 85, 90, 0};
		gbl_panel_1.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panel_1.rowWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		panel_1.setBackground(this.panelColor);
		panel_1.setLayout(gbl_panel_1);
	
		panel_3 = new JPanel();
	    TitledBorder panel_3Border = BorderFactory.createTitledBorder("");
	    panel_3Border.setTitleJustification(2);
	    panel_3Border.setTitlePosition(3);
	    panel_3.setBorder(panel_3Border);
	    
		panel_3.setLayout(new GridLayout(1, 7));
		panel_3.setSize(200, 500);
		panel_3.setBackground(panelColor);
		GridBagConstraints gbc_panel_3 = new GridBagConstraints();
		gbc_panel_3.fill = GridBagConstraints.BOTH;
		gbc_panel_3.insets = new Insets(0, 0, 5, 10);
		gbc_panel_3.gridx = 1;
		gbc_panel_3.gridy = 1;
		panel_1.add(panel_3, gbc_panel_3);
		
		btnNewButton_1 = new JButton("1");
		btnNewButton_1.setBackground(newColorBlueT2);
		btnNewButton_1.setFont(font15);
		btnNewButton_1.setForeground(Color.WHITE);
		btnNewButton_1.setVisible(false);
		panel_3.add(btnNewButton_1);
		
		label = new JLabel(iconArrow);
		label.setVisible(false);
		panel_3.add(label);
		
		btnNewButton_2 = new JButton("2");
		btnNewButton_2.setBackground(newColorBlueT2);
		btnNewButton_2.setFont(font15);
		btnNewButton_2.setForeground(Color.WHITE);
		btnNewButton_2.setVisible(false);
		panel_3.add(btnNewButton_2);
		
		label_1 = new JLabel(iconArrow);
		label_1.setVisible(false);
		panel_3.add(label_1);
		
		btnNewButton_3 = new JButton("3");
		btnNewButton_3.setBackground(newColorBlueT2);
		btnNewButton_3.setFont(font15);
		btnNewButton_3.setForeground(Color.WHITE);
		btnNewButton_3.setVisible(false);
		panel_3.add(btnNewButton_3);
		
		label_2 = new JLabel(iconArrow);
		label_2.setVisible(false);
		panel_3.add(label_2);
		
		btnNewButton_4 = new JButton("4");
		btnNewButton_4.setBackground(newColorBlueT2);
		btnNewButton_4.setFont(font15);
		btnNewButton_4.setForeground(Color.WHITE);
		btnNewButton_4.setVisible(false);
		panel_3.add(btnNewButton_4);
		
		panel_4 = new JPanel();
//		panel_4.setBorder(this.blackline);
		panel_4.setBackground(this.panelColor);
		GridBagConstraints gbc_panel_4 = new GridBagConstraints();
		gbc_panel_4.gridheight = 2;
		gbc_panel_4.fill = GridBagConstraints.BOTH;
		gbc_panel_4.gridx = 1;
		gbc_panel_4.gridy = 2;
		gbc_panel_4.insets = new Insets(0, 0, 5, 10);
		GridBagLayout gbl_panel_4 = new GridBagLayout();
		gbl_panel_4.columnWidths = new int[]{10, 10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10};
		gbl_panel_4.rowHeights = new int[]{10, 10, 10, 10, 0};
		gbl_panel_4.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_4.rowWeights = new double[]{0.0, Double.MIN_VALUE};
		panel_4.setLayout(gbl_panel_4);
		

		
		panelblank = new PanelPKB();
		panelblank2 = new PanelPKB2();

		GridBagConstraints gbc_lblNewLabel_4 = new GridBagConstraints();
		gbc_lblNewLabel_4.fill = GridBagConstraints.HORIZONTAL;
		gbc_lblNewLabel_4.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblNewLabel_4.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_4.gridx = 1;
		gbc_lblNewLabel_4.gridy = 0;
//		panel_4.add(panelblank, gbc_lblNewLabel_4);
		
		lblNewLabel_5 = new JLabel("New label");
		GridBagConstraints gbc_lblNewLabel_5 = new GridBagConstraints();
		gbc_lblNewLabel_5.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_5.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblNewLabel_5.gridx = 2;
		gbc_lblNewLabel_5.gridy = 0;
//		panel_4.add(panelblank2, gbc_lblNewLabel_5);
		
		panel_1.add(panel_4, gbc_panel_4);
		resetScreen();
		
	}

	  private void watsonFile()
	  {
	    int state = getJFileChooser3().showOpenDialog(this);
	    if (state == 0) {
	      File f = jFileChooser3.getSelectedFile();
	      this.path = f.getPath();

	      if (VAStools.PK_WorklistConfirm(this.path)){			//PKF0033
	          this.pkm_text_wat.setText(this.path);
	          this.pkm_text_wat.setEditable(false);
	      }else{
	    	  this.pkm_text_wat.setText("");
	      }
	    }
	  }
	  
	  class DirectoryRestrictedFileSystemView extends FileSystemView
	  {
	      private final File[] rootDirectories;

	      DirectoryRestrictedFileSystemView(File rootDirectory)
	      {
	          this.rootDirectories = new File[] {rootDirectory};
	      }

	      DirectoryRestrictedFileSystemView(File[] rootDirectories)
	      {
	          this.rootDirectories = rootDirectories;
	      }

	      @Override
	      public File createNewFolder(File containingDir) throws IOException
	      {       
	          throw new UnsupportedOperationException("Unable to create directory");
	      }

	      @Override
	      public File[] getRoots()
	      {
	          return rootDirectories;
	      }

	      @Override
	      public boolean isRoot(File file)
	      {
	          for (File root : rootDirectories) {
	              if (root.equals(file)) {
	                  return true;
	              }
	          }
	          return false;
	      }
	      
	      @Override
	      public File getHomeDirectory()
	      {
	        return rootDirectories[0];
	      }
	  }
	  
	  private JFileChooser getJFileChooser3()
	  {
		  
		  jFileChooser3 = null;
		  File[] array_file = new File[TabWindow.directorySelect.arrayList_directoryData.size()];

		  for (int i=0; i < TabWindow.directorySelect.arrayList_directoryData.size(); i++){
			  array_file[i] = new File(TabWindow.directorySelect.arrayList_directoryData.get(i));
		  }

		  
	    if (this.jFileChooser3 == null) {

	      FileSystemView fsv = new DirectoryRestrictedFileSystemView(array_file);
	      if (TabWindow.security){
	    	  this.jFileChooser3 = new JFileChooser(fsv.getHomeDirectory(),fsv);
	      }else{
	    	  this.jFileChooser3 = new JFileChooser();
	      }
	      
	      
	      jFileChooser3.setDialogTitle("Select Worklist");
	      this.jFileChooser3.setApproveButtonText("Select");
	      this.jFileChooser3.setMultiSelectionEnabled(false);
	      this.jFileChooser3.setAcceptAllFileFilterUsed(false);
	      FileFilter filter3 = new textFileFilter(".txt or .pdf or .xls", new String[] { "TXT","PDF","XLS" });
	      this.jFileChooser3.setFileFilter(filter3);
	    }
	    return this.jFileChooser3;
	  }

		
		// Panel 1 - get and set functions
		

		public String getpkmtextwat()
		{
			return this.pkm_text_wat.getText();
		}
		public void setpkmtextwat(String s)
		{
			this.pkm_text_wat.setText(s);
		}
		
		public void panel_3_reset()								//APN0053
		{
			btnNewButton_1.setVisible(false);
			label.setVisible(false);
			
			btnNewButton_2.setVisible(false);
			label_1.setVisible(false);
			
			btnNewButton_3.setVisible(false);
			label_2.setVisible(false);
			
			btnNewButton_4.setVisible(false);
		}
		
		// Panel 2 - get and set functions
		
		public String getpkmtext1()
		{
			if (mrdon)
			{
				return panel2.getpkmtext1();
			}
			else
			{
				return panel4.getpkmtext1();
			}
		}
		public void setpkmtext1(String s)
		{
			if (mrdon)
			{
				panel2.setpkmtext1(s);
			}
			else
			{
				panel4.setpkmtext1(s);
			}
		}
		public String getpkmtextul()
		{
			return panel2.getpkmtextul();
		}
		public void setpkmtextul(String s)
		{
			panel2.setpkmtextul(s);
		}
		public String getpkmsamdil()
		{
			if (mrdon)
			{
				return panel2.getpksamdil();
			}
			else
			{
				return panel3.getpksamdil();
			}
		}
		public String getpkmstddil()
		{
			if (mrdon)
			{
				return panel2.getpkstddil();
			}
			else
			{
				return panel4.getpkstddil();
			}
		}
		public String getpkmmrddil()
		{
			if (mrdon)
			{
				return panel2.getpkmrddil();
			}
			else
			{
				return panel4.getpkmrddil();
			}
		}
		public String getpkstdsrc()
		{
			if (mrdon)
			{
				return panel2.getpkstdsrc();
			}
			else
			{
				return panel4.getpkstdsrc();
			}
		}
		public String getpkssrc()
		{
			if (mrdon)
			{
				return panel2.getpkssrc();
			}
			else
			{
				return panel3.getpkssrc();
			}
		}
		public String getpkmrdsrc()
		{
			return panel2.getpkmrdsrc();
		}
		public String getpkdeck1()
		{
			if (mrdon)
			{
				return panel2.getpkdeck1();
			}
			else
			{
				return panel4.getpkdeck1();
			}
		}

		public void setmrdindex(int x)
		{
			panel2.setMRDsrcIndex(x);
		}
		public void setstdindex(int x)
		{
			if (mrdon)
			{
				panel2.setstdIndex(x);
			}
			else
			{
				panel4.setstdIndex(x);
			}
		}
		public void setsamindex(int x)
		{
			if (mrdon)
			{
				panel2.setsamIndex(x);
			}
			else
			{
				panel3.setsamIndex(x);
			}
		}
		public void setsamdilindex(int x)
		{
			if (mrdon)
			{
				panel2.setsamdilIndex(x);
			}
			else
			{
				panel3.setsamdilIndex(x);
			}
		}
		public void setstddilindex(int x)
		{
			if (mrdon)
			{
				panel2.setstddilIndex(x);
			}
			else
			{
				panel4.setstddilIndex(x);
			}
		}
		public void setmrddilindex(int x)
		{
			if (mrdon)
			{
				panel2.setmrddilIndex(x);
			}
			else
			{
				panel4.setmrddilIndex(x);
			}
		}
		public String getpkdilsrc1()
		{
			if (mrdon)
			{
			return panel2.getpkdilsrc();
			}
			else
			{
			return panel4.getpkdilsrc();
			}
		}
		public void setdeck1index(int x)
		{
			if (mrdon)
			{
				panel2.setdeck1index(x);
			}
			else
			{
				panel4.setdeck1index(x);
			}
		}
		// Panel 3 - get and set functions
		
		public String getpkdil()
		{
			return panel3.getpkdil();
		}
		public String getpkdilres()
		{
			return panel3.getpkdilres();
		}
		public String getpkdeck2()
		{
			return panel3.getDeck2();
		}
		public void setdilsrcindex(int x)
		{
			if (mrdon)
			{
				panel2.setdilsrcindex(x);
			}
			else
			{
				panel4.setdilsrcindex(x);
			}
		}
		public void setdilresindex(int x)
		{
			panel3.setdilrIndex(x);
		}
		public void setdeck2index(int x)
		{
			panel3.setdeck2Index(x);
		}
		public void setdilindex(int x)
		{
			panel3.setdilindex(x);
		}
		public String getpkdilsrc2()
		{
			return panel3.getpkdilsrc();
		}
		public void setdilsrcindex2(int x)
		{
			panel3.setdilsrcindex(x);
		}

		// Panel 4 - get and set functions
		
		public String getpkmpassayul()
		{
			return panel4.getpassayul();
		}
		public void setpkmpassayul(String s)
		{
			panel4.setpassayul(s);
		}
		public String getpassaylab()
		{
			return panel4.getpassaylab();
		}
		public void setpassaylabindex(int x)
		{
			panel4.setpassaylabindex(x);
		}
		public String getpkmassayul()
		{
			return panel5.getassayul();
		}
		public void setpkmassayul(String s)
		{
			panel5.setassayul(s);
		}
		public String getassaylab()
		{
			return panel5.getassaylab();
		}
		public void setassaylabindex(int x)
		{
			panel5.setassaylabindex(x);
		}
		
		public boolean getMRDon()
		{
			return mrdon;
		}
		public boolean getDILon()
		{
			return dilon;
		}
		public boolean getPRAon()
		{
			return preassayon;
		}
		public boolean getASSon()
		{
			return assayon;
		}
		public void setMRDon(boolean b)
		{
			mrdon = b;
		}
		public void setDILon(boolean b)
		{
			dilon = b;
		}
		public void setPRAon(boolean b)
		{
			preassayon = b;
		}
		public void setASSon(boolean b)
		{
			assayon = b;
		}

		public void resetScreen()
		{
		panel_4.removeAll();
		panel_4.add(panelblank);
		panel_4.add(panelblank2, get_gbc_panelblank2());
        panel_4.revalidate();
        panel_4.repaint();
		}
		
		public GridBagConstraints get_gbc_panelblank2(){
			GridBagConstraints gbc_panelblank2 = new GridBagConstraints();
			gbc_panelblank2.insets = new Insets(0, 20, 0, 0);
			return gbc_panelblank2;
		}
		
		public void resetPanel3()
		{
			if (mrdon)
			{
			if (mrdon && dilon && preassayon && assayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(alistener);
				btnNewButton_1.setText("MRD");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(blistener);
				btnNewButton_2.setText("Dilution");
				label_1.setVisible(true);
				btnNewButton_3.setVisible(true);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				btnNewButton_3.addActionListener(clistener);
				btnNewButton_3.setText("Pre-Assay");
				label_2.setVisible(true);
				btnNewButton_4.setVisible(true);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
				btnNewButton_4.addActionListener(dlistener);
				btnNewButton_4.setText("Assay");
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (mrdon && dilon && preassayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(alistener);
				btnNewButton_1.setText("MRD");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(blistener);
				btnNewButton_2.setText("Dilution");
				label_1.setVisible(true);
				btnNewButton_3.setVisible(true);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				btnNewButton_3.addActionListener(clistener);
				btnNewButton_3.setText("Pre-Assay");
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (mrdon && preassayon && assayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(alistener);
				btnNewButton_1.setText("MRD");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(clistener);
				btnNewButton_2.setText("Pre-Assay");
				label_1.setVisible(true);
				btnNewButton_3.setVisible(true);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				btnNewButton_3.addActionListener(dlistener);
				btnNewButton_3.setText("Assay");
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (mrdon && dilon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(alistener);
				btnNewButton_1.setText("MRD");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(blistener);
				btnNewButton_2.setText("Dilution");
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (mrdon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(alistener);
				btnNewButton_1.setText("MRD");
				label.setVisible(false);
				btnNewButton_2.setVisible(false);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
		} else if (dilon)
		  {
			if (dilon && preassayon && assayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(blistener);
				btnNewButton_1.setText("Dilution");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(clistener);
				btnNewButton_2.setText("Pre-Assay");
				label_1.setVisible(true);
				btnNewButton_3.setVisible(true);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				btnNewButton_3.addActionListener(dlistener);
				btnNewButton_3.setText("Assay");
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (dilon && preassayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(blistener);
				btnNewButton_1.setText("Dilution");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(clistener);
				btnNewButton_2.setText("Pre-Assay");
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (dilon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(blistener);
				btnNewButton_1.setText("Dilution");
				label.setVisible(false);
				btnNewButton_2.setVisible(false);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			} 
		} else if (preassayon)
		{
			if (preassayon && assayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(clistener);
				btnNewButton_1.setText("Pre-Assay");
				label.setVisible(true);
				btnNewButton_2.setVisible(true);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				btnNewButton_2.addActionListener(dlistener);
				btnNewButton_2.setText("Assay");
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			else if (preassayon)
			{
				btnNewButton_1.setVisible(true);
				ActionListener[] lis = btnNewButton_1.getActionListeners();
				if (lis.length > 0);
				{
				      for (int i = 0; i < lis.length; i++) {
							btnNewButton_1.removeActionListener(lis[i]);
				      }
				}
				btnNewButton_1.addActionListener(clistener);
				btnNewButton_1.setText("Pre-Assay");
				label.setVisible(false);
				btnNewButton_2.setVisible(false);
				ActionListener[] lis2 = btnNewButton_2.getActionListeners();
				if (lis2.length > 0);
				{
				      for (int i = 0; i < lis2.length; i++) {
							btnNewButton_2.removeActionListener(lis2[i]);
				      }
				}
				label_1.setVisible(false);
				btnNewButton_3.setVisible(false);
				ActionListener[] lis3 = btnNewButton_3.getActionListeners();
				if (lis3.length > 0);
				{
				      for (int i = 0; i < lis3.length; i++) {
							btnNewButton_3.removeActionListener(lis3[i]);
				      }
				}
				label_2.setVisible(false);
				btnNewButton_4.setVisible(false);
				ActionListener[] lis4 = btnNewButton_4.getActionListeners();
				if (lis4.length > 0);
				{
				      for (int i = 0; i < lis4.length; i++) {
							btnNewButton_4.removeActionListener(lis4[i]);
				      }
				}
		        panel_3.revalidate();
		        panel_3.repaint();
			}
			
		}

		}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
