/**
 * AutoPilot
 * Copyright 	- Telos Scientific - 
 * Author 		- Jesse A. Campbell
 * Description	- PK MRD window (Auto Pilot 1.0) 
 * Written 		- 01/05/2014

**/

package TelosV2Pkg;

import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.JPanel;

import java.awt.GridBagLayout;

import javax.swing.JLabel;

import java.awt.GridBagConstraints;

import javax.swing.JTextField;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JComboBox;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import TelosV2Pkg.PanelPK3.DiluentComboBoxRenderer;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;

public class PanelPK2 extends JPanel {
	///////////////////////////////////////////
	// MRD PROPERTIES PANEL
	
	private JTextField pkm_text_1;
	private JTextField pkm_text_ul;
	JComboBox pkMRDsource = null;
	JComboBox pkdeck1 = null;
	JComboBox pkSsource = null;
	JComboBox pkSTDsource = null;
	JComboBox pksamdil = null;
	JComboBox pkstddil = null;
	JComboBox pkDilsource = null;
	JComboBox pkmrddil = null;

	private int deck1index;
	private int patcount = 0; 
	private String deck1;
	private String mrdlab;
	private String samlab;
	private String stdlab;
	private String dillab;
	private String samliq;
	private String stdliq;
	private String dilliq;
    private int mrdlindex = 0;
    private int samlindex = 0;
    private int stdlindex = 0;
    private int dillindex = 0;
    private int samliqindex = 0;
    private int stdliqindex = 0;
    private int dilliqindex = 0;
    private Color panelColor = new Color(248, 248, 255);

    public PanelPK2(String[] plates, String[] tubes, String[] deckpositions, String[] reservoirs, String[] liqtypes) {
    	
		addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {
				//VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkMrd.png", -1, "", 360, 220);
				VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
		
		  String [] platesAll = new String [plates.length + 1];
		  String [] tubesAll = new String [tubes.length];
		  String [] reservoirsAll = new String [reservoirs.length];
	      platesAll[0] = "Select labware type" ;
	      for (int i = 0; i < plates.length; i++) {
	          platesAll[i + 1] = plates[i] ;
	        }
	      for (int i = 1; i < tubes.length; i++) {
	          tubesAll[i] = tubes[i] ;
	        }
	      for (int i = 0; i < reservoirs.length; i++) {
	          reservoirsAll[i] = reservoirs[i] ;
	        }
		  String [] decks  = new String [deckpositions.length];
	      decks[0] = "Deck pos" ;
	      for (int i = 1; i < deckpositions.length; i++) {
	          decks[i] = deckpositions[i] ;
	        }
 		  String [] liqTypes = new String [liqtypes.length];
	      for (int i = 0; i < liqtypes.length; i++) {
	          liqTypes[i] = liqtypes[i] ;
	        }
	      patcount = 0;									//AP-0001

	      String [] platesTubes = new String [plates.length + tubes.length];
	      platesTubes[0] = "Select labware type" ;
		  patcount ++;
	      for (int i = 0; i < plates.length; i++) {
	          platesTubes[patcount] = plates[i] ;
	    	  patcount ++;
	        }
	      for (int i = 1; i < tubes.length; i++) {
	          platesTubes[patcount] = tubes[i] ;
	    	  patcount ++;
	        }

		setSize(new Dimension(810, 240));
		setMinimumSize(new Dimension(810, 240));
	    TitledBorder mrdBorder2 = BorderFactory.createTitledBorder("MRD Properties");
	    mrdBorder2.setTitleJustification(2);
	    mrdBorder2.setTitlePosition(2);
	    mrdBorder2.setTitleFont(new Font("Arial", Font.BOLD, 15));
	    setBorder(mrdBorder2);

		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		setBackground(this.panelColor);
		
		JLabel lblLabware = new JLabel("Labware");
		lblLabware.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLabware = new GridBagConstraints();
		gbc_lblLabware.insets = new Insets(20, 0, 5, 5);
		gbc_lblLabware.gridx = 7;
		gbc_lblLabware.gridy = 1;
		add(lblLabware, gbc_lblLabware);
		
		JLabel lblLiquid = new JLabel("Liquid");
		lblLiquid.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLiquid = new GridBagConstraints();
		gbc_lblLiquid.insets = new Insets(20, 0, 5, 5);
		gbc_lblLiquid.gridx = 8;
		gbc_lblLiquid.gridy = 1;
		add(lblLiquid, gbc_lblLiquid);
		
		JLabel lblPosition = new JLabel("Position");
		lblPosition.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblPosition = new GridBagConstraints();
		gbc_lblPosition.insets = new Insets(20, 0, 5, 5);
		gbc_lblPosition.gridx = 9;
		gbc_lblPosition.gridy = 1;
		add(lblPosition, gbc_lblPosition);
		
//		JLabel lblNewLabel_1 = new JLabel("");
//		GridBagConstraints gbc_lblNewLabel_1 = new GridBagConstraints();
//		gbc_lblNewLabel_1.insets = new Insets(0, 0, 5, 0);
//		gbc_lblNewLabel_1.gridx = 10;
//		gbc_lblNewLabel_1.gridy = 1;
//		add(lblNewLabel_1, gbc_lblNewLabel_1);
		
//		JLabel label_2 = new JLabel("");
//		GridBagConstraints gbc_label_2 = new GridBagConstraints();
//		gbc_label_2.insets = new Insets(0, 0, 5, 5);
//		gbc_label_2.gridx = 0;
//		gbc_label_2.gridy = 3;
//		add(label_2, gbc_label_2);
		
		JLabel label = new JLabel("1:");
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.anchor = GridBagConstraints.EAST;
		gbc_label.gridx = 1;
		gbc_label.gridy = 3;
		add(label, gbc_label);
		
		pkm_text_1 = new JTextField();
		GridBagConstraints gbc_pkm_text_1 = new GridBagConstraints();
		gbc_pkm_text_1.insets = new Insets(0, 0, 5, 5);
		gbc_pkm_text_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkm_text_1.gridx = 2;
		gbc_pkm_text_1.gridy = 3;
		add(pkm_text_1, gbc_pkm_text_1);
		pkm_text_1.setColumns(5);
		
		JLabel lblIn = new JLabel("in");
		GridBagConstraints gbc_lblIn = new GridBagConstraints();
		gbc_lblIn.insets = new Insets(0, 0, 5, 5);
		gbc_lblIn.anchor = GridBagConstraints.EAST;
		gbc_lblIn.gridx = 3;
		gbc_lblIn.gridy = 3;
		add(lblIn, gbc_lblIn);
		
		pkm_text_ul = new JTextField();
		GridBagConstraints gbc_pkm_text_ul = new GridBagConstraints();
		gbc_pkm_text_ul.insets = new Insets(0, 0, 5, 5);
		gbc_pkm_text_ul.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkm_text_ul.gridx = 4;
		gbc_pkm_text_ul.gridy = 3;
		add(pkm_text_ul, gbc_pkm_text_ul);
		pkm_text_ul.setColumns(10);
		
		JLabel lblNewLabel = new JLabel("ul");
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.gridx = 5;
		gbc_lblNewLabel.gridy = 3;
		add(lblNewLabel, gbc_lblNewLabel);
		
		JLabel label_1 = new JLabel("     ");
		GridBagConstraints gbc_label_1 = new GridBagConstraints();
		gbc_label_1.insets = new Insets(0, 0, 5, 5);
		gbc_label_1.anchor = GridBagConstraints.EAST;
		gbc_label_1.gridx = 6;
		gbc_label_1.gridy = 3;
		add(label_1, gbc_label_1);
		
		pkMRDsource = new JComboBox(platesAll);
		
		pkMRDsource.setRenderer(new MyComboBoxRenderer());
		
		pkMRDsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, mrdlab+".png", mrdlindex, "Please Select the MRD Plate Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		GridBagConstraints gbc_pkMRDsource = new GridBagConstraints();
		gbc_pkMRDsource.insets = new Insets(0, 0, 5, 5);
		gbc_pkMRDsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkMRDsource.gridx = 7;
		gbc_pkMRDsource.gridy = 3;
        mrdlindex = this.pkMRDsource.getSelectedIndex();
	    pkMRDsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        mrdlab = ((String)cb.getSelectedItem());
	            mrdlindex = (cb.getSelectedIndex());
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkMRDsource, gbc_pkMRDsource);
		
		JLabel lblSamples = new JLabel("Samples:");
		GridBagConstraints gbc_lblSamples = new GridBagConstraints();
		gbc_lblSamples.insets = new Insets(0, 0, 5, 5);
		gbc_lblSamples.anchor = GridBagConstraints.EAST;
		gbc_lblSamples.gridx = 4;
		gbc_lblSamples.gridy = 4;
		add(lblSamples, gbc_lblSamples);
		
		

		pkSsource = new JComboBox(platesTubes);
		pkSTDsource = new JComboBox(platesTubes);
		
		pkSsource.setRenderer(new MyComboBoxRenderer());
		pkSTDsource.setRenderer(new MyComboBoxRenderer());
		
		pkSsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, samlab+".png", samlindex, "Please Select the Labware Type for the Samples", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		pkSTDsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, stdlab+".png", stdlindex, "Please Select the Labware Type for the Standards", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		GridBagConstraints gbc_pkSsource = new GridBagConstraints();
		gbc_pkSsource.insets = new Insets(0, 0, 5, 5);
		gbc_pkSsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkSsource.gridx = 7;
		gbc_pkSsource.gridy = 4;
        samlindex = this.pkSsource.getSelectedIndex();
        samlab = ((String)this.pkSsource.getSelectedItem());
	    pkSsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        samlab = ((String)cb.getSelectedItem());
	            samlindex = (cb.getSelectedIndex());
	            if (samlab.contains("_96") && (stdlab.contains("_96") || stdlindex == 0)){
	          	  pkSTDsource.setSelectedIndex(pkSsource.getSelectedIndex());
	            }
	            if (samlab.contains("_Tube") && (stdlab.contains("_96") || stdlindex == 0)){
	          	  pkSTDsource.setSelectedIndex(pkSsource.getSelectedIndex());
	            }
	            
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);

		      } } );
		add(pkSsource, gbc_pkSsource);
		
		pksamdil = new JComboBox(liqTypes);
		
		GridBagConstraints gbc_pksamdil = new GridBagConstraints();
		gbc_pksamdil.insets = new Insets(0, 0, 5, 5);
		gbc_pksamdil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pksamdil.gridx = 8;
		gbc_pksamdil.gridy = 4;
        samliqindex = this.pksamdil.getSelectedIndex();
        samliq = ((String)this.pksamdil.getSelectedItem());
        pksamdil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        samliq = ((String)cb.getSelectedItem());
	            samliqindex = (cb.getSelectedIndex());

		      } } );
		add(pksamdil, gbc_pksamdil);
		
		JLabel lblStandards = new JLabel("Standards/QCs:");
		GridBagConstraints gbc_lblStandards = new GridBagConstraints();
		gbc_lblStandards.insets = new Insets(0, 0, 5, 5);
		gbc_lblStandards.anchor = GridBagConstraints.EAST;
		gbc_lblStandards.gridx = 4;
		gbc_lblStandards.gridy = 5;
		add(lblStandards, gbc_lblStandards);
		
		GridBagConstraints gbc_pkSTDsource = new GridBagConstraints();
		gbc_pkSTDsource.insets = new Insets(0, 0, 5, 5);
		gbc_pkSTDsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkSTDsource.gridx = 7;
		gbc_pkSTDsource.gridy = 5;
        stdlindex = this.pkSTDsource.getSelectedIndex();
        stdlab = ((String)this.pkSTDsource.getSelectedItem());
	    pkSTDsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        stdlab = ((String)cb.getSelectedItem());
	            stdlindex = (cb.getSelectedIndex());
	            if (stdlab.contains("_96")){
	          	  pkSsource.setSelectedIndex(pkSTDsource.getSelectedIndex());
	            }
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkSTDsource, gbc_pkSTDsource);
		
		pkstddil = new JComboBox(liqTypes);
		GridBagConstraints gbc_pkstddil = new GridBagConstraints();
		gbc_pkstddil.insets = new Insets(0, 0, 5, 5);
		gbc_pkstddil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkstddil.gridx = 8;
		gbc_pkstddil.gridy = 5;
        stdliqindex = this.pkstddil.getSelectedIndex();
        stdliq = ((String)this.pksamdil.getSelectedItem());
	    pkstddil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        stdliq = ((String)cb.getSelectedItem());
	            stdliqindex = (cb.getSelectedIndex());
		      } } );
		add(pkstddil, gbc_pkstddil);
		
		JLabel lblDiluent = new JLabel("Diluent:");
		GridBagConstraints gbc_lblDiluent = new GridBagConstraints();
		gbc_lblDiluent.insets = new Insets(0, 0, 0, 5);
		gbc_lblDiluent.anchor = GridBagConstraints.EAST;
		gbc_lblDiluent.gridx = 4;
		gbc_lblDiluent.gridy = 6;
		add(lblDiluent, gbc_lblDiluent);
		
		pkDilsource = new JComboBox(reservoirs);
		
		pkDilsource.setRenderer(new DiluentComboBoxRenderer());
		
		pkDilsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, dillab+".png", dillindex, "Please Select the Diluent Reservoir Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		
		GridBagConstraints gbc_pkDilsource = new GridBagConstraints();
		gbc_pkDilsource.insets = new Insets(0, 0, 0, 5);
		gbc_pkDilsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkDilsource.gridx = 7;
		gbc_pkDilsource.gridy = 6;
        dillindex = this.pkDilsource.getSelectedIndex();
	    pkDilsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dillab = ((String)cb.getSelectedItem());
	            dillindex = (cb.getSelectedIndex());
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkDilsource, gbc_pkDilsource);
		
		pkmrddil = new JComboBox(liqTypes);
		GridBagConstraints gbc_pkmrddil = new GridBagConstraints();
		gbc_pkmrddil.insets = new Insets(0, 0, 0, 5);
		gbc_pkmrddil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkmrddil.gridx = 8;
		gbc_pkmrddil.gridy = 6;
        dilliqindex = this.pkmrddil.getSelectedIndex();
        dilliq = ((String)this.pkmrddil.getSelectedItem());
	    pkmrddil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dilliq = ((String)cb.getSelectedItem());
	            dilliqindex = (cb.getSelectedIndex());
		      } } );
		add(pkmrddil, gbc_pkmrddil);

		pkdeck1 = new JComboBox(decks);
		GridBagConstraints gbc_pkdeck1 = new GridBagConstraints();
		gbc_pkdeck1.insets = new Insets(0, 0, 0, 5);
		gbc_pkdeck1.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkdeck1.gridx = 9;
		gbc_pkdeck1.gridy = 6;
        deck1index = this.pkdeck1.getSelectedIndex();
	    pkdeck1.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck1 = ((String)cb.getSelectedItem());
	            deck1index = (cb.getSelectedIndex());
		      } } );
		add(pkdeck1, gbc_pkdeck1);
	}
    
    class MyComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {
        		
        		int width = 273; int height = 148;
        		if (String.valueOf(value).contains("_Tube")){width = 43; height = 118;}
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Plate Type", width, height);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else{
                setOpaque(true);
                setBackground(list.getBackground());
                setForeground(list.getForeground());
        	}	        		
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          return this;
        }
    }
    
    class DiluentComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {	
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Diluent Reservoir Type", 273, 148);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else{
                setOpaque(true);
                setBackground(list.getBackground());
                setForeground(list.getForeground());
        	}	        		
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          return this;
        }
    }
    

	public String getpkmtext1()
	{
		String text = pkm_text_1.getText();
		return text;
	}
	public String getpkmtextul()
	{
		return pkm_text_ul.getText();
	}
	public void setpkmtext1(String s)
	{
		pkm_text_1.setText(s);
	}
	public void setpkmtextul(String s)
	{
		pkm_text_ul.setText(s);
	}

	public String getpksamdil()
	{
			return samliq;
	}
	public String getpkmrddil()
	{
			return dilliq;
	}
	public String getpkstddil()
	{
			return stdliq;
	}
	public String getpkmrdsrc()
	{
		if (mrdlindex > 0)
		{	
			return mrdlab;
		}
			else
		{
			return "0";
		}
	}
	public String getpkssrc()
	{
		if (samlindex > 0)
		{	
			return samlab;
		}
		else
		{
			return "0";
		}
	}
	public String getpkstdsrc()
	{
		if (stdlindex > 0)
		{	
			return stdlab;
		}
		else
		{
			return "0";
		}
	}
	public String getpkdilsrc()
	{
		if (dillindex > 0)
		{	
			return dillab;
		}
		else
		{
			return "0";
		}
	}
	
	public void setMRDsrcIndex( int index ){
		if (index > 0)
		{
			pkMRDsource.setSelectedIndex(index);
		}
		else
		{
			pkMRDsource.setSelectedIndex(0);
		}
	}

	public void setsamIndex( int index ){
		if (index > 0)
		{
			pkSsource.setSelectedIndex(index);
		}
		else
		{
			pkSsource.setSelectedIndex(0);
		}
	}

	public void setdilsrcindex( int index ){
		if (index > 0)
		{
			pkDilsource.setSelectedIndex(index);
		}
		else
		{
			pkDilsource.setSelectedIndex(0);
		}
	}

	public void setstdIndex( int index ){
		if (index > 0)
		{
			pkSTDsource.setSelectedIndex(index);
		}
		else
		{
			pkSTDsource.setSelectedIndex(0);
		}
	}
	public void setsamdilIndex( int index ){
		if (index > 0)
		{
			pksamdil.setSelectedIndex(index);
		}
		else
		{
			pksamdil.setSelectedIndex(0);
		}
	}
	public void setstddilIndex( int index ){
		if (index > 0)
		{
			pkstddil.setSelectedIndex(index);
		}
		else
		{
			pkstddil.setSelectedIndex(0);
		}
	}
	public void setmrddilIndex( int index ){
		if (index > 0)
		{
			pkmrddil.setSelectedIndex(index);
		}
		else
		{
			pkmrddil.setSelectedIndex(0);
		}
	}

	public void setdeck1index( int index ){
		if (index > 0)
		{
			pkdeck1.setSelectedIndex(index);
		}
		else
		{
			pkdeck1.setSelectedIndex(0);
		}
	}

	public String getpkdeck1() {
		if (deck1 == null )
		{
			return "0";
		}
		if (deck1.equals("Deck pos"))
		{
			return "0";
		}
		else
		{
			return deck1;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
