/**
 * AutoPilot
 * Copyright 	- Telos Scientific - 
 * Author 		- Jesse A. Campbell
 * Description	- PK Dilution window (Auto Pilot 1.0) 
 * Written 		- 01/05/2014
 * 
**/

package TelosV2Pkg;

import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import java.awt.GridBagLayout;

import javax.swing.JLabel;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JComboBox;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import TelosV2Pkg.PanelPK5.MyComboBoxRenderer;


import java.awt.Font;

public class PanelPK3 extends JPanel {
    Border blackline = BorderFactory.createLineBorder(Color.black);
	JComboBox pkSsource = null;
	JComboBox pksamdil = null;
	JComboBox pkDSource = null;
	JComboBox pkDilreserve = null;
	JComboBox pkdil = null;
	JComboBox pkdeck2 = null;

	JLabel lblMrd = null;
	JLabel lblDilPlate = null;
	
	private String deck2;
	private String dillab;
	private String dilres;
	private String dilliq;
	private String samlab;
	private String samliq;

	private int dillindex = 0;
    private int dilrindex = 0;
    private int dilliqindex = 0;
    private int mrdliqindex = 0;
    private int mrdlindex = 0;
    private int samlindex = 0;
    private int samliqindex = 0;
	private int deck2index;
	private int patcount = 0; 
    private Color panelColor = new Color(248, 248, 255);

	public PanelPK3(String[] plates, String[] tubes, String[] deckpositions, String[] reservoirs, String[] liqtypes) {
		
		addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {
//				VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkdilution.png", -1, "", 360, 220);
				VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
			  String [] blankAll = new String [1];
		
			  String [] platesAll = new String [plates.length + 1];
			  String [] reservoirsAll = new String [reservoirs.length];
		      platesAll[0] = "Select labware type" ;
		      for (int i = 0; i < plates.length; i++) {
		          platesAll[i + 1] = plates[i] ;
		        }
//		      for (int i = 0; i < plates.length; i++) {
//		          platesAll[i] = plates[i] ;
//		        }
		      for (int i = 0; i < reservoirs.length; i++) {
		          reservoirsAll[i] = reservoirs[i] ;
		        }
		      String [] platesTubes = new String [plates.length + tubes.length];
		      platesTubes[0] = "Select labware type" ;
			  patcount ++;
		      for (int i = 0; i < plates.length; i++) {
		          platesTubes[patcount] = plates[i] ;
		    	  patcount ++;
		        }
		      for (int i = 1; i < tubes.length; i++) {
		          platesTubes[patcount] = tubes[i] ;
		    	  patcount ++;
		        }


			  String [] decks  = new String [deckpositions.length];
		      decks[0] = "Deck pos" ;
		      for (int i = 1; i < deckpositions.length; i++) {
		          decks[i] = deckpositions[i] ;
		        }
	 		  String [] liqTypes = new String [liqtypes.length];
		      for (int i = 0; i < liqtypes.length; i++) {
		          liqTypes[i] = liqtypes[i] ;
		        }

		setSize(new Dimension(810, 240));
		setMinimumSize(new Dimension(810, 240));
		TitledBorder dilBorder = BorderFactory.createTitledBorder("Dilution Properties");
		dilBorder.setTitleJustification(2);
		dilBorder.setTitlePosition(2);
		dilBorder.setTitleFont(new Font("Arial", Font.BOLD, 15));
		setBorder(dilBorder);
			    
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		setBackground(this.panelColor);
		
		JLabel lblLabware = new JLabel("Labware");
		lblLabware.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLabware = new GridBagConstraints();
		gbc_lblLabware.insets = new Insets(20, 0, 5, 5);
		gbc_lblLabware.gridx = 7;
		gbc_lblLabware.gridy = 1;
		add(lblLabware, gbc_lblLabware);
		
		JLabel lblLiquid = new JLabel("Liquid");
		lblLiquid.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLiquid = new GridBagConstraints();
		gbc_lblLiquid.insets = new Insets(20, 0, 5, 5);
		gbc_lblLiquid.gridx = 8;
		gbc_lblLiquid.gridy = 1;
		add(lblLiquid, gbc_lblLiquid);
		
		JLabel lblPosition = new JLabel("Position");
		lblPosition.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblPosition = new GridBagConstraints();
		gbc_lblPosition.insets = new Insets(20, 0, 5, 5);
		gbc_lblPosition.gridx = 9;
		gbc_lblPosition.gridy = 1;
		add(lblPosition, gbc_lblPosition);
		
		lblMrd = new JLabel("Samples:");
		GridBagConstraints gbc_lblMrd = new GridBagConstraints();
		gbc_lblMrd.anchor = GridBagConstraints.EAST;
		gbc_lblMrd.insets = new Insets(0, 0, 0, 5);
		gbc_lblMrd.gridx = 6;
		gbc_lblMrd.gridy = 3;
		add(lblMrd, gbc_lblMrd);

		pkSsource = new JComboBox(platesTubes);
		GridBagConstraints gbc_pkSsource = new GridBagConstraints();
		gbc_pkSsource.insets = new Insets(0, 0, 0, 5);
		gbc_pkSsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkSsource.gridx = 7;
		gbc_pkSsource.gridy = 3;
        samlindex = this.pkSsource.getSelectedIndex();
        samlab = ((String)this.pkSsource.getSelectedItem());
	    pkSsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        samlab = ((String)cb.getSelectedItem());
	            samlindex = (cb.getSelectedIndex());
		      } } );
		add(pkSsource, gbc_pkSsource);
		
		pksamdil = new JComboBox(liqTypes);
		GridBagConstraints gbc_pksamdil = new GridBagConstraints();
		gbc_pksamdil.insets = new Insets(0, 0, 5, 5);
		gbc_pksamdil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pksamdil.gridx = 8;
		gbc_pksamdil.gridy = 3;
        samliqindex = this.pksamdil.getSelectedIndex();
        samliq = ((String)this.pksamdil.getSelectedItem());
	    pksamdil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        samliq = ((String)cb.getSelectedItem());
	            samliqindex = (cb.getSelectedIndex());
		      } } );
		add(pksamdil, gbc_pksamdil);

		lblDilPlate = new JLabel("Dilution Plate:");
		GridBagConstraints gbc_lblDilPlate = new GridBagConstraints();
		gbc_lblDilPlate.anchor = GridBagConstraints.EAST;
		gbc_lblDilPlate.insets = new Insets(0, 0, 0, 5);
		gbc_lblDilPlate.gridx = 6;
		gbc_lblDilPlate.gridy = 4;
		add(lblDilPlate, gbc_lblDilPlate);
		
		pkDSource = new JComboBox(platesAll);
		
		pkDSource.setRenderer(new MyComboBoxRenderer());
		
		pkDSource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, dillab+".png", dillindex, "Please Select the Assay Plate Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		GridBagConstraints gbc_pkDSource = new GridBagConstraints();
		gbc_pkDSource.insets = new Insets(0, 0, 5, 5);
		gbc_pkDSource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkDSource.gridx = 7;
		gbc_pkDSource.gridy = 4;
        dillindex = this.pkDSource.getSelectedIndex();
	    pkDSource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dillab = ((String)cb.getSelectedItem());
	            dillindex = (cb.getSelectedIndex());
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkDSource, gbc_pkDSource);
		
		JLabel lblDiluent = new JLabel("Diluent:");
		GridBagConstraints gbc_lblDiluent = new GridBagConstraints();
		gbc_lblDiluent.insets = new Insets(0, 0, 0, 5);
		gbc_lblDiluent.anchor = GridBagConstraints.EAST;
		gbc_lblDiluent.gridx = 6;
		gbc_lblDiluent.gridy = 5;
		add(lblDiluent, gbc_lblDiluent);
		
		pkDilreserve = new JComboBox(reservoirsAll);
		
		pkDilreserve.setRenderer(new DiluentComboBoxRenderer());
		
		pkDilreserve.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, dilres+".png", dilrindex, "Please Select the Diluent Reservoir Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		GridBagConstraints gbc_pkDilreserve = new GridBagConstraints();
		gbc_pkDilreserve.insets = new Insets(0, 0, 0, 5);
		gbc_pkDilreserve.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkDilreserve.gridx = 7;
		gbc_pkDilreserve.gridy = 5;
        dilrindex = this.pkDilreserve.getSelectedIndex();
	    pkDilreserve.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dilres = ((String)cb.getSelectedItem());
	            dilrindex = (cb.getSelectedIndex());
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkDilreserve, gbc_pkDilreserve);
		
		pkdil = new JComboBox(liqTypes);
		GridBagConstraints gbc_pkdil = new GridBagConstraints();
		gbc_pkdil.insets = new Insets(0, 0, 0, 5);
		gbc_pkdil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkdil.gridx = 8;
		gbc_pkdil.gridy = 5;
        dilliqindex = this.pkdil.getSelectedIndex();
        dilliq = ((String)this.pkdil.getSelectedItem());
	    pkdil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dilliq = ((String)cb.getSelectedItem());
	            dilliqindex = (cb.getSelectedIndex());
		      } } );
		add(pkdil, gbc_pkdil);

		
		pkdeck2 = new JComboBox(decks);
		GridBagConstraints gbc_pkdeck2 = new GridBagConstraints();
		gbc_pkdeck2.insets = new Insets(0, 0, 0, 5);
		gbc_pkdeck2.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkdeck2.gridx = 9;
		gbc_pkdeck2.gridy = 5;
        deck2index = this.pkdeck2.getSelectedIndex();
	    pkdeck2.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck2 = ((String)cb.getSelectedItem());
	            deck2index = (cb.getSelectedIndex());
		      } } );
		add(pkdeck2, gbc_pkdeck2);
	}
	
    class MyComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {	
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Dilution Plate Type", 273, 148);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else{
                setOpaque(true);
                setBackground(list.getBackground());
                setForeground(list.getForeground());
        	}	        		
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          return this;
        }
    }
    
    class DiluentComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {	
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Diluent Reservoir Type", 273, 148);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else{
                setOpaque(true);
                setBackground(list.getBackground());
                setForeground(list.getForeground());
        	}	        		
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          return this;
        }
    }

	public void setsamIndex( int index ){
		if (index > 0)
		{
			pkSsource.setSelectedIndex(index);
		}
		else
		{
			pkSsource.setSelectedIndex(0);
		}
	}

	public void setdilrIndex( int index ){
		if (index > 0)
		{
			pkDilreserve.setSelectedIndex(index);
		}
		else
		{
			pkDilreserve.setSelectedIndex(0);
		}
	}
	
	public void setdeck2Index( int index ){
		if (index > 0)
		{
			pkdeck2.setSelectedIndex(index);
		}
		else
		{
			pkdeck2.setSelectedIndex(0);
		}
	}

	public void setdilsrcindex( int index ){
		if (index > 0)
		{
			pkDSource.setSelectedIndex(index);
		}
		else
		{
			pkDSource.setSelectedIndex(0);
		}
	}
	public void setdilindex(int x)
	{
		if (x > 0)
		{
			pkdil.setSelectedIndex(x);
		}
		else
		{
			pkdil.setSelectedIndex(0);
		}
	}
	
	public String getDeck2() {
		if (deck2 == null )
		{
			return "0";
		}
		if (deck2.equals("Deck pos"))
		{
			return "0";
		}
		else
		{
			return deck2;
		}
	}
 
	public int getdeck2Index(){
		return deck2index;
	}

	public int getdillindex(){
		return dillindex;
	}

	public int getdilrindex(){
		return dilrindex;
	}

	public int getdilliqIndex(){
		return dilliqindex;
	}

	public int getsamlindex(){
		return samlindex;
	}

	public String getpkdilsrc()
	{
		if (dillindex > 0)
		{	
		return dillab;
		}
		else
		{
			return "0";
		}
	}
	public String getpkdil()
	{
		return dilliq;
	}
	public String getpkdilres()
	{
		if (dilrindex > 0)
		{	
			return dilres;
		}
		else
		{
			return "0";
		}
	}
	public String getpkssrc()
	{
		if (samlindex > 0)
		{	
			return samlab;
		}
		else
		{
			return "0";
		}
	}
	public String getpksamdil()
	{
			return samliq;
	}

	public void setsamdilIndex( int index ){
		if (index > 0)
		{
			pksamdil.setSelectedIndex(index);
		}
		else
		{
			pksamdil.setSelectedIndex(0);
		}
	}
	public String getpkmrddil()
	{
			return dilliq;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
