/**
 * AutoPilot
 * Copyright 	- Telos Scientific - 
 * Author 		- Jesse A. Campbell
 * Description	- PK Pre-assay window (Auto Pilot 1.0) 
 * Written 		- 01/06/2014
 * 
**/
package TelosV2Pkg;

//Updates
//
//07/19/15 RSC - APNNNNN	  PK PREASSAY FIELD CONTROL	

import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.Renderer;

import java.awt.GridBagLayout;

import javax.swing.JLabel;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JComboBox;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


import java.awt.Font;
import javax.swing.JTextField;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;

public class PanelPK4 extends JPanel {
    Border blackline = BorderFactory.createLineBorder(Color.black);
	JComboBox pkMRDsource = null;
	JComboBox pkPassay = null;
	JComboBox pkmrddil = null;
	JComboBox pkstddil = null;
	JComboBox pkDSource = null;
	JComboBox pkSTDsource = null;
	JComboBox pkDilreserve = null;
	JComboBox pkDilsource = null;
	JComboBox pkdil = null;
	JComboBox pkdeck1 = null;
	JLabel lblMrd = null;
	JLabel lblDilPlate = null;
	JLabel lblStandard = null;
	JLabel lblDiluent = null;
	JLabel lbl1 = null;
	JLabel lblin = null;
	JLabel lblLiquid = null;
	JLabel lblPosition = null;
	
	DiluentComboBoxRenderer dilrender = null;
	JList dillist = new JList();
	private JTextField pkm_text_ul_preAssay;
    JTextField pkm_text_1;
	private String textul;
	private String passlab;
    private int passlindex = 0;
	private String stdlab;	
	private String dillab;
	private String mrdlab;
	private String samliq;
	private String dilliq;
	private String mrdliq;
	private String deck1;
	private String stdliq;

    private int mrdlindex = 0;
    private int stdlindex = 0;
	private int patcount = 0; 
    private int stdliqindex = 0;
    private int dillindex = 0;
    private int samliqindex = 0;
    private int dilliqindex = 0;
    private int mrdliqindex = 0;
	private int deck1index;
	
	private boolean dilenabled = false;
	
    private Color panelColor = new Color(248, 248, 255);

	public PanelPK4(String[] plates, String[] tubes, String[] deckpositions, String[] reservoirs, String[] liqtypes) {
		
		addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {
//				VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "pkdilution.png", -1, "", 360, 220);
				VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
			}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
		
			  String [] platesAll = new String [plates.length + 1];
			  String [] reservoirsAll = new String [reservoirs.length];
		      platesAll[0] = "Select labware type" ;
		      for (int i = 0; i < plates.length; i++) {
		          platesAll[i + 1] = plates[i] ;
		        }
//		      for (int i = 0; i < plates.length; i++) {
//		          platesAll[i] = plates[i] ;
//		        }
		      String [] platesTubes = new String [plates.length + tubes.length];
		      platesTubes[0] = "Select labware type" ;
			  patcount ++;
		      for (int i = 0; i < plates.length; i++) {
		          platesTubes[patcount] = plates[i] ;
		    	  patcount ++;
		        }
		      for (int i = 1; i < tubes.length; i++) {
		          platesTubes[patcount] = tubes[i] ;
		    	  patcount ++;
		        }

		      for (int i = 0; i < reservoirs.length; i++) {
		          reservoirsAll[i] = reservoirs[i] ;
		        }
			  String [] decks  = new String [deckpositions.length];
		      decks[0] = "Deck pos" ;
		      for (int i = 1; i < deckpositions.length; i++) {
		          decks[i] = deckpositions[i] ;
		        }
	 		  String [] liqTypes = new String [liqtypes.length];
		      for (int i = 0; i < liqtypes.length; i++) {
		          liqTypes[i] = liqtypes[i] ;
		        }

		setSize(new Dimension(810, 240));
		setMinimumSize(new Dimension(810, 240));
		TitledBorder dilBorder = BorderFactory.createTitledBorder("Pre-Assay plate Properties");
		dilBorder.setTitleJustification(2);
		dilBorder.setTitlePosition(2);
		dilBorder.setTitleFont(new Font("Arial", Font.BOLD, 15));
		setBorder(dilBorder);
			    
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		setBackground(this.panelColor);
		
		JLabel lblLabware = new JLabel("Labware");
		lblLabware.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLabware = new GridBagConstraints();
		gbc_lblLabware.insets = new Insets(20, 0, 5, 5);
		gbc_lblLabware.gridx = 8;
		gbc_lblLabware.gridy = 1;
		add(lblLabware, gbc_lblLabware);
		
		lblLiquid = new JLabel("Liquid");
		lblLiquid.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblLiquid = new GridBagConstraints();
		gbc_lblLiquid.insets = new Insets(20, 0, 5, 5);
		gbc_lblLiquid.gridx = 9;
		gbc_lblLiquid.gridy = 1;
		add(lblLiquid, gbc_lblLiquid);
		
		lblPosition = new JLabel("Position");
		lblPosition.setFont(new Font("Arial", Font.BOLD, 14));
		GridBagConstraints gbc_lblPosition = new GridBagConstraints();
		gbc_lblPosition.insets = new Insets(20, 0, 5, 0);
		gbc_lblPosition.gridx = 10;
		gbc_lblPosition.gridy = 1;
		add(lblPosition, gbc_lblPosition);
		
		pkPassay = new JComboBox(platesAll);
		GridBagConstraints gbc_pkPassay = new GridBagConstraints();
		gbc_pkPassay.insets = new Insets(0, 0, 5, 5);
		gbc_pkPassay.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkPassay.gridx = 8;
		gbc_pkPassay.gridy = 3;
        passlindex = this.pkPassay.getSelectedIndex();
	    pkPassay.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        passlab = ((String)cb.getSelectedItem());
	            passlindex = (cb.getSelectedIndex());
		      } } );
		
		lbl1 = new JLabel("1:");
		GridBagConstraints gbc_lbl1 = new GridBagConstraints();
		gbc_lbl1.anchor = GridBagConstraints.EAST;
		gbc_lbl1.insets = new Insets(0, 0, 5, 5);
		gbc_lbl1.gridx = 3;
		gbc_lbl1.gridy = 3;
		add(lbl1, gbc_lbl1);
		
		pkm_text_1 = new JTextField();
		GridBagConstraints gbc_pkm_text_1 = new GridBagConstraints();
		gbc_pkm_text_1.insets = new Insets(0, 0, 5, 5);
		gbc_pkm_text_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkm_text_1.gridx = 4;
		gbc_pkm_text_1.gridy = 3;
		pkm_text_1.setText("1");
	    pkm_text_1.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        String pretext = pkm_text_1.getText();
	    		if (pretext.equals("1"))
	    		{
	    			pkDilsource.setEnabled(false);
	    			pkmrddil.setEnabled(false);
	    			pkdeck1.setEnabled(false);
	    			dilenabled = false;
	    			lblDiluent.setForeground(Color.GRAY);
	    			}
	    		else
	    		{
	    			pkDilsource.setEnabled(true);
	    			pkmrddil.setEnabled(true);
	    			pkdeck1.setEnabled(true);
	    			dilenabled = true;
	    			lblDiluent.setForeground(Color.BLACK);
	    		}
		      } } );
	    pkm_text_1.getDocument().addDocumentListener(new DocumentListener() {
	    	  public void changedUpdate(DocumentEvent e) {
	    	    setFields();
	    	  }
	    	  public void removeUpdate(DocumentEvent e) {
	    	    setFields();
	    	  }
	    	  public void insertUpdate(DocumentEvent e) {
	    	    setFields();
	    	  }

	    	  public void setFields() {
			        String pretext = pkm_text_1.getText();
			        int prenum = 0;
					try {
						//TabWindow.this.rHam = TabWindow.this.s1.contains("Ham");  //removed as part of APF0043
						prenum = Integer.parseInt(pretext);
					} catch (NumberFormatException e1) {
						// TODO Auto-generated catch block
						prenum = 0;
					}
		            
			        if (prenum>1)
			        {
		    			pkDilsource.setEnabled(true);
		    			pkmrddil.setEnabled(true);
		    			pkdeck1.setEnabled(true);
		    			dilenabled = true;
		    			lblDiluent.setForeground(Color.BLACK);
			        }       
			        else
		    		{
		    			pkDilsource.setEnabled(false);
		    			pkmrddil.setEnabled(false);
		    			pkdeck1.setEnabled(false);
		    			dilenabled = false;
		    			lblDiluent.setForeground(Color.GRAY);
		    		}
	    	  }
	    	});
		add(pkm_text_1, gbc_pkm_text_1);
		pkm_text_1.setColumns(5);
		
		lblin = new JLabel("in");
		GridBagConstraints gbc_lblin = new GridBagConstraints();
		gbc_lblin.insets = new Insets(0, 0, 5, 5);
		gbc_lblin.anchor = GridBagConstraints.EAST;
		gbc_lblin.gridx = 5;
		gbc_lblin.gridy = 3;
		add(lblin, gbc_lblin);
		
		JLabel lblUl = new JLabel("ul");
		GridBagConstraints gbc_lblUl = new GridBagConstraints();
		gbc_lblUl.insets = new Insets(0, 0, 5, 5);
		gbc_lblUl.anchor = GridBagConstraints.EAST;
		gbc_lblUl.gridx = 7;
		gbc_lblUl.gridy = 3;
		add(lblUl, gbc_lblUl);
		add(pkPassay, gbc_pkPassay);

	    pkm_text_ul_preAssay = new JTextField();
		GridBagConstraints gbc_pkm_ul_preAssay = new GridBagConstraints();
		gbc_pkm_ul_preAssay.insets = new Insets(0, 0, 5, 5);
		gbc_pkm_ul_preAssay.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkm_ul_preAssay.gridx = 6;
		gbc_pkm_ul_preAssay.gridy = 3;
	    pkm_text_ul_preAssay.setText("0"); 
	    
		add(pkm_text_ul_preAssay, gbc_pkm_ul_preAssay);
		pkm_text_ul_preAssay.setColumns(10);
		
		lblStandard = new JLabel("Standards/QCs:");
		GridBagConstraints gbc_lblStandard = new GridBagConstraints();
		gbc_lblStandard.anchor = GridBagConstraints.EAST;
		gbc_lblStandard.insets = new Insets(0, 0, 5, 5);
		gbc_lblStandard.gridx = 6;
		gbc_lblStandard.gridy = 4;
		add(lblStandard, gbc_lblStandard);
		
		pkSTDsource = new JComboBox(platesTubes);
		
		pkSTDsource.setRenderer(new MyComboBoxRenderer());
		
		pkSTDsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, dillab+".png", dillindex, "Please Select the Assay Plate Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		
		GridBagConstraints gbc_pkSTDsource = new GridBagConstraints();
		gbc_pkSTDsource.insets = new Insets(0, 0, 5, 5);
		gbc_pkSTDsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkSTDsource.gridx = 8;
		gbc_pkSTDsource.gridy = 4;
        stdlindex = this.pkSTDsource.getSelectedIndex();
        stdlab = ((String)this.pkSTDsource.getSelectedItem());
	    pkSTDsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        stdlab = ((String)cb.getSelectedItem());
	            stdlindex = (cb.getSelectedIndex());
	            if (stdlab.contains("_96")){
//	            	pkSsource.setSelectedIndex(pkSTDsource.getSelectedIndex());
	            }
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkSTDsource, gbc_pkSTDsource);
		
		pkstddil = new JComboBox(liqTypes);
		GridBagConstraints gbc_pkstddil = new GridBagConstraints();
		gbc_pkstddil.insets = new Insets(0, 0, 5, 5);
		gbc_pkstddil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkstddil.gridx = 9;
		gbc_pkstddil.gridy = 4;
        stdliqindex = this.pkstddil.getSelectedIndex();
        stdliq = ((String)this.pkstddil.getSelectedItem());
		pkstddil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        stdliq = ((String)cb.getSelectedItem());
	            stdliqindex = (cb.getSelectedIndex());
		      } } );
		add(pkstddil, gbc_pkstddil);
		
		lblDiluent = new JLabel("Diluent:");
		lblDiluent.setForeground(Color.GRAY);
		GridBagConstraints gbc_lblDiluent = new GridBagConstraints();
		gbc_lblDiluent.insets = new Insets(0, 0, 0, 5);
		gbc_lblDiluent.anchor = GridBagConstraints.EAST;
		gbc_lblDiluent.gridx = 6;
		gbc_lblDiluent.gridy = 5;
		add(lblDiluent, gbc_lblDiluent);
		
		pkDilsource = new JComboBox(reservoirsAll);
		pkDilsource.setEnabled(false);
		dilrender = new DiluentComboBoxRenderer();
		pkDilsource.setRenderer(dilrender);
		pkDilsource.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, dilliq+".png", dillindex, "Please Select the Diluent Reservoir Type", 273, 148);}
			public void mouseExited(MouseEvent arg0) {VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}	
	    });
		GridBagConstraints gbc_pkDilsource = new GridBagConstraints();
		gbc_pkDilsource.insets = new Insets(0, 0, 0, 5);
		gbc_pkDilsource.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkDilsource.gridx = 8;
		gbc_pkDilsource.gridy = 5;
        dillindex = this.pkDilsource.getSelectedIndex();
	    pkDilsource.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dillab = ((String)cb.getSelectedItem());
	            dillindex = (cb.getSelectedIndex());
	            VAStools.setJLabelImage(PanelPKB2.lblPkBlank, "TelosLogo.png", -1, "", 199, 74);
		      } } );
		add(pkDilsource, gbc_pkDilsource);
		
		pkmrddil = new JComboBox(liqTypes);
		pkmrddil.setEnabled(false);
		GridBagConstraints gbc_pkmrddil = new GridBagConstraints();
		gbc_pkmrddil.insets = new Insets(0, 0, 0, 5);
		gbc_pkmrddil.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkmrddil.gridx = 9;
		gbc_pkmrddil.gridy = 5;
        dilliqindex = this.pkmrddil.getSelectedIndex();
        dilliq = ((String)this.pkmrddil.getSelectedItem());
	    pkmrddil.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        dilliq = ((String)cb.getSelectedItem());
	            dilliqindex = (cb.getSelectedIndex());
		      } } );
		add(pkmrddil, gbc_pkmrddil);
		
		pkdeck1 = new JComboBox(decks);
		pkdeck1.setEnabled(false);
		GridBagConstraints gbc_pkdeck1 = new GridBagConstraints();
		gbc_pkdeck1.fill = GridBagConstraints.HORIZONTAL;
		gbc_pkdeck1.gridx = 10;
		gbc_pkdeck1.gridy = 5;
        deck1index = this.pkdeck1.getSelectedIndex();
	    pkdeck1.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        deck1 = ((String)cb.getSelectedItem());
	            deck1index = (cb.getSelectedIndex());
		      } } );
		add(pkdeck1, gbc_pkdeck1);
	}
	
    class MyComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {	
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Dilution Plate Type", 273, 148);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else{
                setOpaque(true);
                setBackground(list.getBackground());
                setForeground(list.getForeground());
        	}	        		
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          return this;
        }
    }

    class DiluentComboBoxRenderer extends DefaultListCellRenderer  {
        private static final long serialVersionUID = 2746090194775905713L;
        public Component getListCellRendererComponent(JList list, Object value,  
                int index, boolean isSelected, boolean cellHasFocus) {

        	if (isSelected) {	
        		VAStools.setJLabelImage(PanelPKB2.lblPkBlank, String.valueOf(value) + ".png", index, "Please Select the Diluent Reservoir Type", 273, 148);
        		setOpaque(true);
        		setBackground(list.getSelectionBackground());
        		setForeground(list.getSelectionForeground());              
        	}else
        	{
                setOpaque(true);
                setBackground(list.getBackground());
                if (dilenabled)
                {
                    setForeground(list.getForeground());
                }
                else
                {
                    setForeground(Color.GRAY);
                }
        	}	        		
          setEnabled(list.isEnabled());
          setFont(list.getFont());
          setText((value == null) ? "" : value.toString());
          // setEnabled(false);
          return this;
        }
    }
    
    
	public void setpassaylabindex( int index ){
		if (index > 0)
		{
			pkPassay.setSelectedIndex(index);
		}
		else
		{
			pkPassay.setSelectedIndex(0);
		}
	}

	public String getpassayul() {
			return pkm_text_ul_preAssay.getText();
	}
	public String getpassaylab() {
		if (passlindex > 0)
		{	
			return passlab;
		}
		else
		{
			return "0";
		}
	}
	public void setpassayul( String s ){
		pkm_text_ul_preAssay.setText(s);
	}

	public String getpkstdsrc()
	{
		if (stdlindex > 0)
		{	
			return stdlab;
		}
		else
		{
			return "0";
		}
	}

	public int getpkstdlindex()
	{
			return stdlindex;
	}
	
	public String getpkdilsrc()
	{
		if (dillindex > 0)
		{	
			return dillab;
		}
		else
		{
			return "0";
		}
	}

	public String getpkmtext1()
	{
		return pkm_text_1.getText();
	}

	public String getpkmrddil()
	{
			return dilliq;
	}
	
	public void setpkmtext1(String s)
	{
		pkm_text_1.setText(s);
	}

	public void setdilsrcindex( int index ){
		if (index > 0)
		{
			pkDilsource.setSelectedIndex(index);
		}
		else
		{
			pkDilsource.setSelectedIndex(0);
		}
	}

	public void setstdIndex( int index ){
		if (index > 0)
		{
			pkSTDsource.setSelectedIndex(index);
		}
		else
		{
			pkSTDsource.setSelectedIndex(0);
		}
	}
	public void setdeck1index( int index ){
		if (index > 0)
		{
			pkdeck1.setSelectedIndex(index);
		}
		else
		{
			pkdeck1.setSelectedIndex(0);
		}
	}

	public String getpkdeck1() {
		if (deck1 == null )
		{
			return "0";
		}
		if (deck1.equals("Deck pos"))
		{
			return "0";
		}
		else
		{
			return deck1;
		}
	}

	public void setmrddilIndex( int index ){
		if (index > 0)
		{
			pkmrddil.setSelectedIndex(index);
		}
		else
		{
			pkmrddil.setSelectedIndex(0);
		}
	}	
	public String getpkstddil()
	{
			return stdliq;
	}
	public void setstddilIndex( int index ){
		if (index > 0)
		{
			pkstddil.setSelectedIndex(index);
		}
		else
		{
			pkstddil.setSelectedIndex(0);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
