package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DateFormatSymbols;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

public class PanelPasswordReset extends JFrame {

	private JPanel jContentPane = null;
	private JPanel resetPanel = null;
	private JLabel labelPassword1 = new JLabel("New Password:");
	private JLabel labelPassword2 = new JLabel("New Password:");
	private JTextField textField_Password1 = new JPasswordField(10); 
	private JTextField textField_Password2 = new JPasswordField(10); 

	private static JButton saveButton = null ; 
	private static JButton cancelButton = null ; 
	
	private FileInputStream input;
	
	ArrayList<String> arrayList_userData = new ArrayList();
	ArrayList<String> arrayList_userData_Encrypted = new ArrayList();
	
	public String decrypted;
	public String userName;
	
	long millisecondsToday;
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getResetPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}
	
	/**
	 * This is the default constructor
	 */
	public PanelPasswordReset() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(475, 225);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle("Please Reset Your Password");

		cancelButton.setEnabled(true);
		saveButton.setEnabled(true);
		
	    //create a listener for all exit events
	    addWindowListener(new WindowAdapter()				//APN0049
	    {
	       public void windowClosing(WindowEvent e)
	       {							
	    	   onTop(false);
				textField_Password1.setText("");
				textField_Password2.setText("");
				LogInWindow.textField_Username.setText("");
				LogInWindow.textField_Password.setText("");
				vis(false);																												
	    	} 																																		

	    });

	}
	

	private JPanel getResetPanel() {
		if (resetPanel == null) {
			resetPanel = new JPanel();
			GridBagLayout gbl_resetPanel = new GridBagLayout();
			gbl_resetPanel.columnWidths = new int[]{60,60,60,60};
			gbl_resetPanel.rowHeights = new int[]{0, 0};
			gbl_resetPanel.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			gbl_resetPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			resetPanel.setLayout(gbl_resetPanel);
			
			
//			Row 1			
			GridBagConstraints gbc_lblNewLabel1 = new GridBagConstraints();
			gbc_lblNewLabel1.anchor = GridBagConstraints.EAST;
			gbc_lblNewLabel1.insets = new Insets(0, 0, 0, 5);
			gbc_lblNewLabel1.gridx = 1;
			gbc_lblNewLabel1.gridy = 1;
			resetPanel.add(labelPassword1, gbc_lblNewLabel1);
			
			GridBagConstraints gbc_textField_Password1 = new GridBagConstraints();
			gbc_textField_Password1.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Password1.anchor = GridBagConstraints.NORTH;
			gbc_textField_Password1.insets = new Insets(0, 0, 0, 5);
			gbc_textField_Password1.gridx = 2;
			gbc_textField_Password1.gridy =1;
			resetPanel.add(textField_Password1, gbc_textField_Password1);

//			Row 2
			GridBagConstraints gbc_lblNewLabel2 = new GridBagConstraints();
			gbc_lblNewLabel2.anchor = GridBagConstraints.EAST;
			gbc_lblNewLabel2.insets = new Insets(0, 0, 0, 5);
			gbc_lblNewLabel2.gridx = 1;
			gbc_lblNewLabel2.gridy = 2;
			resetPanel.add(labelPassword2, gbc_lblNewLabel2);
			
			
			GridBagConstraints gbc_textField_Password2 = new GridBagConstraints();
			gbc_textField_Password2.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Password2.anchor = GridBagConstraints.NORTH;
			gbc_textField_Password2.insets = new Insets(0, 0, 0, 5);
			gbc_textField_Password2.gridx = 2;
			gbc_textField_Password2.gridy = 2;
			resetPanel.add(textField_Password2, gbc_textField_Password2);
			
//			Row 3
			GridBagConstraints gbc_saveButton = new GridBagConstraints();
			gbc_saveButton.anchor = GridBagConstraints.EAST;
			gbc_saveButton.insets = new Insets(0, 0, 0, 5);
			gbc_saveButton.gridx = 1;
			gbc_saveButton.gridy = 3;
			resetPanel.add(getsaveButton(), gbc_saveButton);
			
			
			GridBagConstraints gbc_cancelButton = new GridBagConstraints();
			gbc_cancelButton.anchor = GridBagConstraints.WEST;
			gbc_cancelButton.insets = new Insets(0, 5, 0, 0);
			gbc_cancelButton.gridx = 2;
			gbc_cancelButton.gridy = 3;
			resetPanel.add(getcancelButton(), gbc_cancelButton);
			
		}
		
		return resetPanel;
	}
	
	private javax.swing.JButton getsaveButton() {
		if (saveButton == null) {
			saveButton = new javax.swing.JButton();
			saveButton.setSize(20, 20);
			saveButton.setText("  Save   ");
			saveButton.setHorizontalAlignment(SwingConstants.CENTER);
		    saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					
					
					
					onTop(false);
					
					if (textField_Password1.getText().equals(textField_Password2.getText())){
						onTop(false);
						if (VAStools.passwordAccept(textField_Password1.getText())){
							loadAccount();
							
							onTop(false);
							if (saveAccount()){		
				   				JOptionPane.showMessageDialog(null, "Your password has been reset."," ", JOptionPane.INFORMATION_MESSAGE);					
								textField_Password1.setText("");
								textField_Password2.setText("");
								vis(false);								
							}else{
				   				JOptionPane.showMessageDialog(null, "Your password must not match the previous one."," ", JOptionPane.INFORMATION_MESSAGE);					
								textField_Password1.setText("");
								textField_Password2.setText("");
							}

						}else{
							onTop(true);
						}
					}else{
						onTop(false);
						JOptionPane.showMessageDialog(null, "The passwords do not match.  Please try again."," ", JOptionPane.INFORMATION_MESSAGE);					
						textField_Password1.setText("");
						textField_Password2.setText("");
						onTop(true);
					}
				}
			});			
		}
		return saveButton;
	}
	
	private javax.swing.JButton getcancelButton() {
		if (cancelButton == null) {
			cancelButton = new javax.swing.JButton();
			cancelButton.setSize(20, 20);
			cancelButton.setText("  Cancel   ");
			cancelButton.setHorizontalAlignment(SwingConstants.CENTER);
		    cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					onTop(false);
					textField_Password1.setText("");
					textField_Password2.setText("");
					LogInWindow.textField_Username.setText("");
					LogInWindow.textField_Password.setText("");
					vis(false);
				}
			});			
		}
		return cancelButton;
	}
	
	/**
	 * This method loads scheme data into holding list  	
	 * 	
	 * @return void 	
	 */
	@SuppressWarnings("unchecked")
	public void loadAccount() {
		
		arrayList_userData.clear();
		arrayList_userData_Encrypted.clear();
	    
		try { 
			String data = "";
			String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
			File f = new File(filename);
			input = new FileInputStream ( f );
			final BufferedReader bw = new BufferedReader(new FileReader(f));

			userName = "";
		    while ((data = bw.readLine()) != null) {	
				
				System.out.println("UAW   -   " + data);
		    	  
		    	decrypted = CryptoMessage.decrypt(data);
		    	  
		    	System.out.println("UAW   -   " + decrypted);
		    	  
		    	arrayList_userData.add(decrypted);
		   }
		} 
		catch ( EOFException eof ) {
			try { 
				input.close();
				} catch ( IOException e ) {
				JOptionPane.showMessageDialog( this, 
						"Error Closing File" , 
						"Error", 
						JOptionPane.ERROR_MESSAGE );
				}
		}
		catch ( IOException e ) {
			JOptionPane.showMessageDialog( this, 
					"Error Opening File" , 
					"Error", 
					JOptionPane.ERROR_MESSAGE );
		}

		try { 
		input.close();
		} catch ( IOException e ) {
		JOptionPane.showMessageDialog( this, 
				"Error Closing File" , 
				"Error", 
				JOptionPane.ERROR_MESSAGE );
		}
	}
	
	private boolean saveAccount() {
		String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
		File f = new File(filename);
		try {
			final BufferedWriter bw = new BufferedWriter(new FileWriter(f));
			Date date=new Date();
			millisecondsToday = date.getTime();
			String saveData = "";
			String accountData = "";
			String encrypted ="";
			arrayList_userData_Encrypted.clear();
			for (int i=0; i < arrayList_userData.size(); i++){
				accountData = arrayList_userData.get(i);
				userName = accountData.split(",")[0];
				
				//APN0056  Setting the account update field (field [4]) to "2" to indicate password has been updated.
		    	if (userName.equals(LogInWindow.userNameConfirmed)){
		    		if (textField_Password1.getText().equals(accountData.split(",")[1])){//if same as previous password
		    			encrypted = CryptoMessage.encrypt(accountData);// re-write original data
		    			return false;
		    		}else{
			    		saveData = userName + "," + textField_Password1.getText() + ","  + accountData.split(",")[2] + "," + String.valueOf(millisecondsToday) + "," + "2";
						encrypted = CryptoMessage.encrypt(saveData);
						arrayList_userData.set(i,saveData);
						System.out.println("Resetting Password " + saveData); 		    			
		    		}

		    	}else{
		    		encrypted = CryptoMessage.encrypt(accountData);
		    	}

		    	arrayList_userData_Encrypted.add(encrypted);		
			}		

			for (int i=0; i < arrayList_userData_Encrypted.size(); i++){
			    bw.write(arrayList_userData_Encrypted.get(i)) ;
				bw.newLine();				
			}
			bw.close( );

		} catch (final FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (final IOException e1) {
			e1.printStackTrace();
		}
		
		return true;
	}
	
	private void onTop (boolean b){//APN0049
		this.setAlwaysOnTop(b);
	}
	private void vis (boolean b){
		this.setVisible(b);
	}
}
