package TelosV2Pkg;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class PausePanel extends JPanel {
	private JTextField textMessage;
	private JTextField textSeconds;
	private JTextField textMinutes;
	private JCheckBox ckbTimed;
	
	private String minutes;
	private String seconds;
	private String message;

	public PausePanel() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		JLabel label = new JLabel(" ");
		GridBagConstraints gbc_label = new GridBagConstraints();
		gbc_label.insets = new Insets(0, 0, 5, 5);
		gbc_label.gridx = 0;
		gbc_label.gridy = 1;
		add(label, gbc_label);
		
		JLabel lblTimedDelay = new JLabel(" Timed delay:");
		GridBagConstraints gbc_lblTimedDelay = new GridBagConstraints();
		gbc_lblTimedDelay.anchor = GridBagConstraints.WEST;
		gbc_lblTimedDelay.insets = new Insets(0, 0, 5, 5);
		gbc_lblTimedDelay.gridx = 2;
		gbc_lblTimedDelay.gridy = 2;
		add(lblTimedDelay, gbc_lblTimedDelay);
		
		ckbTimed = new JCheckBox(" ");
		ckbTimed.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (ckbTimed.isSelected())
				{
					textMinutes.setEnabled(true);
					textSeconds.setEnabled(true);
//					textMessage.setEnabled(true);
				}
				else
				{
					textMinutes.setEnabled(false);
					textSeconds.setEnabled(false);
//					textMessage.setEnabled(false);
				}	
			}
		});
		GridBagConstraints gbc_ckbTimed = new GridBagConstraints();
		gbc_ckbTimed.anchor = GridBagConstraints.WEST;
		gbc_ckbTimed.insets = new Insets(0, 0, 5, 0);
		gbc_ckbTimed.gridx = 3;
		gbc_ckbTimed.gridy = 2;
		add(ckbTimed, gbc_ckbTimed);
		
		JLabel lblMinutes = new JLabel(" Minutes:");
		GridBagConstraints gbc_lblMinutes = new GridBagConstraints();
		gbc_lblMinutes.anchor = GridBagConstraints.WEST;
		gbc_lblMinutes.insets = new Insets(0, 0, 5, 5);
		gbc_lblMinutes.gridx = 2;
		gbc_lblMinutes.gridy = 3;
		add(lblMinutes, gbc_lblMinutes);
		
		textMinutes = new JTextField();
		textMinutes.setMinimumSize(new Dimension(75, 25));
		GridBagConstraints gbc_textMinutes = new GridBagConstraints();
		gbc_textMinutes.anchor = GridBagConstraints.WEST;
		gbc_textMinutes.insets = new Insets(0, 0, 5, 0);
		gbc_textMinutes.gridx = 3;
		gbc_textMinutes.gridy = 3;
		textMinutes.setColumns(30);
		textMinutes.setEnabled(false);
		add(textMinutes, gbc_textMinutes);
		
		JLabel lblSeconds = new JLabel(" Seconds:");
		GridBagConstraints gbc_lblSeconds = new GridBagConstraints();
		gbc_lblSeconds.anchor = GridBagConstraints.WEST;
		gbc_lblSeconds.insets = new Insets(0, 0, 5, 5);
		gbc_lblSeconds.gridx = 2;
		gbc_lblSeconds.gridy = 4;
		add(lblSeconds, gbc_lblSeconds);
		
		textSeconds = new JTextField();
		textSeconds.setMinimumSize(new Dimension(75, 25));
		GridBagConstraints gbc_textSeconds = new GridBagConstraints();
		gbc_textSeconds.anchor = GridBagConstraints.WEST;
		gbc_textSeconds.insets = new Insets(0, 0, 5, 0);
		gbc_textSeconds.gridx = 3;
		gbc_textSeconds.gridy = 4;
		textSeconds.setColumns(30);
		textSeconds.setEnabled(false);
		add(textSeconds, gbc_textSeconds);
		
		JLabel label_1 = new JLabel(" ");
		GridBagConstraints gbc_label_1 = new GridBagConstraints();
		gbc_label_1.insets = new Insets(0, 0, 5, 5);
		gbc_label_1.gridx = 1;
		gbc_label_1.gridy = 5;
		add(label_1, gbc_label_1);
		
		JLabel lblUserMessage = new JLabel(" User message:");
		GridBagConstraints gbc_lblUserMessage = new GridBagConstraints();
		gbc_lblUserMessage.anchor = GridBagConstraints.WEST;
		gbc_lblUserMessage.insets = new Insets(0, 0, 0, 5);
		gbc_lblUserMessage.gridx = 2;
		gbc_lblUserMessage.gridy = 6;
		add(lblUserMessage, gbc_lblUserMessage);
		
		textMessage = new JTextField();
		textMessage.setMinimumSize(new Dimension(300, 25));
		GridBagConstraints gbc_textMessage = new GridBagConstraints();
		gbc_textMessage.anchor = GridBagConstraints.WEST;
		gbc_textMessage.gridx = 3;
		gbc_textMessage.gridy = 6;
		textMessage.setColumns(150);
//		textMessage.setEnabled(false);
		add(textMessage, gbc_textMessage);
	}

	public String getMinutes() {
	minutes = textMinutes.getText().trim();	
	return minutes;
	}
	
	public void setMinutes( String s ){
		textMinutes.setText(s);
	}
	  
	public String getSeconds() {
	seconds = textSeconds.getText().trim();	
	return seconds;
	}
	
	public void setSeconds( String s ){
		textSeconds.setText(s);
	}
	  
	public String getMessage() {
	message = textMessage.getText();	
	return message;
	}
	
	public void setMessage( String s ){
		textMessage.setText(s);
	}
	  
	public boolean isTimed( ) {
		return ckbTimed.isSelected();
	}
	
	public void setTimed(boolean b ) {
		ckbTimed.setSelected(b);
		if (ckbTimed.isSelected())
		{
			textMinutes.setEnabled(true);
			textSeconds.setEnabled(true);
//			textMessage.setEnabled(true);
		}
		else
		{
			textMinutes.setEnabled(false);
			textSeconds.setEnabled(false);
//			textMessage.setEnabled(false);
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	
}
