	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Panel Object - 24X well (Auto Pilot 1.0)
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class Res12XPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JPanel res12XPanel = null;
	public static int rescount = 0;
	Border blackline = BorderFactory.createLineBorder(Color.black, 1);
	Border redline = BorderFactory.createLineBorder(Color.red,3);
	
	private JPanel textWindow = null;

	private JTextArea dTextArea[] = new JTextArea[ 15 ];

	private String res1 = "";
	public JLabel	lres1 = new JLabel( "Reservoir # ");
	public JTextField reservoir = new JTextField(2);

	private Color panelColor = new Color(248, 248, 255);                                 

	boolean update = false;
	/**
	 * This is the default constructor
	 */
	public Res12XPanel(int r) {
		super();
		initialize(r);
	}

	/**
	 * This repaint the JPanel */
	public static void setResnum(int r) {
		rescount = r;
	}
	/**
	 * This repaint the JPanel */
	
//	public void paintComponent( Graphics g ) {
//		super.paintComponent( g );
//		g.setColor( Color.BLACK );
//		g.drawRect(100, 50, 100, 200);
//		g.setColor( Color.BLUE );
//		g.fillRect(105, 60, 90, 180);
//	}


	public String getReservoir() {

		res1 = reservoir.getText().trim();
		return res1;

		}

	private JPanel getres12XPanel(int r) {
		if (res12XPanel == null) {
//			GridLayout gridLayout = new GridLayout();
//			gridLayout.setRows(1);
//			gridLayout.setColumns(1);
			res12XPanel = new JPanel();
			res12XPanel.setLayout(new FlowLayout());
			res12XPanel.add(getTextWindow(r));
			}
		return res12XPanel;
	}

	private JPanel getTextWindow( int r) {
		if (textWindow == null) {
			textWindow = new JPanel();
			textWindow.setLayout(new GridLayout( 1, 12 ));
//			hTextArea.setBorder( blackline );
//			textWindow.setBackground(panelColor);
//			textWindow.setBackground(Color.WHITE);
			for ( int d = 0; d < 12; d++ ) {
				dTextArea[ d ] = new JTextArea( 14, 2 );
				dTextArea[ d ].setVisible(false);
				
			}
			dTextArea[ 0 ].setEditable(false);
//			dTextArea[ 0 ].setVisible(true);
			dTextArea[ 0 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				update = true;
				dTextArea[ 0 ].setBorder(redline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 0 ]);
			dTextArea[ 1 ].setEditable(false);
//			dTextArea[ 1 ].setVisible(true);
			dTextArea[ 1 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				}
				dTextArea[ 1 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 1 ]);
			dTextArea[ 2 ].setEditable(false);
//			dTextArea[ 2 ].setVisible(true);
			dTextArea[ 2 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update == false)
				{	
				update = true;
				dTextArea[ 2 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
			}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 2 ]);
			dTextArea[ 3 ].setEditable(false);
//			dTextArea[ 3 ].setVisible(true);
			dTextArea[ 3 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 3 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 3 ]);
			dTextArea[ 4 ].setEditable(false);
//			dTextArea[ 4 ].setVisible(true);
			dTextArea[ 4 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 4 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 4 ]);
			dTextArea[ 5 ].setEditable(false);
//			dTextArea[ 5 ].setVisible(true);
			dTextArea[ 5 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 5 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 5 ]);
			dTextArea[ 6 ].setEditable(false);
//			dTextArea[ 6 ].setVisible(true);
			dTextArea[ 6 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 6 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 6 ]);
			dTextArea[ 7 ].setEditable(false);
//			dTextArea[ 7 ].setVisible(true);
			dTextArea[ 7 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 7 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 7 ]);
			dTextArea[ 8 ].setEditable(false);
//			dTextArea[ 8 ].setVisible(true);
			dTextArea[ 8 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 8 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 8 ]);
            dTextArea[ 9 ].setEditable(false);
//			dTextArea[ 9 ].setVisible(true);
			dTextArea[ 9 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 9 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 9 ]);
            dTextArea[ 10 ].setEditable(false);
//			dTextArea[ 10 ].setVisible(true);
			dTextArea[ 10 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 10 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 11 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 10 ]);
            dTextArea[ 11 ].setEditable(false);
//			dTextArea[ 11 ].setVisible(true);
			dTextArea[ 11 ].addMouseListener(new java.awt.event.MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
				if (update ==  false)
				{
				update = true;
				dTextArea[ 11 ].setBorder(redline);
				dTextArea[ 0 ].setBorder(blackline);
				dTextArea[ 1 ].setBorder(blackline);
				dTextArea[ 2 ].setBorder(blackline);
				dTextArea[ 3 ].setBorder(blackline);
				dTextArea[ 4 ].setBorder(blackline);
				dTextArea[ 5 ].setBorder(blackline);
				dTextArea[ 6 ].setBorder(blackline);
				dTextArea[ 7 ].setBorder(blackline);
				dTextArea[ 8 ].setBorder(blackline);
				dTextArea[ 9 ].setBorder(blackline);
				dTextArea[ 10 ].setBorder(blackline);
				dTextArea[ 12 ].setBorder(blackline);
				}
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

			});
			textWindow.add(dTextArea[ 11 ]);
 
		}
		for ( int res = 0; res < r; res++ )
			dTextArea[res].setVisible(true);
		return textWindow;
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize( int r) {
		this.setSize(500, 500);
		this.setLayout(new FlowLayout());
		//		this.add(getres12XPanel(), BorderLayout.CENTER);
		this.add(getres12XPanel(rescount));
//		this.add(lres1);
//		this.add(reservoir);

	}
}
