	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Panel Object - reservoir panel (Auto Pilot 1.0)
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.FlowLayout;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class ReservoirPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JPanel reservoirPanel = null;
	private JPanel reservoirPanelTop = null;
	private JPanel reservoirPanelBottomh = null;

	Border blackline = BorderFactory.createLineBorder(Color.black, 3);
	Icon icon1 = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Graphics/Abgene_AB-0765_96.png"); 
    private Color panelColor = new Color(248, 248, 255);
    public JLabel label1 = new JLabel("");
    
	private String reservoir1 = "";
	private String reservoir2 = "";
	private JLabel	lreservoirl1 = new JLabel( "First reservoir\n ");
	private JLabel	lreservoirl2 = new JLabel( "Last reservoir ");
	private JTextField lreservoir1 = new JTextField(2);
	private JTextField lreservoir2 = new JTextField(2);
	private JCheckBox lt1inc = new JCheckBox ( "Increment" ) ;

	/**
	 * This is the default constructor
	 */
	public ReservoirPanel() {
		super();
		initialize();
	}

	/**
	 * This repaint the JPanel */
	
//	public void paintComponent( Graphics g ) {
//		super.paintComponent( g );
////		g.setColor( Color.BLACK );
////		g.drawArc(95, 90, 110, 120, 0, 360);
//		g.setColor( Color.BLUE );
//		g.fillArc(100, 100, 100, 100, 0, 360);
//	}
	
	private JPanel getreservoirPanelTop() {
		if (reservoirPanelTop == null) {			

			reservoirPanelTop = new JPanel();
            reservoirPanelTop.setBackground(this.panelColor);
			reservoirPanelTop.setLayout(new FlowLayout());

			reservoirPanelTop.add(lreservoirl1);
			reservoirPanelTop.add(lreservoir1);
			reservoirPanelTop.add(lreservoirl2);
			reservoirPanelTop.add(lreservoir2);
			}
		return reservoirPanelTop;
	}	
	
	private JPanel getReservoirPanelBottom() {
		if (reservoirPanel == null) {			
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setColumns(1);
			reservoirPanel = new JPanel();
            reservoirPanel.setBackground(this.panelColor);
			reservoirPanel.setLayout(gridLayout);
			label1.setHorizontalAlignment(JLabel.CENTER);
			reservoirPanel.add(label1);
			}
		return reservoirPanel;
	}

	public String getFirstreservoir() {
		reservoir1 = lreservoir1.getText().trim();
		return reservoir1;
		}
	public String getLastreservoir() {
		
		reservoir2 = lreservoir2.getText().trim();
		return reservoir2;

		}

	public void setFirstreservoir( String t ) {
		lreservoir1.setText( t );
		}
	
	public void setLastreservoir( String t ) {
		lreservoir2.setText( t );
		}

	public void setIncButton( String i ) {
		if (i.trim().equals("1"))
		{
			lt1inc.setSelected(true);
		}
		else
		{
			lt1inc.setSelected(false);
		}
			
	}

	public boolean incIsSelected() {
		if (lt1inc.isSelected())
		{	
		return true ;
		}
		else
		{
		return false;	
		}
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 500);
		this.setBackground(this.panelColor);
		this.setLayout(new BorderLayout());
	
		label1.setText("SELECT RESERVOIR TYPE ABOVE");

		add(getReservoirPanelBottom(), BorderLayout.CENTER);
	
	}
}
