	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Panel Object - Sample panel (Auto Pilot 1.0)
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class SamplePanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JPanel samplePanel = null;

	Border blackline = BorderFactory.createLineBorder(Color.black, 3);
	private JButton splashbutton = null;
	private JLabel	splabel1 = new JLabel( " x ");
	private JLabel	splabel2 = new JLabel( " x ");
	private JLabel	splabel3 = new JLabel( " x ");
	private JLabel	splabel4 = new JLabel( " x ");
	private JLabel	splabel5 = new JLabel( " x ");
	private JLabel	splabel6 = new JLabel( " x ");
	private JLabel	splabel7 = new JLabel( " x ");
	private JLabel	splabel8 = new JLabel( " x ");

	/**
	 * This is the default constructor
	 */
	public SamplePanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes saveButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getSplashButton() {
		if (splashbutton == null) {
			splashbutton = new javax.swing.JButton();
//			splashbutton.setPreferredSize(new Dimension(34, 34));
//			splashbutton.setContentAreaFilled(false);
//			splashbutton.setFocusPainted(false);
			splashbutton.setText("Add Step");
//			splashbutton.setIcon( icons[ 3 ] );
			splashbutton.setToolTipText("Continue Scheme Entry");
    
			splashbutton.addFocusListener(new FocusAdapter(){
				public void focusGained(FocusEvent fe){
					  splashbutton.setBorder(null);
					  }
				public void focusLost(FocusEvent e) {
					splashbutton.setBorder(null);
					
				    }
			});
	
			splashbutton.addMouseListener(new MouseAdapter(){   
				  public void mouseEntered(MouseEvent me){   
				    splashbutton.setContentAreaFilled(true);   
				  }   
				  public void mouseExited(MouseEvent me){   
					  splashbutton.setContentAreaFilled(false);   
				  }   
				});  

			splashbutton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
//					saveFile();
				}
			});
		}
		return splashbutton;
	}

	private JPanel getSamplePanel() {
		if (samplePanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(3);
			gridLayout.setColumns(3);
			samplePanel = new JPanel();
			samplePanel.setLayout(gridLayout);
			samplePanel.add(splabel1);
			samplePanel.add(splabel2);
			samplePanel.add(splabel3);
			samplePanel.add(splabel4);
			samplePanel.add(getSplashButton());
			samplePanel.add(splabel5);
			samplePanel.add(splabel6);
			samplePanel.add(splabel7);
			samplePanel.add(splabel8);
			
			}
		return samplePanel;
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 500);
		this.setLayout(new BorderLayout());
		this.setBorder(blackline) ;
		this.add(getSamplePanel(), BorderLayout.CENTER);
	}
}
