	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Dilution window for Serial Step  (Auto Pilot 1.0)
	 * 
	 * Updates - 09/04/13 - JC - SD1.4 - Rows populated based on VAS interpretation of pattern.
	 * 
	 */


package TelosV2Pkg;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.MouseAdapter; 
import java.awt.event.MouseEvent;
import java.io.BufferedReader;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Vector;

public class SerialSchemePanel extends JPanel {
       /**
	 * 
	 */
	
	private static final long serialVersionUID = 1L;
	Border blackline = BorderFactory.createLineBorder(Color.black);
	private Color panelColor = new Color(248, 248, 255);  
	private Color steelDrkColor = new Color (70, 130, 180);
	public boolean tablecomplete = false;
	
//	public static int tableRowCount = 2;
//	public static Object[][] data = new Object[tableRowCount][3];

	String[] columnNames = {
			 "TransferNumber",
			 "TransferVolume",
			 "DiluentVolume",
			 };
	
	 public static DefaultTableModel dataModel = new DefaultTableModel() {
		private static final long serialVersionUID = 1L;
	 };
	
	public JTable table = new JTable(dataModel);
	
 
	public SerialSchemePanel() {   
//		JTable table = new JTable(dataModel);
		this.setLayout(new GridLayout(1,1));
		DefaultTableCellRenderer renderer = (DefaultTableCellRenderer)table.getDefaultRenderer(String.class);    
		renderer.setHorizontalAlignment(JLabel.CENTER);
		
		//Add Three Columns
		for (int col = 0; col < columnNames.length; col++) {
			 dataModel.addColumn(columnNames[col]);
		}
		
		//Double Click on the table selects all rows
		table.addMouseListener( new MouseAdapter()
		{
			public void mouseClicked( MouseEvent e )
			{
				// Left mouse click
				
				if ( e.getClickCount() == 2 )
				{
					table.selectAll();
				}
			}
		});
		
    	table.setRowHeight(30);
        int height = dataModel.getRowCount() * table.getRowHeight();
    	if (height > 360){height = 360;}
        table.setPreferredScrollableViewportSize(new Dimension(DilWindow.windowWidth-25, 360));
        table.setBorder(blackline);
        table.setShowHorizontalLines(true);
        table.setShowVerticalLines(true);
        table.setSelectionBackground(Color.GREEN);
        table.getTableHeader();
        table.setFillsViewportHeight(true); 
        table.setColumnSelectionAllowed( true );

        //Disable auto resizing
        table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);

        // Set the second visible column to 100 pixels wide
        int vColIndex1 = 0;
        TableColumn col1 = table.getColumnModel().getColumn(vColIndex1);
        col1.setPreferredWidth(1);
        col1.setHeaderValue("  " );
        col1.setResizable(false);

        
        // Set the first visible column to 100 pixels wide
        int vColIndex2 = 1;
        TableColumn col2 = table.getColumnModel().getColumn(vColIndex2);
        col2.setPreferredWidth(100);
        col2.setHeaderValue("      Transfer Vol (ul) " );
        col2.setResizable(false);
        
        // Set the second visible column to 100 pixels wide
        int vColIndex3 = 2;
        TableColumn col3 = table.getColumnModel().getColumn(vColIndex3);
        col3.setPreferredWidth(100);
        col3.setHeaderValue("      Diluent Vol (ul) " );
        col3.setResizable(false);


        //Create the scroll pane and add the table to it.  
        JScrollPane scrollPane = new JScrollPane(table); 
        scrollPane.setBorder(blackline);
        
        table.getModel().addTableModelListener(new TableModelListener() {

         	public void tableChanged(TableModelEvent e) {
                int row = e.getFirstRow();
                int column = e.getColumn();
                TableModel model = (TableModel)e.getSource();
                String columnName = model.getColumnName(column);
                tablecomplete = true;
            	for (int i = 0; i < model.getRowCount(); i++)
            	{ 
           			if (model.getValueAt( i, 1) != null){
           				String val = model.getValueAt( i, 1).toString();
           				if (val.trim().equals("")) 
               			{        
               				tablecomplete =  false;
               			}  
           			}
           			
            	}     
            } 
          });

       
        //Add the scroll pane to this panel. 
        add(scrollPane); 
        this.setBackground(panelColor);

	}  

	
	
} 


