	/**
 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Advanced function window (Auto Pilot 1.0)
	 * 
	 */


package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;
import java.util.concurrent.CountDownLatch;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.apache.poi.ss.usermodel.Cell;

import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.DatabaseBuilder;
import com.healthmarketscience.jackcess.Row;
import com.healthmarketscience.jackcess.Table;
import com.itextpdf.text.io.RandomAccessSourceFactory;
import com.itextpdf.text.pdf.RandomAccessFileOrArray;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.parser.PdfReaderContentParser;
import com.itextpdf.text.pdf.parser.SimpleTextExtractionStrategy;
import com.itextpdf.text.pdf.parser.TextExtractionStrategy;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class TestingWindow extends JFrame {
	private static final long serialVersionUID = 1L;
	public static boolean frameActive = false;
	private JPanel jContentPane = null;
	private JPanel okPanel = null;
	private JButton okButton = null ;  

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TestingWindow thisClass = new TestingWindow();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}
	/**
	 * This is the default constructor
	 */
	public TestingWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(350, 250);
		this.setContentPane(getJContentPane());
		this.setTitle("Aspirate Options");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getOKPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}


	private JPanel getOKPanel() {
		if (okPanel == null) {
			FlowLayout flow = new FlowLayout();
			okPanel = new JPanel();
			okPanel.setLayout(flow);
            okPanel.add(getOKButton());
		 }
		return okPanel;
	}
	
	

    public void gyrosParser() throws IOException {
    	String gyroPdf_filePath = "C:\\Users\\Jesse Campbell\\Desktop\\TEST.pdf";
    	String gyroPdfParsedRaw_filePath = "C:\\Program Files\\Telos\\AutoPilot\\System\\gyrolabParsedInterm.txt";							//Intermediate text file that is created from parsed .pdf.  This file will then be opened and processed below
    	String gyroPdfParsedFinal_filePath = "C:\\Program Files\\Telos\\AutoPilot\\Data\\PK_GyrolabParsed" + gyroPdf_filePath.substring(gyroPdf_filePath.lastIndexOf("\\") , gyroPdf_filePath.lastIndexOf(".")+1) + "txt";							//Text file containing formatted parsed sample info from original .pdf
    	String gyroPdfParsedRaw_textAll = "";																								//All text from .pdf.  Search this for "GyroLab" to confirm the file is a GyroLab "LoadList"

        boolean tableOn = false;
		int plateNumberInt = 0;
		int eSampleNumber;
		int eIDend;
		int eDil;
		int eWell;
		int PK_WorklistTotalRecords = 0;
		int cntr1 = 0;
    	String newline;
    	String id = "";
    	String SampleType = "";
		String currentSampleNumber;
		String nextReadSampleNumber;
		String nextRequiredSampleNumber;
		String writeString;
    	ArrayList<String> arrayList_Interm = new ArrayList<String>();																//arrayList to hold each line from Intermediate text file
    	String[][] array_PK_Input = new String[960][6];																				//array to hold final captured and organized lines of data from original .pdf.  declared to 960 possible samples
    	
    	try {																														//Extract info from PDF to intermediate text file.
			PdfReader reader = new PdfReader(gyroPdf_filePath);
			PdfReaderContentParser parser = new PdfReaderContentParser(reader);
			PrintWriter outInterm = new PrintWriter(new FileOutputStream(gyroPdfParsedRaw_filePath));
			TextExtractionStrategy strategy;
			for (int i = 1; i <= reader.getNumberOfPages(); i++) {
			    strategy = parser.processContent(i, new SimpleTextExtractionStrategy());
			    outInterm.println(strategy.getResultantText());
			    gyroPdfParsedRaw_textAll = gyroPdfParsedRaw_textAll + strategy.getResultantText();
			}
			outInterm.flush();
			outInterm.close();
			reader.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "VAS Error: error parsing GyroLab file\n\nerror: " + e);
			e.printStackTrace();
			return;
		}
        
    	if (!gyroPdfParsedRaw_textAll.contains("Gyrolab")){
    		JOptionPane.showMessageDialog(null, "VAS Error: error parsing GyroLab file\n\nerror: File format not recognized"); return;
    	}
    	
    	FileReader input;
		File f = new File(gyroPdfParsedRaw_filePath);
        input = new FileReader(f);
		BufferedReader br = new BufferedReader(input);
		
		try {
			while ((newline = br.readLine()) != null) {											//create arrayList_Interm from pdf
			    
				if (newline.contains("R-MP1")){break;}
				if (newline.equals("Gyrolab Control Loading")){tableOn = false;}
				if (newline.matches("MP._CD.*")){tableOn = false;}

				if (tableOn){
					arrayList_Interm.add(newline);
				}
				
				if (newline.equals("Pos Reagent/Sample Concentration Vol. [l] Well")){tableOn = true;}
			  }
			br.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "VAS Error: error parsing GyroLab file\n\nerror: " + e);
			e.printStackTrace();
		}

        for (int i = 0; i < arrayList_Interm.size(); i++){									//parse fields correctly into array_PK_Input
        	
        	String currentString = arrayList_Interm.get(i);
        	currentSampleNumber = arrayList_Interm.get(i).split(" ")[0];
        	nextRequiredSampleNumber = String.valueOf(Integer.parseInt(currentSampleNumber) + 1);
        	if ((i+1)<arrayList_Interm.size()){nextReadSampleNumber = arrayList_Interm.get(i+1).split(" ")[0];}else{nextReadSampleNumber="0";}
        	
        	writeString = currentString;
        	
        	if (!nextReadSampleNumber.equals(nextRequiredSampleNumber)){					//Input lines more than 36 characters split to three different lines
        		String idLine2 = arrayList_Interm.get(i+1);									//Second part of sample id located on second line

        		if (currentString.matches(".*\\s\\d\\s\\D\\d{1,2}")){ 						//Line includes vol and well info indicating that second line of name is on next page. 
        			String idLine1 = writeString.split("\\s\\d\\s\\D\\d{1,2}")[0];			//Strip vol and well from name
        			String volWell = writeString.substring(idLine1.length());				//Record vol and well
        			writeString = idLine1 + " " + idLine2 + volWell;						//Rebuild NameLine1 + NameLine2 + VolWell (parsed from line1)
        			i++;
        		}else{
        			String volWell = arrayList_Interm.get(i+2);								//Record vol and well
	         		writeString = writeString + " " + idLine2 + " " + volWell;				//Rebuild NameLine1 + NameLine2 + VolWell (from line 3)
	        		i++; i++;       			
        		}
        	}
        	

        	eSampleNumber = 0;
    		id="";
        	eDil = writeString.split(" ").length - 3;
        	eWell = writeString.split(" ").length - 1;
        	
        	if (writeString.contains("STD") || writeString.contains("QC") || writeString.contains("blank") || writeString.contains("BLANK") ){eIDend = 2; SampleType = "0";}else{eIDend = 3; SampleType = "1";}
        	if (writeString.split(" ")[eSampleNumber].equals("1")){plateNumberInt++;}
        	for (int a = 1; a < writeString.split(" ").length - eIDend; a++){id = id+writeString.split(" ")[a]+" ";}
        	
        	array_PK_Input[cntr1][0] = String.valueOf(plateNumberInt);
        	array_PK_Input[cntr1][1] = writeString.split(" ")[eSampleNumber];
        	array_PK_Input[cntr1][2] = id;
        	array_PK_Input[cntr1][3] = writeString.split(" ")[eDil];
        	array_PK_Input[cntr1][4] = writeString.split(" ")[eWell];
        	array_PK_Input[cntr1][5] = SampleType;
        	
        	cntr1++; PK_WorklistTotalRecords++;
		}
        
        try {
			PrintWriter out = new PrintWriter(new FileOutputStream(gyroPdfParsedFinal_filePath));
			for (int a = 0; a < PK_WorklistTotalRecords; a++){
				out.println(array_PK_Input[a][0]+"\t"+array_PK_Input[a][1]+"\t"+array_PK_Input[a][2]+"\t"+array_PK_Input[a][3]+"\t"+array_PK_Input[a][4]+"\t"+array_PK_Input[a][5]);
				}
			out.flush();
			out.close();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "VAS Error: error parsing GyroLab file\n\nerror: " + e);
			e.printStackTrace();
		}
    }
    
	/**
	 * This method returns labware properties.
	 *  For Hamilton
     *	labwareParamaters 1=.rck Height,  2=.rck number of wells, 5=.ctr depth,  6=.ctr Total Volume,  10=grip position WITH LID
	 */
    public static String SystemLabwareData(int labwareParameter, String LabwareDefFile_WithoutExtension){
    	// Collect information from labware file.  
    	// To be configured for each type of system (e.g. Beckman, Hamilton, Tecan)

    	FileReader input;
    	String returnValue = "";
    	String s = "";
    	String labwareHeight = "";
    	String labwareColumns = "";
    	String labwareRows = "";
    	String lidToBase = "";
    	String segments = "";
    	String gripHeightWithLid = "";
    	String fileRack = LabwareDefFile_WithoutExtension + ".rck";
    	String fileContainer = LabwareDefFile_WithoutExtension + ".ctr";
    	String fileLid = LabwareDefFile_WithoutExtension + ".lid";
    	String newline = "";
    	String lineIN_Rack = "";
    	String lineIN_Container = "";
    	String lineIN_Lid = "";
    	
    	boolean matched = false;
    	

        // .rck file
    	if (labwareParameter == 1 || labwareParameter == 2|| labwareParameter == 10){
    		matched = false;
        	File f = new File(fileRack);
            try {
              input = new FileReader(f);
              BufferedReader br = new BufferedReader(input);
              while ((newline = br.readLine()) != null) {
            	  lineIN_Rack = lineIN_Rack + newline;
              }
              input.close();
            }catch (Exception e) {
            	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::"+e);
            }
            
            // GET RACK HEIGHT
    		Pattern patternDimDz = Pattern.compile("Dim.Dz......");
            Matcher matcherDimDz = patternDimDz.matcher(lineIN_Rack);
            if (matcherDimDz.find()) {
            	s = matcherDimDz.group().substring(1);
            	matched = true;
            } 
              if (matched){
    	          boolean start = false;
    	          char[] characters = s.toCharArray();
    	          for(int i =0;i<characters.length;i++){//Start recording at first character that is a digit.  Stop recording at next character that is not a digit.  This will capture digits up to the "."
    	  			if(Character.isDigit(characters[i])){
    	  				start = true;
    	  				labwareHeight = labwareHeight + String.valueOf(characters[i]);
    	  			}else{
    	  				if (start == true){break;}
    	  			}
    	          }       	  
              }else{
              	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::Labware Height not found");
              }
              
              // GET RACK NUMBER OF WELLS
              //Columns
              Pattern patternColumns = Pattern.compile("Columns......");
              Matcher matcherColumns = patternColumns.matcher(lineIN_Rack);
              if (matcherColumns.find()) {
              	s = matcherColumns.group().substring(1);
              	matched = true;
              } 
              if (matched){
      	          boolean start = false;
      	          char[] characters = s.toCharArray();
      	          for(int i =0;i<characters.length;i++){//Start recording at first character that is a digit.  Stop recording at next character that is not a digit.  This will capture digits up to the "."
      	  			if(Character.isDigit(characters[i])){
      	  				start = true;
      	  				labwareColumns = labwareColumns + String.valueOf(characters[i]);
      	  			}else{
      	  				if (start == true){break;}
      	  			}
      	          }       	  
              }else{
                	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::Labware Columns not found");
              }
              //Rows
              Pattern patternRows = Pattern.compile("Rows......");
              Matcher matcherRows = patternRows.matcher(lineIN_Rack);
              if (matcherRows.find()) {
              	s = matcherRows.group().substring(1);
              	matched = true;
              } 
              if (matched){
      	          boolean start = false;
      	          char[] characters = s.toCharArray();
      	          for(int i =0;i<characters.length;i++){//Start recording at first character that is a digit.  Stop recording at next character that is not a digit.  This will capture digits up to the "."
      	  			if(Character.isDigit(characters[i])){
      	  				start = true;
      	  				labwareRows = labwareRows + String.valueOf(characters[i]);
      	  			}else{
      	  				if (start == true){break;}
      	  			}
      	          }       	  
              }else{
                	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::Labware Rows not found");
              }  

              //Return Value based on parameter selected.  Total Well number is calculated based on Columns*Rows  
              if (labwareParameter == 1){returnValue = labwareHeight;}
              if (labwareParameter == 2){returnValue = String.valueOf(Integer.parseInt(labwareColumns)*Integer.parseInt(labwareRows));}
            matched = false;
    	}
    	
    	if (labwareParameter == 10){
    		matched = false;
    		File f = new File(fileLid);
            try {
              input = new FileReader(f);
              BufferedReader br = new BufferedReader(input);
              while ((newline = br.readLine()) != null) {
            	  lineIN_Lid = lineIN_Lid + newline;
              }
              input.close();
            }catch (Exception e) {
            	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::"+e);
            }
            
    		Pattern patternRackBaseToCoverBase = Pattern.compile("RackBaseToCoverBase......");
        	Matcher matcherRackBaseToCoverBase = patternRackBaseToCoverBase.matcher(lineIN_Lid);
            if (matcherRackBaseToCoverBase.find()) {
            	s = matcherRackBaseToCoverBase.group().substring(1);
            	matched = true;
            } 
              
              if (matched){
    	          boolean start = false;
    	          char[] characters = s.toCharArray();
    	          for(int i =0;i<characters.length;i++){//Start recording at first character that is a digit.  Stop recording at next character that is not a digit.  This will capture digits up to the "."
    	  			if(Character.isDigit(characters[i])){
    	  				start = true;
    	  				lidToBase = lidToBase + String.valueOf(characters[i]);
    	  			}else{
    	  				if (start == true){break;}
    	  			}
    	          }
    	          
    	          gripHeightWithLid = String.valueOf(  (Integer.parseInt(labwareHeight) - Integer.parseInt(lidToBase))  + 2);
              }else{
              	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::Lid Dimensions Not Found");
              }
 
            
            returnValue = gripHeightWithLid;
    	}
    	
    	if (labwareParameter == 6){/////////////// NOT COMPLETE!
    		matched = false;
    		File f = new File(fileContainer);
            try {
              input = new FileReader(f);
              BufferedReader br = new BufferedReader(input);
              while ((newline = br.readLine()) != null) {
            	  lineIN_Container = lineIN_Container + newline;
              }
              input.close();
            }catch (Exception e) {
            	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::"+e);
            }
              Pattern patternSegments = Pattern.compile("Segments......");
              Matcher matcherSegments = patternSegments.matcher(lineIN_Container);
              if (matcherSegments.find()) {
              	s = matcherSegments.group().substring(1);
              	matched = true;
              }               
              if (matched){
    	          boolean start = false;
    	          char[] characters = s.toCharArray();
    	          for(int i =0;i<characters.length;i++){//Start recording at first character that is a digit.  Stop recording at next character that is not a digit.  This will capture digits up to the "."
    	  			if(Character.isDigit(characters[i])){
    	  				start = true;
    	  				segments = segments + String.valueOf(characters[i]);
    	  			}else{
    	  				if (start == true){break;}
    	  			}
    	          }

    	          for(int i =1;i<Integer.parseInt(segments)+1;i++){
    	        	 /////////////// SCROLLING THROUGH SHAPES started here but not completed
    	          }
              }else{
              	VAStools.errorMessageProcess("VAS ERROR::VAS cannot process the labware file " + LabwareDefFile_WithoutExtension +"\n\nError ID::Lid Dimensions Not Found");
              }
            
            returnValue = segments;	
    	}
        
        return returnValue;
      }
    
    
    
	private javax.swing.JButton getOKButton() {
		if (okButton == null) {
			okButton = new javax.swing.JButton();
			okButton.setSize(20, 20);
			okButton.setText("    OK     ");
			okButton.setHorizontalAlignment(SwingConstants.CENTER);
		    okButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					
					JTextArea area = new JTextArea(5,20);
					area.setLineWrap(true);
//					int okCxl = JOptionPane.showConfirmDialog(
//							null,
//                            area,
//                            "Reason For Change",
//                            JOptionPane.NO_OPTION
//                            );
					
					int okCxl = JOptionPane.showConfirmDialog(
							null, 
							area, 
							"Reason for modification.", 
							JOptionPane.OK_CANCEL_OPTION, 
							JOptionPane.PLAIN_MESSAGE, 
							null);

							
							
if (okCxl == JOptionPane.OK_OPTION) {
	JOptionPane.showMessageDialog(null, area.getText()); 
	return;
// Process text.
}
					
					
					
					
					String x = "a,s,d,f";	
					
					
JOptionPane.showMessageDialog(null, x.replaceFirst(".{2}", ""));
			
String xx = "A12";

if (!x.matches("\\D(?![0])\\d{1,2}") ){
	JOptionPane.showMessageDialog(null, "1 - YES");
}else{
	JOptionPane.showMessageDialog(null, "2 - NO");
}


JOptionPane.showMessageDialog(null, "STOP");


FileReader input;
String newline;
String tabChar = "\t";
try {
	  File f = new File("C:\\test.xls");
	  input = new FileReader(f);
	  BufferedReader br = new BufferedReader(input);
	  while (!(newline = br.readLine()).contains("Index")) {
		  JOptionPane.showMessageDialog(null, newline.split(tabChar)[0]);	
	  }
	  
	  while ((newline = br.readLine()) != null) {
		  if (newline.split(tabChar)[0].equals("")){JOptionPane.showMessageDialog(null, "BLANK");}
		  JOptionPane.showMessageDialog(null, newline.split(tabChar)[0] + "   -   " + newline.split(tabChar)[2]);	
	  }
	  br.close();
} catch (Exception e1) {
	JOptionPane.showMessageDialog(null, "VAS Error: error parsing Watson file\n\nerror: " + e1);
	e1.printStackTrace();
}

JOptionPane.showMessageDialog(null, "GO2");

try {
File excel = new File ("C:\\test.xls");
FileInputStream fis = new FileInputStream(excel);
    HSSFWorkbook wb = new HSSFWorkbook(fis);
    HSSFSheet sheet = wb.getSheetAt(0);
    HSSFRow row;
    HSSFCell cell;

    int rows; // No of rows
    rows = sheet.getPhysicalNumberOfRows();

    int cols = 0; // No of columns
    int tmp = 0;

    // This trick ensures that we get the data properly even if it doesn't start from first few rows
    for(int i = 0; i < 10 || i < rows; i++) {
        row = sheet.getRow(i);
        if(row != null) {
            tmp = sheet.getRow(i).getPhysicalNumberOfCells();
            if(tmp > cols) cols = tmp;
        }
    }

    for(int r = 0; r < rows; r++) {
        row = sheet.getRow(r);
        if(row != null) {
            for(int c = 0; c < cols; c++) {
                cell = row.getCell(c);
                if(cell != null) {
                    JOptionPane.showMessageDialog(null, cell);
                }
            }
        }
    }
} catch(Exception ioe) {
    ioe.printStackTrace();
}
				
JOptionPane.showMessageDialog(null, "STOP");

				}
			});
		}
		return okButton;
	}

	double roundTwoDecimals(double d) {
        DecimalFormat twoDForm = new DecimalFormat("#.##");
    return Double.valueOf(twoDForm.format(d));
	}
	
	public static void LiquidClassConfirm(String dataBase){
		boolean found = false;
		String liquidClass;
		String liquid;
		try {
			Database db = DatabaseBuilder.open(new File(dataBase));
			Table table = db.getTable("LiquidClass");
			  for(Row row : table) { 
				  liquidClass = String.valueOf(row.get("LiquidClassName"));
				    if (liquidClass.contains("tip_") && liquidClass.contains("_pip")){
				    	liquid = liquidClass.split("_")[1];
				    	JOptionPane.showMessageDialog(null, liquidClass);
				    	JOptionPane.showMessageDialog(null, liquid);
				    }
			  }
			  db.close();
		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
			JOptionPane.showMessageDialog(null, "ERRRRRROOOORRRR");
		}		
	}
	
}
