	/**
	 * Copyright 	- Telos Scientific - 01/10/2010
	 * Author 		- Robin S Campbell
	 * Description	- Panel Object - Tube panel (Auto Pilot 1.0)
	 */

package TelosV2Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.FlowLayout;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class TubePanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JPanel tubePanel = null;
	private JPanel tubePanelTop = null;
	private JPanel tubePanelBottomh = null;

	Border blackline = BorderFactory.createLineBorder(Color.black, 3);
	Icon icon1 = new ImageIcon("C:/Program Files/TELOS/AutoPilot/Graphics/Abgene_AB-0765_96.png"); 
    private Color panelColor = new Color(248, 248, 255);
    public JLabel label1 = new JLabel("");
    
	private String tube1 = "";
	private String tube2 = "";
	private JLabel	ltubel1 = new JLabel( "First Tube\n ");
	private JLabel	ltubel2 = new JLabel( "Last Tube ");
	private JTextField ltube1 = new JTextField(2);
	private JTextField ltube2 = new JTextField(2);
	private JCheckBox lt1inc = new JCheckBox ( "Increment" ) ;

	/**
	 * This is the default constructor
	 */
	public TubePanel() {
		super();
		initialize();
	}

	/**
	 * This repaint the JPanel */
	
//	public void paintComponent( Graphics g ) {
//		super.paintComponent( g );
////		g.setColor( Color.BLACK );
////		g.drawArc(95, 90, 110, 120, 0, 360);
//		g.setColor( Color.BLUE );
//		g.fillArc(100, 100, 100, 100, 0, 360);
//	}
	
	private JPanel getTubePanelTop() {
		if (tubePanelTop == null) {			

			tubePanelTop = new JPanel();
            tubePanelTop.setBackground(this.panelColor);
			tubePanelTop.setLayout(new FlowLayout());

			tubePanelTop.add(ltubel1);
			tubePanelTop.add(ltube1);
			tubePanelTop.add(ltubel2);
			tubePanelTop.add(ltube2);
			}
		return tubePanelTop;
	}	
	
	private JPanel getTubePanelBottom() {
		if (tubePanel == null) {			
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setColumns(1);
			tubePanel = new JPanel();
            tubePanel.setBackground(this.panelColor);
			tubePanel.setLayout(gridLayout);
			label1.setHorizontalAlignment(JLabel.CENTER);
			tubePanel.add(label1);
			}
		return tubePanel;
	}

	public String getFirstTube() {
		tube1 = ltube1.getText().trim();
		return tube1;
		}
	public String getLastTube() {
		
		tube2 = ltube2.getText().trim();
		return tube2;

		}

	public void setFirstTube( String t ) {
		ltube1.setText( t );
		}
	
	public void setLastTube( String t ) {
		ltube2.setText( t );
		}

	public void setIncButton( String i ) {
		if (i.trim().equals("1"))
		{
			lt1inc.setSelected(true);
		}
		else
		{
			lt1inc.setSelected(false);
		}
			
	}

	public boolean incIsSelected() {
		if (lt1inc.isSelected())
		{	
		return true ;
		}
		else
		{
		return false;	
		}
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 500);
		this.setBackground(this.panelColor);
		this.setLayout(new BorderLayout());
	
		label1.setText("SELECT TUBE TYPE ABOVE");

		add(getTubePanelTop(), BorderLayout.NORTH);
		add(getTubePanelBottom(), BorderLayout.CENTER);
	
	}
}
