package TelosV2Pkg;

/**
 * Copyright 	- Telos Scientific - 06/17/2014
 * Author 		- Jesse A Campbell
 * Description	- User Account Entry window for Autopilot (Auto Pilot 1.0)
 * 
 * 06/17/14 - RSC - Program written
 */


import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.DateFormatSymbols;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Scanner;
import java.util.concurrent.CountDownLatch;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.util.Calendar;

import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.DatabaseBuilder;
import com.healthmarketscience.jackcess.Row;
import com.healthmarketscience.jackcess.Table;
import com.itextpdf.text.io.RandomAccessSourceFactory;
import com.itextpdf.text.pdf.RandomAccessFileOrArray;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.parser.PdfReaderContentParser;
import com.itextpdf.text.pdf.parser.SimpleTextExtractionStrategy;
import com.itextpdf.text.pdf.parser.TextExtractionStrategy;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Dimension;

public class UserAccountWindow extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel loginPanel = null;
	private static JButton saveButton = null ; 
	private static JButton deleteButton = null ;
	private static JButton cancelButton = null ; 

	private JPanel okPanel = null;
	private JLabel labelBlank1 = new JLabel("                    ");
	private JLabel labelBlank2 = new JLabel("                    ");
	private JLabel labelBlank3 = new JLabel("                    ");
	private JLabel labelBlank4 = new JLabel("                    ");
	private JLabel labelBlank5 = new JLabel("                    ");
	private JLabel labelBlank6 = new JLabel("                    ");
	private JLabel labelBlank7 = new JLabel("                    ");
	private JLabel labelBlank8 = new JLabel("                    ");
	private JLabel labelBlank9 = new JLabel("                    ");
	private JLabel labelBlank10 = new JLabel("                    ");
	private JLabel labelAccount = new JLabel("Account:");
	private JLabel labelUsername = new JLabel("User Name:");
	private JLabel labelPassword1 = new JLabel("Password:");
	private JLabel labelPassword2 = new JLabel("Password:");
	private JTextField textField_Username = new JTextField(20); 
	private JPasswordField  passwordField_Password1 = new JPasswordField(); // Component ULW1.2
	private JPasswordField  passwordField_Password2 = new JPasswordField(); // Component ULW1.2
//	private JTextField textField_Password1 = new JTextField(20); 
//	private JTextField textField_Password2 = new JTextField(20); 
	private final JLabel lblType = new JLabel("Type:");

	private String[] comboAccounts = {""};
	private String[] comboAccountTypes = { "Operator", "Method Developer", "Administrator"};
	
	private JComboBox comboBox_Accounts = new JComboBox();
	private JComboBox comboBox_AccountTypes = new JComboBox(comboAccountTypes);
	
	private final JLabel lblNewLabel = new JLabel("");
//	private final JButton btnCancel = new JButton(" Cancel ");
	private String password = null;
	private String confpassword = null;
	private String saveaccount = "";
	private String accountSelected = "";
	private String atype = "";
	String DateStamp;
	String TimeStamp;
	String DateTimeStamp;
	Calendar cal = Calendar.getInstance();
	SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy"); 
	long dateMilliseconds;
	
	private FileInputStream input;
//	List accountList = new List();  //  @jve:decl-index=0:
//	List accountbList = new List();  //  @jve:decl-index=0:
//	List accounteList = new List();  //  @jve:decl-index=0:
	
	ArrayList<String> arrayList_userData = new ArrayList();
	ArrayList<String> arrayList_userData_Encrypted = new ArrayList();
	
	public String decrypted;

	private boolean match = false;

	
	/**
	 * @param args
	 */
	public void main(String[] args) {

		try  
		{  
 	  //Tell the UIManager to use the platform look and feel  
		  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());  
		}  
		catch(Exception e)  
		{  
		  //Do nothing  
		}  
		
		// TODO Auto-generated method stub
		UserAccountWindow thisClass = new UserAccountWindow();
		thisClass.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		thisClass.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public UserAccountWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(475, 225);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle("AutoPilot Account Setup");
		int day = cal.get(Calendar.DAY_OF_MONTH);
		int month = cal.get(Calendar.MONTH); 
		int year = cal.get(Calendar.YEAR);
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
		DateStamp = Integer.toString(day) + "-" + ((new DateFormatSymbols().getMonths()[month]).substring(0,3))  + "-" + Integer.toString(year);
		DateTimeStamp = DateStamp + "_" + TimeStamp;

    	
		deleteButton.setEnabled(true);
		saveButton.setEnabled(false);
		
//			TabWindow.security_userLoggedIn = textField_Username.getText().trim();
//		TabWindow.loadButton.setEnabled(true);
//		TabWindow.runButton.setEnabled(true);
//		TabWindow.securityButton.setEnabled(true);
		
	    comboBox_Accounts.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		    	  
		    	String type = "";
		    		
		    	passwordField_Password1.setText("");
		    	passwordField_Password2.setText("");
		    	
		    	if (comboBox_Accounts.getSelectedIndex() == 0){
		    		textField_Username.setText("");
		    		
		    		comboBox_AccountTypes.setSelectedIndex(0);
		    		
		    		deleteButton.setEnabled(false);
		    		saveButton.setEnabled(true);

		    	}else{
		    		
		    		
		    		
		    		accountSelected = ((String)comboBox_Accounts.getSelectedItem());
		    		
		    		textField_Username.setText(accountSelected);

				    for (int i=0; i < arrayList_userData.size(); i++){
				    	if (arrayList_userData.get(i).split(",")[0].equals(accountSelected)){
				    		type = arrayList_userData.get(i).split(",")[2];
				    	}
				    }		
				    
			    	if (type.equals("Operator")){
			    		comboBox_AccountTypes.setSelectedIndex(0);	
			    	}else if (type.equals("Method Developer")){
			    		comboBox_AccountTypes.setSelectedIndex(1);	
			    	}else{
			    		comboBox_AccountTypes.setSelectedIndex(2);
			    	}

		    		deleteButton.setEnabled(true);
		    		saveButton.setEnabled(true);
		    		
		    	}

		    	
		      } 
		} );
	    
	    comboBox_AccountTypes.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		        atype = ((String)comboBox_AccountTypes.getSelectedItem());
		      } 
		} );
	    
	    //create a listener for all exit events
	    addWindowListener(new WindowAdapter()				//APN0049
	    {
	       public void windowClosing(WindowEvent e)
	       {							
	    	   onTop(false);
				textField_Username.setText("");
				passwordField_Password1.setText("");
				passwordField_Password2.setText("");
				comboBox_Accounts.setSelectedIndex(0);
				comboBox_AccountTypes.setSelectedIndex(0);
			    UserAccountWindow.this.setVisible(false);
	    	} 																																		

	    });
	    
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getLoginPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	private JPanel getOKPanel() {
		if (okPanel == null) {
			FlowLayout flow = new FlowLayout();
			okPanel = new JPanel();
			okPanel.setLayout(flow);
            okPanel.add(getsaveButton());
            okPanel.add(getdeleteButton());
            okPanel.add(getcancelButton());
		 }
		return okPanel;
	}
	
	private JPanel getLoginPanel() {
		if (loginPanel == null) {
			loginPanel = new JPanel();
			GridBagLayout gbl_loginPanel = new GridBagLayout();
			gbl_loginPanel.columnWidths = new int[]{60, 56, 166, 60, 0};
			gbl_loginPanel.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0};
			gbl_loginPanel.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			gbl_loginPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
			loginPanel.setLayout(gbl_loginPanel);
						
			GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
			gbc_lblNewLabel.anchor = GridBagConstraints.EAST;
			gbc_lblNewLabel.insets = new Insets(20, 0, 20, 5);
			gbc_lblNewLabel.gridx = 1;
			gbc_lblNewLabel.gridy = 1;
			loginPanel.add(labelAccount, gbc_lblNewLabel);
			
			GridBagConstraints gbc_comboBox = new GridBagConstraints();
			gbc_comboBox.anchor = GridBagConstraints.WEST;
			gbc_comboBox.insets = new Insets(20, 0, 20, 0);
			gbc_comboBox.gridx = 2;
			gbc_comboBox.gridy = 1;
		    comboBox_Accounts.setMinimumSize(new Dimension(275, 20));
		    comboBox_Accounts.setPreferredSize(new Dimension(275, 20));
			loginPanel.add(comboBox_Accounts, gbc_comboBox);
			
			GridBagConstraints gbc_labelBlank5 = new GridBagConstraints();
			gbc_labelBlank5.anchor = GridBagConstraints.WEST;
			gbc_labelBlank5.insets = new Insets(0, 0, 5, 0);
			gbc_labelBlank5.gridx = 0;
			gbc_labelBlank5.gridy = 2;
			loginPanel.add(labelBlank5, gbc_labelBlank5);
			
			GridBagConstraints gbc_labelUsername = new GridBagConstraints();
			gbc_labelUsername.anchor = GridBagConstraints.EAST;
			gbc_labelUsername.insets = new Insets(0, 0, 5, 5);
			gbc_labelUsername.gridx = 1;
			gbc_labelUsername.gridy = 2;
			loginPanel.add(labelUsername, gbc_labelUsername); 
			
			GridBagConstraints gbc_textField_Uername = new GridBagConstraints();
			gbc_textField_Uername.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Uername.anchor = GridBagConstraints.NORTH;
			gbc_textField_Uername.insets = new Insets(0, 0, 0, 0);
			gbc_textField_Uername.gridx = 2;
			gbc_textField_Uername.gridy = 2;
			loginPanel.add(textField_Username, gbc_textField_Uername);
			
			GridBagConstraints gbc_labelBlank6 = new GridBagConstraints();
			gbc_labelBlank6.anchor = GridBagConstraints.WEST;
			gbc_labelBlank6.insets = new Insets(0, 0, 0, 0);
			gbc_labelBlank6.gridx = 3;
			gbc_labelBlank6.gridy = 2;
			loginPanel.add(labelBlank6, gbc_labelBlank6);
			
			GridBagConstraints gbc_labelBlank7 = new GridBagConstraints();
			gbc_labelBlank7.anchor = GridBagConstraints.WEST;
			gbc_labelBlank7.insets = new Insets(0, 0, 0, 0);
			gbc_labelBlank7.gridx = 0;
			gbc_labelBlank7.gridy = 3;
			loginPanel.add(labelBlank7, gbc_labelBlank7);
			
			GridBagConstraints gbc_labelPassword1 = new GridBagConstraints();
			gbc_labelPassword1.anchor = GridBagConstraints.EAST;
			gbc_labelPassword1.insets = new Insets(0, 0, 5, 5);
			gbc_labelPassword1.gridx = 1;
			gbc_labelPassword1.gridy = 3;
			loginPanel.add(labelPassword1, gbc_labelPassword1);
			
			GridBagConstraints gbc_textField_Password1 = new GridBagConstraints();
			gbc_textField_Password1.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Password1.anchor = GridBagConstraints.NORTH;
			gbc_textField_Password1.insets = new Insets(0, 0, 0, 0);
			gbc_textField_Password1.gridx = 2;
			gbc_textField_Password1.gridy = 3;
			loginPanel.add(passwordField_Password1, gbc_textField_Password1); 
			
			GridBagConstraints gbc_labelBlank8 = new GridBagConstraints();
			gbc_labelBlank8.anchor = GridBagConstraints.WEST;
			gbc_labelBlank8.insets = new Insets(0, 0, 0, 0);
			gbc_labelBlank8.gridx = 3;
			gbc_labelBlank8.gridy = 3;
			loginPanel.add(labelBlank8, gbc_labelBlank8);
			
			GridBagConstraints gbc_lblPassword2 = new GridBagConstraints();
			gbc_lblPassword2.anchor = GridBagConstraints.EAST;
			gbc_lblPassword2.insets = new Insets(0, 0, 5, 5);
			gbc_lblPassword2.gridx = 1;
			gbc_lblPassword2.gridy = 4;
			loginPanel.add(labelPassword2, gbc_lblPassword2);
			
			GridBagConstraints gbc_textField_Password2 = new GridBagConstraints();
			gbc_textField_Password2.fill = GridBagConstraints.HORIZONTAL;
			gbc_textField_Password2.anchor = GridBagConstraints.NORTH;
			gbc_textField_Password2.insets = new Insets(0, 0, 0, 0);
			gbc_textField_Password2.gridx = 2;
			gbc_textField_Password2.gridy = 4;
			loginPanel.add(passwordField_Password2, gbc_textField_Password2); 
			
			GridBagConstraints gbc_lblType = new GridBagConstraints();
			gbc_lblType.anchor = GridBagConstraints.EAST;
			gbc_lblType.insets = new Insets(0, 0, 5, 5);
			gbc_lblType.gridx = 1;
			gbc_lblType.gridy = 5;
			loginPanel.add(lblType, gbc_lblType);
			
			GridBagConstraints gbc_comboBox_Accounts = new GridBagConstraints();
			gbc_comboBox_Accounts.anchor = GridBagConstraints.WEST;
			gbc_comboBox_Accounts.insets = new Insets(0, 0, 0, 0);
			gbc_comboBox_Accounts.gridx = 2;
			gbc_comboBox_Accounts.gridy = 5;
		    comboBox_AccountTypes.setMinimumSize(new Dimension(275, 20));
		    comboBox_AccountTypes.setPreferredSize(new Dimension(275, 20));
			loginPanel.add(comboBox_AccountTypes, gbc_comboBox_Accounts);
			
			GridBagConstraints gbc_saveButton = new GridBagConstraints();
			gbc_saveButton.anchor = GridBagConstraints.NORTH;
			gbc_saveButton.insets = new Insets(20, 0, 0, 0);
			gbc_saveButton.gridx = 2;
			gbc_saveButton.gridy = 6;
			loginPanel.add(getOKPanel(), gbc_saveButton
					);

		 }
		return loginPanel;
	}

    
	private javax.swing.JButton getsaveButton() {
		if (saveButton == null) {
			saveButton = new javax.swing.JButton();
			saveButton.setSize(20, 20);
			saveButton.setText("  Save   ");
			saveButton.setHorizontalAlignment(SwingConstants.CENTER);
		    saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					System.out.println("SaveAccount Start");
					onTop(false);
					if(comboBox_Accounts.getSelectedItem().equals("telos")){return;}
					
					if (textField_Username.getText().equals("")  ||  passwordField_Password1.getText().equals("")  ||  passwordField_Password2.getText().equals("")){
						JOptionPane.showMessageDialog(null, "Fields are incomplete.");
						return;
					}
					
					password = passwordField_Password1.getText();
					confpassword = passwordField_Password2.getText();
			 		if ( !password.equals(confpassword.trim()) ) 
			 		{
			 			JOptionPane.showMessageDialog(null, "Password entries do not match"," ", JOptionPane.WARNING_MESSAGE);
			 			return;
			 		}

					Date date=new Date() ; 
			    	dateMilliseconds = date.getTime(); 
			    	
        			String user  = textField_Username.getText().trim();
		 			saveaccount = user + "," + password
		 					+ "," + atype.trim() + "," +  String.valueOf(dateMilliseconds) + "," + "1";
		 			
			 		//check for existing account and updated if requested
		 			boolean match = false;
					for (int i=0; i < arrayList_userData.size(); i++){
					    if(arrayList_userData.get(i).split(",")[0].equals(textField_Username.getText().trim())) {
						    
					    	int state = JOptionPane.showConfirmDialog(null, "Update existing account?");
						    if (state != 0){return;}
				 			arrayList_userData.set(i, saveaccount);
				 			match = true;
				 			System.out.println("Updating account to:: " + saveaccount); 
					    }   
					}

		 			if (!match){
		 				arrayList_userData.add(saveaccount);
		 				System.out.println("Adding new account:: " + saveaccount);
		 			}
		 			System.out.println("2");
	   				saveAccount();
	   				
	   				
					JOptionPane.showMessageDialog(null, "Account saved"," ", JOptionPane.INFORMATION_MESSAGE);
					onTop(true);
				}
			});
					
		}
		return saveButton;
	}
	
	private javax.swing.JButton getdeleteButton() {
		if (deleteButton == null) {
			deleteButton = new javax.swing.JButton();
			deleteButton.setSize(20, 20);
			deleteButton.setText("  Delete   ");
			deleteButton.setHorizontalAlignment(SwingConstants.CENTER);
		    deleteButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
    
					if(comboBox_Accounts.getSelectedItem().equals("telos")){return;}
					onTop(false);
				    int state = JOptionPane.showConfirmDialog(null, "Are you sure you want to permanently DELETE this account?");
				    onTop(true);
				    
				    if (state == 0){
					    for (int i=0; i < arrayList_userData.size(); i++){
					    	if (arrayList_userData.get(i).split(",")[0].equals(accountSelected)){
					    		arrayList_userData.remove(i);
					    		saveAccount();
					    		comboBox_Accounts.setSelectedIndex(0);
					    	}
					    }				    	
				    }
   
				}
			});
					
		}
		return deleteButton;
	}
	
	private javax.swing.JButton getcancelButton() {
		if (cancelButton == null) {
			cancelButton = new javax.swing.JButton();
			cancelButton.setSize(20, 20);
			cancelButton.setText("  Cancel   ");
			cancelButton.setHorizontalAlignment(SwingConstants.CENTER);
		    cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final java.awt.event.ActionEvent e) {
					textField_Username.setText("");
					passwordField_Password1.setText("");
					passwordField_Password2.setText("");
					comboBox_Accounts.setSelectedIndex(0);
					comboBox_AccountTypes.setSelectedIndex(0);
					onTop(false);
				    UserAccountWindow.this.setVisible(false);
				}
			});
		}
		return cancelButton;
	}
	
	
	public void saveAccount() {
		
		String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
		File f = new File(filename);
		try {
			final BufferedWriter bw = new BufferedWriter(new FileWriter(f));
			

			for (int i=0; i < arrayList_userData.size(); i++){
				String encrypted;
				encrypted = CryptoMessage.encrypt(arrayList_userData.get(i));
				arrayList_userData_Encrypted.add(encrypted);
			}
			
			for (int i=0; i < arrayList_userData.size(); i++){
			    bw.write(arrayList_userData_Encrypted.get(i)) ;
				bw.newLine();				
			}

			bw.close( );

			
		} catch (final FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (final IOException e1) {
			e1.printStackTrace();
		}

		// reset the screen values 
		textField_Username.setText("");
		passwordField_Password1.setText("");
		passwordField_Password2.setText("");
		comboBox_Accounts.setSelectedIndex(0);
		comboBox_AccountTypes.setSelectedIndex(0);
		
		loadAccount();
	}



	/**
	 * This method loads scheme data into holding list  	
	 * 	
	 * @return void 	
	 */
	@SuppressWarnings("unchecked")
	public void loadAccount() {
		
		arrayList_userData.clear();
		arrayList_userData_Encrypted.clear();
		comboBox_Accounts.removeAllItems();  comboBox_Accounts.addItem("Create New Account");
	    
		try { 
			String data = "";
			String filename = "C:/Program Files/TELOS/AutoPilot/Config/APASACCT.cfg" ;
			File f = new File(filename);
			input = new FileInputStream ( f );
			final BufferedReader bw = new BufferedReader(new FileReader(f));

		    while ((data = bw.readLine()) != null) {	
				
				System.out.println("UAW   -   " + data);
		    	  
		    	decrypted = CryptoMessage.decrypt(data);
		    	  
		    	System.out.println("UAW   -   " + decrypted);
		    	  
		    	arrayList_userData.add(decrypted);
				comboBox_Accounts.addItem(decrypted.split(",")[0]);

		   }
		    
		    comboBox_Accounts.setSelectedIndex(0);
		} 
		catch ( EOFException eof ) {
			try { 
				input.close();
				} catch ( IOException e ) {
				JOptionPane.showMessageDialog( this, 
						"Error Closing File" , 
						"Error", 
						JOptionPane.ERROR_MESSAGE );
				}
		}
		catch ( IOException e ) {
			JOptionPane.showMessageDialog( this, 
					"Error Opening File" , 
					"Error", 
					JOptionPane.ERROR_MESSAGE );
		}

		try { 
		input.close();
		} catch ( IOException e ) {
		JOptionPane.showMessageDialog( this, 
				"Error Closing File" , 
				"Error", 
				JOptionPane.ERROR_MESSAGE );
		}
	}
	
	private void onTop (boolean b){//APN0049
		this.setAlwaysOnTop(b);
	}
	private void vis (boolean b){
		this.setVisible(b);
	}
	
}
