package TelosV2Pkg;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import com.itextpdf.awt.geom.Rectangle;
import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.FontFactory;
import com.itextpdf.text.Image;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.Font.FontFamily;
import com.itextpdf.text.pdf.ColumnText;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfWriter;

public class VASReporter {
	public static String newline = System.getProperty("line.separator");
	public static String reportRaw = "C:\\Program Files\\Telos\\AutoPilot\\System\\reportRaw.pdf";
	public static String filePath_ReportCORDNA= "C:\\Program Files\\Telos\\AutoPilot\\Reports\\ReportsCORDNA\\";
	public static String filePath_ReportPK1= "C:\\Program Files\\Telos\\AutoPilot\\Reports\\ReportsPK\\";
	public static String output1;
	public static final String graphicFile = "C:\\Program Files\\Telos\\AutoPilot\\Graphics\\TelosLogo.png";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
	}
	
	public static String safeString(ArrayList<String> list, int index){
		String returnVal = "Error:00";
		
		if (index > (list.size()-1)){returnVal = "Error:OoB:" + index;}
		else if (list.get(index).equals(null)){returnVal = "Error:null";}
		else {returnVal = String.valueOf(list.get(index));}
		
		return returnVal;
	}
	
	public static void CORDNA01() {

		String RunID = VASengine.runID;  														//DateTimeRandom
		String RunID_ID = RunID.substring(RunID.lastIndexOf("_")+1);		//The Random 10 digiti ID
		String fileName_ReportCORDNA = "NormalizationReport_" + RunID_ID + ".pdf";
		String filePathName_ReportCORDNA = (filePath_ReportCORDNA + fileName_ReportCORDNA);

		output1 = fileName_ReportCORDNA;
		
		Document document = new Document(PageSize.LETTER.rotate());
		Font HVET_B_6 = new Font(FontFamily.HELVETICA, 6, Font.BOLDITALIC, new BaseColor(0, 0, 255));
			
		try {
			PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(reportRaw));
			//writer.setPageEvent(new HeaderAndFooter());
			document.open();

		    Paragraph paraHeader = new Paragraph(10);					//Create new paragraph for Header Info (line spacing 10)
		    paraHeader.setFont(HVET_B_6);
		    
			paraHeader.add(new Chunk("DNA Normalization Report                                                              " + RunID + newline));
			paraHeader.add(new Chunk(newline));
			paraHeader.add(new Chunk("Worklist                     " + VASengine.CORDNA_Worklist + newline));
			paraHeader.add(new Chunk("Venus RunID             " + APLOG.arrayLogLive[20][1] + newline));
			paraHeader.add(new Chunk("Target [ ] (ng/ul)        "  + VASengine.CORDNA_TargetConc + newline));
			paraHeader.add(new Chunk("Target Vol (ul)           "  + VASengine.CORDNA_TargetVol + newline));
			paraHeader.add(new Chunk(newline));
			paraHeader.add(new Chunk(newline));
			paraHeader.add(new Chunk("Concentration in ng/ul" + newline));
			paraHeader.add(new Chunk("Volume in ul" + newline));
			paraHeader.add(new Chunk(newline));
						
		    //Create Table
			PdfPTable table = new PdfPTable(4);
		    table.setWidthPercentage(50);
		    table.getDefaultCell().setBorder(0);
		    table.setHorizontalAlignment(0);
		    table.setHeaderRows(1);					//Places Header row on each page of .pdf
	
		    //Table Header
		    System.out.println("AP::REPORT::CORDNA01::CreateHeader");
		    Phrase h1 = new Phrase("Source ID",  HVET_B_6); table.addCell(h1);
		    Phrase h2 = new Phrase("Sample Concentration",  HVET_B_6); table.addCell(h2);
		    Phrase h3 = new Phrase("Sample Volume",  HVET_B_6);table.addCell(h3);
		    Phrase h4 = new Phrase("Diluent Volume",  HVET_B_6);table.addCell(h4);

		     for (int n=0; n<VASengine.arrayList_CORDNA_IDs.size(); n++){

		    	String ID; try{ID = safeString(VASengine.arrayList_CORDNA_IDs,n);} catch (Exception e) {ID = "Error";}
		    	String ConcS; try{ConcS = safeString(VASengine.arrayList_CORDNA_Conc,n);} catch (Exception e) {ConcS = "Error";}
		    	
		    	String VolS;
		    	String VolD;
		    	boolean fail = false;
		    	for (int r=0; r<VASengine.arrayList_CORDNA_TrackingRaw_Position.size(); r++){
		    		if(VASengine.arrayList_CORDNA_TrackingRaw_Position.get(r).equals(String.valueOf(n+1))){
		    			if (!VASengine.arrayList_CORDNA_TrackingRaw_Vol.get(r).equals(VASengine.CORDNA_TargetVol)){
		    				fail = true;
		    			}
		    		}
		    	}
		    	
		    	if (fail){
		    		VolS = "--";
		    		VolD = "--";
		    	}else{
					try {VolS = safeString(VASengine.arrayList_CORDNA_VolSource,n);} catch (Exception e) {VolS = "Error";}					
					try {VolD = safeString(VASengine.arrayList_CORDNA_VolDiluent,n);} catch (Exception e) {VolD = "Error";}			    		
		    	}
				
				
					
		    	Phrase p1 = new Phrase(ID,  HVET_B_6);								//ID
			    Phrase p2 = new Phrase(ConcS, HVET_B_6);							//ConcS
			    Phrase p3 = new Phrase(VolS, HVET_B_6);								//VolS
			    Phrase p4 = new Phrase(VolD, HVET_B_6);								//VolD

			     table.addCell(p1);
			     table.addCell(p2);
			     table.addCell(p3);
			     table.addCell(p4);
		        }

		    //Populate Document
			document.add(paraHeader);				        
		    document.add(table);   
		    
		    //Close Document
			document.close();
			
			//Create final report document with page numbers
			try {
				reportPages(filePathName_ReportCORDNA);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (DocumentException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}

	public static void PK1() {		//Dilution Series Report

		String RunID = VASengine.runID;  														//DateTimeRandom
		String RunID_ID = RunID.substring(RunID.lastIndexOf("_")+1);		//The Random 10 digiti ID
		String fileName_ReportPK2 = "PKReport_DilutionSummary_" + RunID_ID + ".pdf";
		String filePathName_ReportPK2 = (filePath_ReportPK1 + fileName_ReportPK2);
		Document document = new Document(PageSize.LETTER);
		Font HVET_B_6 = new Font(FontFamily.HELVETICA, 6, Font.BOLDITALIC, new BaseColor(0, 0, 255));
		Font HVET_B_6_Black = new Font(FontFamily.HELVETICA, 6, Font.BOLDITALIC, BaseColor.BLACK);
		String mrdStatus = "";
		String dilutionStatus = "";
		String preStatus = "";
		String assayStatus = "";
		BaseColor bColor;

		if (VASengine.PK_GoMRD.equals("1")){mrdStatus = "1:" + VASengine.PK_MRD_Read + " in " + VASengine.PK_MRD_VolTotal_Read + "ul";}							//APF0061
		if (VASengine.PK_GoDilution.equals("1")){dilutionStatus =   VASengine.PK_Multi_DilutionPlates+ " plates";}else{dilutionStatus = "N/A";}
		if (VASengine.PK_GoPreAssay.equals("1")){preStatus =  VASengine.PK_PreAssay_Vol_Read+ "ul";}else{preStatus = "N/A";}
		if (!VASengine.PK_GoMRD.equals("1") && VASengine.PK_GoPreAssay.equals("1") && !VASengine.PK_PreAssay_MRD.equals("1")){mrdStatus = "1:" + VASengine.PK_PreAssay_MRD + " in " + VASengine.PK_PreAssay_Vol_Read + "ul";}		//APF0061  
		if (VASengine.PK_GoAssay.equals("1")){assayStatus =  VASengine.PK_Assay_Vol_Read+ "ul";}else{assayStatus = "N/A";}

		ArrayList<String> arraylistDilutionOutput = new ArrayList<String>();
		
		try {
			PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(reportRaw));
			//writer.setPageEvent(new HeaderAndFooter());
			document.open();

			//Add Image
			try {

				Image img = Image.getInstance(graphicFile);
				img.scalePercent(15f, 15f);
				
				document.add(img);
				
			} catch (MalformedURLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			//Done Image
			
		    Paragraph paraHeader = new Paragraph(10);					//Create new paragraph for Header Info (line spacing 10)
		    paraHeader.setFont(HVET_B_6_Black);

		    paraHeader.add(new Chunk(newline));
			paraHeader.add(new Chunk("PK Report                Dilution Summary - " + RunID + newline));
			paraHeader.add(new Chunk(newline));
			paraHeader.add(new Chunk("Version                    " + TabWindow.APversion + newline));
			paraHeader.add(new Chunk("User                         " + TabWindow.security_userLoggedIn + newline));
			paraHeader.add(new Chunk("Worklist                   " + VASengine.PK_Worklist + newline));
			paraHeader.add(new Chunk("Venus RunID           " + APLOG.arrayLogLive[20][1] + newline));
			if (VASengine.PK_GoDilution.equals("1")){paraHeader.add(new Chunk("Units                        Dilution Series reported as Sample(ul)/Diluent(ul)") + newline);}
			paraHeader.add(new Chunk(newline));
			if (VASengine.PK_GoMRD.equals("1")){ paraHeader.add(new Chunk("MRD:                        " + mrdStatus + newline));}
			if (VASengine.PK_GoDilution.equals("1")){paraHeader.add(new Chunk("Dilutions (DP):        " + dilutionStatus + newline));}
			if (VASengine.PK_GoPreAssay.equals("1")){paraHeader.add(new Chunk("PreAssay (PA):       " + preStatus + newline));}
			if (!VASengine.PK_GoMRD.equals("1") && VASengine.PK_GoPreAssay.equals("1") && !VASengine.PK_PreAssay_MRD.equals("1")){ paraHeader.add(new Chunk("PreAssay MRD:      " + mrdStatus + newline));}
			if (VASengine.PK_GoAssay.equals("1")){paraHeader.add(new Chunk("Assay (A):               " + assayStatus + newline));}
			paraHeader.add(new Chunk(newline + newline));
						
		    //Create Table
			PdfPTable table = new PdfPTable(10);
		    table.setWidthPercentage(100);
		    table.getDefaultCell().setBorder(0);
		    table.setHorizontalAlignment(0);
		    table.setWidths(new int[]{1,4,1,1,1,1,2,2,2,1});
		    table.setHeaderRows(1);					//Places Header row on each page of .pdf
	
		    //Table Header
		    PdfPCell cH1 = new PdfPCell(new Phrase("Sample",  HVET_B_6));cH1.setBorder(2); cH1.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH1);
		    PdfPCell cH2 = new PdfPCell(new Phrase("Sample ID",  HVET_B_6));cH2.setBorder(2); cH2.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH2);
		    PdfPCell cH3 = new PdfPCell(new Phrase("DP Plate",  HVET_B_6));cH3.setBorder(2); cH3.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH3);
		    PdfPCell cH4 = new PdfPCell(new Phrase("DP Well",  HVET_B_6));cH4.setBorder(2); cH4.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH4);
		    PdfPCell cH5 = new PdfPCell(new Phrase("DP Vol(ul)",  HVET_B_6));cH5.setBorder(2); cH5.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH5);
		    PdfPCell cH6 = new PdfPCell(new Phrase("Final",  HVET_B_6));cH6.setBorder(2); cH6.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH6);
		    PdfPCell cH7 = new PdfPCell(new Phrase("Step 1",  HVET_B_6));cH7.setBorder(2); cH7.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH7);
		    PdfPCell cH8 = new PdfPCell(new Phrase("Step 2",  HVET_B_6));cH8.setBorder(2); cH8.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH8);
		    PdfPCell cH9 = new PdfPCell(new Phrase("Step 3",  HVET_B_6));cH9.setBorder(2); cH9.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH9);
		    PdfPCell cH10 = new PdfPCell(new Phrase("PA Well",  HVET_B_6));cH10.setBorder(2); cH10.setBackgroundColor(BaseColor.LIGHT_GRAY);table.addCell(cH10);


		    int sampleNumberCntr = 0;
		    int colorCntr = 0;
		    int y=0;
		    int chnCntr = 0;
		    String sampleNumber;
		    String sampleID;
		    String dilutionFinal;
		    String Plate = "";
		    String Well = "";
		    String preAssayWell = "";

		    for (int i = 0; i < VASengine.PK_StdCntrl_Unique_Total; i++){
		    	if (colorCntr == 0){bColor = new BaseColor(255,255,255); colorCntr = 1;
		    	}else{bColor = new BaseColor(204,229,255); colorCntr = 0;}
		    	
		    	sampleNumberCntr ++;
		    	sampleID = VASengine.arraylistPK_StdCntrls.get(i);
		    	sampleNumber = String.valueOf(sampleNumberCntr);
		    	
		    	if (VASengine.PK_GoPreAssay.equals("1")){
		    		preAssayWell = "";

		    		
	    			for (int z = 0; z < VASengine.PK_StdCntrl_ReadLine_Total; z++){
	    				System.out.println(VASengine.arraylistPK_SamplesIDAll.get(z)  +  "    -    "  +  sampleID);
	    				if (VASengine.arraylistPK_SamplesIDAll.get(z).equals(sampleID)){
	    					preAssayWell = preAssayWell + AlphaToNumeric.ToAlpha_WithZeros(VASengine.PK_PreAssay_StdCntr_DestinationSeq.split(",")[z]) + "/";
	    				}
	    			}
	    			preAssayWell = preAssayWell.substring(0, preAssayWell.length() -1);
	    			
	    			
		    	}else{preAssayWell = "-";}
		    	
			    PdfPCell c1 = new PdfPCell(new Phrase(sampleNumber,  HVET_B_6));c1.setBorder(0); c1.setBackgroundColor(bColor);table.addCell(c1);
			    PdfPCell c2 = new PdfPCell(new Phrase(sampleID,  HVET_B_6));c2.setBorder(0); c2.setBackgroundColor(bColor);table.addCell(c2);
			    PdfPCell c3 = new PdfPCell(new Phrase("-",  HVET_B_6));c3.setBorder(0); c3.setBackgroundColor(bColor);table.addCell(c3);
			    PdfPCell c4 = new PdfPCell(new Phrase("-",  HVET_B_6));c4.setBorder(0); c4.setBackgroundColor(bColor);table.addCell(c4);
			    PdfPCell c5 = new PdfPCell(new Phrase("-",  HVET_B_6));c5.setBorder(0); c5.setBackgroundColor(bColor);table.addCell(c5);
			    PdfPCell c6 = new PdfPCell(new Phrase("-",  HVET_B_6));c6.setBorder(0); c6.setBackgroundColor(bColor);table.addCell(c6);
			    PdfPCell c7 = new PdfPCell(new Phrase("-",  HVET_B_6));c7.setBorder(0); c7.setBackgroundColor(bColor);table.addCell(c7);
			    PdfPCell c8 = new PdfPCell(new Phrase("-",  HVET_B_6));c8.setBorder(0); c8.setBackgroundColor(bColor);table.addCell(c8);
			    PdfPCell c9 = new PdfPCell(new Phrase("-",  HVET_B_6));c9.setBorder(0); c9.setBackgroundColor(bColor);table.addCell(c9);
			    PdfPCell c10 = new PdfPCell(new Phrase(preAssayWell,  HVET_B_6));c10.setBorder(0); c10.setBackgroundColor(bColor);table.addCell(c10);
			    
		    }
		    
		    int cntr=0; int subVal;

		    for (int i = 0; i < VASengine.PK_WorklistUniqeSamples; i++){
		    	chnCntr ++;
		    	if (colorCntr == 0){bColor = new BaseColor(255,255,255); colorCntr = 1;
		    	}else{bColor = new BaseColor(204,229,255); colorCntr = 0;}
		    	
		    	arraylistDilutionOutput.clear();	    	
		    	sampleNumberCntr ++;
		    	sampleNumber = String.valueOf(sampleNumberCntr);
		    	sampleID = VASengine.arraylistPK_SamplesUnique.get(i);
		    	String Vol;
		    	if (VASengine.PK_GoDilution.equals("1")){
			    	 if (i<32){
			    		 Plate = "1";
			    		 Well = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf(i+65));
			    	 }else if (i<64){
			    		 Plate = "2";
			    		 Well = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf((i-32)+65));
			    	 }else{
			    		 Plate = "3";
			    		 Well = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf((i-64)+65));
			    	 }
			    	try {Vol = safeString(VASengine.arraylistPK_VolumeFinal_Total,i).split("\\.")[0];} catch (Exception e) {Vol = "Error";}
			    	dilutionFinal = VASengine.arraylistPK_DilutionFinal.get(i);
			    	//JOptionPane.showMessageDialog(null, VASengine.PK_Volume_DilutionSeries_Sample);
			    	
			    	cntr++;
			    	if (cntr < 9){subVal = 64;}
			    	else if (cntr < 17){subVal = 56;}
			    	else if (cntr < 25){subVal = 48;}
			    	else {subVal = 40;}
			    	
			    	if (cntr == 32){cntr = 0;}
			    	
			    	for (int x = 0; x <3; x++){
			    		String interWell = "";
			    		
			    		if (Integer.valueOf(dilutionFinal)<100){
			    			if (x == 0){
			    				interWell = Well + " / ";
			    			}
			    		}else if (Integer.valueOf(dilutionFinal)<10000){
			    			if (x == 0){
			    				interWell = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf(Integer.valueOf(AlphaToNumeric.ToNumeric_WithZeros(Well))-subVal)) + "/";
			    			}
			    			if (x == 1){
			    				interWell = Well + " / ";
			    			}
			    		}else{
			    			if (x == 0){
			    				interWell = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf(Integer.valueOf(AlphaToNumeric.ToNumeric_WithZeros(Well))-subVal)) + "/";
			    			}
			    			if (x == 1){
			    				interWell = AlphaToNumeric.ToAlpha_WithZeros(String.valueOf(Integer.valueOf(AlphaToNumeric.ToNumeric_WithZeros(Well))- (subVal-8))) + "/";
			    			}
			    			if (x == 2){
			    				interWell = Well + " / ";
			    			}
			    		}
			    		
			    		try {
			    			String val1 = VASengine.PK_Volume_DilutionSeries_Sample.split(",")[i+(8*x)+y];	//removed this split to display all digits.....split("\\.")[0]
			    			String val2 = VASengine.PK_Volume_DilutionSeries_Diluent.split(",")[i+(8*x)+y];	//removed this split to display all digits.....split("\\.")[0]

			    			if (!val1.contains(".")){val1 = val1 + ".0";}
			    			if (!val2.contains(".")){val2 = val2 + ".0";}

			    			arraylistDilutionOutput.add(interWell + val1 + " / " + val2);		
						} catch (Exception e) {
							e.printStackTrace();
							arraylistDilutionOutput.add("0");
						}
			    	}
			    	if (chnCntr==8){chnCntr = 0; y+=16;}
		    	}else{
		    		Plate = "-";
		    		Well = "-";
		    		Vol = "-";
		    		dilutionFinal = "-";
		    	}
		    	
			    PdfPCell c1 = new PdfPCell(new Phrase(sampleNumber,  HVET_B_6));c1.setBorder(0); c1.setBackgroundColor(bColor);table.addCell(c1);
			    PdfPCell c2 = new PdfPCell(new Phrase(sampleID,  HVET_B_6));c2.setBorder(0); c2.setBackgroundColor(bColor);table.addCell(c2);
			    
			    if (VASengine.PK_GoDilution.equals("1")){
				    PdfPCell c3 = new PdfPCell(new Phrase(Plate,  HVET_B_6));c3.setBorder(0); c3.setBackgroundColor(bColor);table.addCell(c3);
				    PdfPCell c4 = new PdfPCell(new Phrase(Well,  HVET_B_6));c4.setBorder(0); c4.setBackgroundColor(bColor);table.addCell(c4);
				    PdfPCell c5 = new PdfPCell(new Phrase(Vol,  HVET_B_6));c5.setBorder(0); c5.setBackgroundColor(bColor);table.addCell(c5);
				    PdfPCell c6 = new PdfPCell(new Phrase("1:" + dilutionFinal,  HVET_B_6));c6.setBorder(0); c6.setBackgroundColor(bColor);table.addCell(c6);
				    PdfPCell c7 = new PdfPCell(new Phrase(arraylistDilutionOutput.get(0),  HVET_B_6));c7.setBorder(0); c7.setBackgroundColor(bColor);table.addCell(c7);
				    PdfPCell c8 = new PdfPCell(new Phrase(arraylistDilutionOutput.get(1),  HVET_B_6));c8.setBorder(0); c8.setBackgroundColor(bColor);table.addCell(c8);
				    PdfPCell c9 = new PdfPCell(new Phrase(arraylistDilutionOutput.get(2),  HVET_B_6));c9.setBorder(0); c9.setBackgroundColor(bColor);table.addCell(c9);	
			    }else{
				    PdfPCell c3 = new PdfPCell(new Phrase("-",  HVET_B_6));c3.setBorder(0); c3.setBackgroundColor(bColor);table.addCell(c3);
				    PdfPCell c4 = new PdfPCell(new Phrase("-",  HVET_B_6));c4.setBorder(0); c4.setBackgroundColor(bColor);table.addCell(c4);
				    PdfPCell c5 = new PdfPCell(new Phrase("-",  HVET_B_6));c5.setBorder(0); c5.setBackgroundColor(bColor);table.addCell(c5);
				    PdfPCell c6 = new PdfPCell(new Phrase("-" + dilutionFinal,  HVET_B_6));c6.setBorder(0); c6.setBackgroundColor(bColor);table.addCell(c6);
				    PdfPCell c7 = new PdfPCell(new Phrase("-",  HVET_B_6));c7.setBorder(0); c7.setBackgroundColor(bColor);table.addCell(c7);
				    PdfPCell c8 = new PdfPCell(new Phrase("-",  HVET_B_6));c8.setBorder(0); c8.setBackgroundColor(bColor);table.addCell(c8);
				    PdfPCell c9 = new PdfPCell(new Phrase("-",  HVET_B_6));c9.setBorder(0); c9.setBackgroundColor(bColor);table.addCell(c9);	
			    }
			    
			    
			    System.out.println("========================================");
			    System.out.println(VASengine.PK_StdCntrl_ReadLine_Total);
			    System.out.println(VASengine.arraylistPK_SamplesIDAll.size());
			    System.out.println(preAssayWell);
			    System.out.println("========================================");
			    
		    	if (VASengine.PK_GoPreAssay.equals("1")){
		    		System.out.println("IF-----------");
		    		preAssayWell = "";
	    			for (int z = VASengine.PK_StdCntrl_ReadLine_Total; z < VASengine.arraylistPK_SamplesIDAll.size(); z++){
	    				System.out.println(VASengine.arraylistPK_SamplesIDAll.get(z)  +  "    -    "  +  sampleID);
	    				if (VASengine.arraylistPK_SamplesIDAll.get(z).equals(sampleID)){
	    					preAssayWell = preAssayWell + AlphaToNumeric.ToAlpha_WithZeros(VASengine.PK_PreAssay_DestinationSeq.split(",")[z-VASengine.PK_StdCntrl_ReadLine_Total]) + "/";
	    				}
	    			}
	    			preAssayWell = preAssayWell.substring(0, preAssayWell.length() -1);
	    			
		    	}else{preAssayWell = "-";}
			    PdfPCell c10 = new PdfPCell(new Phrase(preAssayWell,  HVET_B_6));c10.setBorder(0); c10.setBackgroundColor(bColor);table.addCell(c10);   
		    }

		    //Populate Document
			document.add(paraHeader);				        
		    document.add(table);   
		    
		    //Close Document
			document.close();
			
			//Create final report document with page numbers
			try {
				reportPages(filePathName_ReportPK2);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (DocumentException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	

	public static void reportPages(String RESULT) throws DocumentException, IOException {
		/** The resulting PDF file. */
//	    String RESULT = "C:\\Program Files\\Telos\\AutoPilot\\Reports\\ReportsSummary\\stamped.pdf";
	 
	        try {
				// step 1
				Document document = new Document();
				// step 2
				PdfCopy copy = new PdfCopy(document, new FileOutputStream(RESULT));
				// step 3
				document.open();
				// step 4
				// reader for document 1
				PdfReader reader1 = new PdfReader(reportRaw);
				int n1 = reader1.getNumberOfPages();
				
				// initializations
				PdfImportedPage page;
				PdfCopy.PageStamp stamp;
				// Loop over the pages of document 1
				for (int i = 0; i < n1; ) {
				    page = copy.getImportedPage(reader1, ++i);
				    stamp = copy.createPageStamp(page);
				    // add page numbers
				    ColumnText.showTextAligned(
				            stamp.getUnderContent(), Element.ALIGN_CENTER,
				            new Phrase(String.format("page %d of %d", i, n1)),
				            297.5f, 28, 0);
				    stamp.alterContents();
				    copy.addPage(page);
				}

				document.close();
				reader1.close();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				JOptionPane.showMessageDialog(null, "Failed to create final report " + RESULT + "\n\n" + e);

			}
	}
	
}
